structure AtkTextRange :>
  ATK_TEXT_RANGE
    where type t = AtkTextRangeRecord.t
    where type text_rectangle_t = AtkTextRectangleRecord.t =
  struct
    val getType_ = _import "atk_text_range_get_type" : unit -> GObjectType.FFI.val_;
    val bounds'Offset_ = _import "giraffe_atk_text_range_bounds_offset" : unit -> GSize.FFI.val_;
    val startOffset'Offset_ = _import "giraffe_atk_text_range_start_offset_offset" : unit -> GSize.FFI.val_;
    val endOffset'Offset_ = _import "giraffe_atk_text_range_end_offset_offset" : unit -> GSize.FFI.val_;
    val content'Offset_ = _import "giraffe_atk_text_range_content_offset" : unit -> GSize.FFI.val_;
    type t = AtkTextRangeRecord.t
    type text_rectangle_t = AtkTextRectangleRecord.t
    structure BoundsField =
      Field(
        structure Container = AtkTextRangeRecord
        structure FieldType = ValueFieldType(AtkTextRectangleRecord)
        val offset = (I ---> GSize.FFI.fromVal) bounds'Offset_
      )
    structure StartOffsetField =
      Field(
        structure Container = AtkTextRangeRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) startOffset'Offset_
      )
    structure EndOffsetField =
      Field(
        structure Container = AtkTextRangeRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) endOffset'Offset_
      )
    structure ContentField =
      Field(
        structure Container = AtkTextRangeRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) content'Offset_
      )
    val bounds =
      {
        get = fn x => BoundsField.get x,
        set = fn x => BoundsField.set x
      }
    val startOffset =
      {
        get = fn x => StartOffsetField.get x,
        set = fn x => StartOffsetField.set x
      }
    val endOffset =
      {
        get = fn x => EndOffsetField.get x,
        set = fn x => EndOffsetField.set x
      }
    val content =
      {
        get = fn x => ContentField.get x,
        set = fn x => ContentField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
  end
