structure Atk : ATK =
  struct
    local
      open PolyMLFFI
    in
      val focusTrackerNotify_ = call (getSymbol "atk_focus_tracker_notify") (AtkObjectClass.PolyML.cPtr --> cVoid)
      val getBinaryAge_ = call (getSymbol "atk_get_binary_age") (cVoid --> GUInt.PolyML.cVal)
      val getDefaultRegistry_ = call (getSymbol "atk_get_default_registry") (cVoid --> AtkRegistryClass.PolyML.cPtr)
      val getFocusObject_ = call (getSymbol "atk_get_focus_object") (cVoid --> AtkObjectClass.PolyML.cPtr)
      val getInterfaceAge_ = call (getSymbol "atk_get_interface_age") (cVoid --> GUInt.PolyML.cVal)
      val getMajorVersion_ = call (getSymbol "atk_get_major_version") (cVoid --> GUInt.PolyML.cVal)
      val getMicroVersion_ = call (getSymbol "atk_get_micro_version") (cVoid --> GUInt.PolyML.cVal)
      val getMinorVersion_ = call (getSymbol "atk_get_minor_version") (cVoid --> GUInt.PolyML.cVal)
      val getRoot_ = call (getSymbol "atk_get_root") (cVoid --> AtkObjectClass.PolyML.cPtr)
      val getToolkitName_ = call (getSymbol "atk_get_toolkit_name") (cVoid --> Utf8.PolyML.cOutPtr)
      val getToolkitVersion_ = call (getSymbol "atk_get_toolkit_version") (cVoid --> Utf8.PolyML.cOutPtr)
      val getVersion_ = call (getSymbol "atk_get_version") (cVoid --> Utf8.PolyML.cOutPtr)
      val removeFocusTracker_ = call (getSymbol "atk_remove_focus_tracker") (GUInt.PolyML.cVal --> cVoid)
      val removeGlobalEventListener_ = call (getSymbol "atk_remove_global_event_listener") (GUInt.PolyML.cVal --> cVoid)
      val removeKeyEventListener_ = call (getSymbol "atk_remove_key_event_listener") (GUInt.PolyML.cVal --> cVoid)
    end
    structure State = AtkState
    structure ActionClass = AtkActionClass
    structure ComponentClass = AtkComponentClass
    structure CoordType = AtkCoordType
    structure DocumentClass = AtkDocumentClass
    structure EditableTextClass = AtkEditableTextClass
    structure HyperlinkClass = AtkHyperlinkClass
    structure HyperlinkImplClass = AtkHyperlinkImplClass
    structure HyperlinkStateFlags = AtkHyperlinkStateFlags
    structure HypertextClass = AtkHypertextClass
    structure ImageClass = AtkImageClass
    structure ImplementorIfaceClass = AtkImplementorIfaceClass
    structure KeyEventType = AtkKeyEventType
    structure Layer = AtkLayer
    structure MiscClass = AtkMiscClass
    structure ObjectClass = AtkObjectClass
    structure ObjectFactoryClass = AtkObjectFactoryClass
    structure RangeRecord = AtkRangeRecord
    structure RectangleRecord = AtkRectangleRecord
    structure RegistryClass = AtkRegistryClass
    structure RelationClass = AtkRelationClass
    structure RelationSetClass = AtkRelationSetClass
    structure RelationType = AtkRelationType
    structure Role = AtkRole
    structure SelectionClass = AtkSelectionClass
    structure StateSetClass = AtkStateSetClass
    structure StateType = AtkStateType
    structure StreamableContentClass = AtkStreamableContentClass
    structure TableClass = AtkTableClass
    structure TableCellClass = AtkTableCellClass
    structure TextClass = AtkTextClass
    structure TextAttribute = AtkTextAttribute
    structure TextBoundary = AtkTextBoundary
    structure TextClipType = AtkTextClipType
    structure TextGranularity = AtkTextGranularity
    structure TextRangeRecord = AtkTextRangeRecord
    structure TextRectangleRecord = AtkTextRectangleRecord
    structure UtilClass = AtkUtilClass
    structure ValueClass = AtkValueClass
    structure ValueType = AtkValueType
    structure WindowClass = AtkWindowClass
    structure Action = AtkAction
    structure Component = AtkComponent
    structure Document = AtkDocument
    structure EditableText = AtkEditableText
    structure GObjectAccessibleClass = AtkGObjectAccessibleClass
    structure Hyperlink = AtkHyperlink
    structure HyperlinkImpl = AtkHyperlinkImpl
    structure Hypertext = AtkHypertext
    structure Image = AtkImage
    structure ImplementorIface = AtkImplementorIface
    structure Misc = AtkMisc
    structure NoOpObjectClass = AtkNoOpObjectClass
    structure NoOpObjectFactoryClass = AtkNoOpObjectFactoryClass
    structure Object = AtkObject
    structure ObjectFactory = AtkObjectFactory
    structure PlugClass = AtkPlugClass
    structure Range = AtkRange
    structure Rectangle = AtkRectangle
    structure Registry = AtkRegistry
    structure ObjectClassCPtrArrayN = AtkObjectClassCPtrArrayN
    structure RelationSet = AtkRelationSet
    structure Selection = AtkSelection
    structure SocketClass = AtkSocketClass
    structure StateTypeCArrayN = AtkStateTypeCArrayN
    structure StreamableContent = AtkStreamableContent
    structure Table = AtkTable
    structure TableCell = AtkTableCell
    structure TextRangeRecordCPtrArray = AtkTextRangeRecordCPtrArray
    structure TextRange = AtkTextRange
    structure TextRectangle = AtkTextRectangle
    structure Util = AtkUtil
    structure Value = AtkValue
    structure Window = AtkWindow
    structure GObjectAccessible = AtkGObjectAccessible
    structure NoOpObject = AtkNoOpObject
    structure NoOpObjectFactory = AtkNoOpObjectFactory
    structure Plug = AtkPlug
    structure Relation = AtkRelation
    structure Socket = AtkSocket
    structure StateSet = AtkStateSet
    structure Text = AtkText
    val BINARY_AGE = 22210
    val INTERFACE_AGE = 1
    val MAJOR_VERSION = 2
    val MICRO_VERSION = 0
    val MINOR_VERSION = 22
    val VERSION_MIN_REQUIRED = 2
    fun focusTrackerNotify object = (AtkObjectClass.FFI.withPtr false ---> I) focusTrackerNotify_ object
    fun getBinaryAge () = (I ---> GUInt.FFI.fromVal) getBinaryAge_ ()
    fun getDefaultRegistry () = (I ---> AtkRegistryClass.FFI.fromPtr true) getDefaultRegistry_ ()
    fun getFocusObject () = (I ---> AtkObjectClass.FFI.fromPtr false) getFocusObject_ ()
    fun getInterfaceAge () = (I ---> GUInt.FFI.fromVal) getInterfaceAge_ ()
    fun getMajorVersion () = (I ---> GUInt.FFI.fromVal) getMajorVersion_ ()
    fun getMicroVersion () = (I ---> GUInt.FFI.fromVal) getMicroVersion_ ()
    fun getMinorVersion () = (I ---> GUInt.FFI.fromVal) getMinorVersion_ ()
    fun getRoot () = (I ---> AtkObjectClass.FFI.fromPtr false) getRoot_ ()
    fun getToolkitName () = (I ---> Utf8.FFI.fromPtr 0) getToolkitName_ ()
    fun getToolkitVersion () = (I ---> Utf8.FFI.fromPtr 0) getToolkitVersion_ ()
    fun getVersion () = (I ---> Utf8.FFI.fromPtr 0) getVersion_ ()
    fun removeFocusTracker trackerId = (GUInt.FFI.withVal ---> I) removeFocusTracker_ trackerId
    fun removeGlobalEventListener listenerId = (GUInt.FFI.withVal ---> I) removeGlobalEventListener_ listenerId
    fun removeKeyEventListener listenerId = (GUInt.FFI.withVal ---> I) removeKeyEventListener_ listenerId
  end
