structure AtkTextRange :>
  ATK_TEXT_RANGE
    where type t = AtkTextRangeRecord.t
    where type text_rectangle_t = AtkTextRectangleRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "atk_text_range_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val bounds'Offset_ = call (getSymbol "giraffe_atk_text_range_bounds_offset") (cVoid --> GSize.PolyML.cVal)
      val startOffset'Offset_ = call (getSymbol "giraffe_atk_text_range_start_offset_offset") (cVoid --> GSize.PolyML.cVal)
      val endOffset'Offset_ = call (getSymbol "giraffe_atk_text_range_end_offset_offset") (cVoid --> GSize.PolyML.cVal)
      val content'Offset_ = call (getSymbol "giraffe_atk_text_range_content_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = AtkTextRangeRecord.t
    type text_rectangle_t = AtkTextRectangleRecord.t
    structure BoundsField =
      Field(
        structure Container = AtkTextRangeRecord
        structure FieldType = ValueFieldType(AtkTextRectangleRecord)
        val offset = (I ---> GSize.FFI.fromVal) bounds'Offset_
      )
    structure StartOffsetField =
      Field(
        structure Container = AtkTextRangeRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) startOffset'Offset_
      )
    structure EndOffsetField =
      Field(
        structure Container = AtkTextRangeRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) endOffset'Offset_
      )
    structure ContentField =
      Field(
        structure Container = AtkTextRangeRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) content'Offset_
      )
    val bounds =
      {
        get = fn x => BoundsField.get x,
        set = fn x => BoundsField.set x
      }
    val startOffset =
      {
        get = fn x => StartOffsetField.get x,
        set = fn x => StartOffsetField.set x
      }
    val endOffset =
      {
        get = fn x => EndOffsetField.get x,
        set = fn x => EndOffsetField.set x
      }
    val content =
      {
        get = fn x => ContentField.get x,
        set = fn x => ContentField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
  end
