signature GDK_EVENT_CROSSING =
  sig
    type t
    type event_type_t
    type 'a window_class
    type crossing_mode_t
    type notify_type_t
    type modifier_type_t
    val type' :
      {
        get : t -> event_type_t,
        set :
          event_type_t
           -> t
           -> unit
      }
    val window :
      {
        get : t -> base window_class option,
        set :
          'a window_class option
           -> t
           -> unit
      }
    val sendEvent :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val subwindow :
      {
        get : t -> base window_class option,
        set :
          'a window_class option
           -> t
           -> unit
      }
    val time :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val x :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val y :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val xRoot :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val yRoot :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val mode :
      {
        get : t -> crossing_mode_t,
        set :
          crossing_mode_t
           -> t
           -> unit
      }
    val detail :
      {
        get : t -> notify_type_t,
        set :
          notify_type_t
           -> t
           -> unit
      }
    val focus :
      {
        get : t -> bool,
        set :
          bool
           -> t
           -> unit
      }
    val state :
      {
        get : t -> modifier_type_t,
        set :
          modifier_type_t
           -> t
           -> unit
      }
  end
