signature GDK_EVENT_SCROLL =
  sig
    type t
    type event_type_t
    type 'a window_class
    type modifier_type_t
    type scroll_direction_t
    type 'a device_class
    val type' :
      {
        get : t -> event_type_t,
        set :
          event_type_t
           -> t
           -> unit
      }
    val window :
      {
        get : t -> base window_class option,
        set :
          'a window_class option
           -> t
           -> unit
      }
    val sendEvent :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val time :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val x :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val y :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val state :
      {
        get : t -> modifier_type_t,
        set :
          modifier_type_t
           -> t
           -> unit
      }
    val direction :
      {
        get : t -> scroll_direction_t,
        set :
          scroll_direction_t
           -> t
           -> unit
      }
    val device :
      {
        get : t -> base device_class option,
        set :
          'a device_class option
           -> t
           -> unit
      }
    val xRoot :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val yRoot :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val deltaX :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val deltaY :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
  end
