signature GDK_GEOMETRY =
  sig
    type t
    type gravity_t
    val minWidth :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val minHeight :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val maxWidth :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val maxHeight :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val baseWidth :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val baseHeight :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val widthInc :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val heightInc :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val minAspect :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val maxAspect :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val winGravity :
      {
        get : t -> gravity_t,
        set :
          gravity_t
           -> t
           -> unit
      }
    val new :
      {
        minWidth : LargeInt.int,
        minHeight : LargeInt.int,
        maxWidth : LargeInt.int,
        maxHeight : LargeInt.int,
        baseWidth : LargeInt.int,
        baseHeight : LargeInt.int,
        widthInc : LargeInt.int,
        heightInc : LargeInt.int,
        minAspect : real,
        maxAspect : real,
        winGravity : gravity_t
      }
       -> t
  end
