structure GdkColor :>
  GDK_COLOR
    where type t = GdkColorRecord.t =
  struct
    val getType_ = _import "gdk_color_get_type" : unit -> GObjectType.FFI.val_;
    val copy_ = _import "gdk_color_copy" : GdkColorRecord.FFI.non_opt GdkColorRecord.FFI.p -> GdkColorRecord.FFI.non_opt GdkColorRecord.FFI.p;
    val equal_ = fn x1 & x2 => (_import "gdk_color_equal" : GdkColorRecord.FFI.non_opt GdkColorRecord.FFI.p * GdkColorRecord.FFI.non_opt GdkColorRecord.FFI.p -> GBool.FFI.val_;) (x1, x2)
    val hash_ = _import "gdk_color_hash" : GdkColorRecord.FFI.non_opt GdkColorRecord.FFI.p -> GUInt.FFI.val_;
    val toString_ = _import "gdk_color_to_string" : GdkColorRecord.FFI.non_opt GdkColorRecord.FFI.p -> Utf8.FFI.non_opt Utf8.FFI.out_p;
    val parse_ =
      fn
        (x1, x2) & x3 =>
          (
            _import "mlton_gdk_color_parse" :
              Utf8.MLton.p1
               * Utf8.FFI.non_opt Utf8.MLton.p2
               * GdkColorRecord.FFI.non_opt GdkColorRecord.FFI.p
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3
            )
    val pixel'Offset_ = _import "giraffe_gdk_color_pixel_offset" : unit -> GSize.FFI.val_;
    val red'Offset_ = _import "giraffe_gdk_color_red_offset" : unit -> GSize.FFI.val_;
    val green'Offset_ = _import "giraffe_gdk_color_green_offset" : unit -> GSize.FFI.val_;
    val blue'Offset_ = _import "giraffe_gdk_color_blue_offset" : unit -> GSize.FFI.val_;
    type t = GdkColorRecord.t
    structure PixelField =
      Field(
        structure Container = GdkColorRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) pixel'Offset_
      )
    structure RedField =
      Field(
        structure Container = GdkColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) red'Offset_
      )
    structure GreenField =
      Field(
        structure Container = GdkColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) green'Offset_
      )
    structure BlueField =
      Field(
        structure Container = GdkColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) blue'Offset_
      )
    val pixel =
      {
        get = fn x => PixelField.get x,
        set = fn x => PixelField.set x
      }
    val red =
      {
        get = fn x => RedField.get x,
        set = fn x => RedField.set x
      }
    val green =
      {
        get = fn x => GreenField.get x,
        set = fn x => GreenField.set x
      }
    val blue =
      {
        get = fn x => BlueField.get x,
        set = fn x => BlueField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new
      {
        pixel,
        red,
        green,
        blue
      } =
      let
        fun init_ p =
          (
            PixelField.C.set pixel p;
            RedField.C.set red p;
            GreenField.C.set green p;
            BlueField.C.set blue p;
            ()
          )
        val retVal & () = (GdkColorRecord.FFI.withNewPtr ---> GdkColorRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
    fun copy self = (GdkColorRecord.FFI.withPtr false ---> GdkColorRecord.FFI.fromPtr true) copy_ self
    fun equal self colorb = (GdkColorRecord.FFI.withPtr false &&&> GdkColorRecord.FFI.withPtr false ---> GBool.FFI.fromVal) equal_ (self & colorb)
    fun hash self = (GdkColorRecord.FFI.withPtr false ---> GUInt.FFI.fromVal) hash_ self
    fun toString self = (GdkColorRecord.FFI.withPtr false ---> Utf8.FFI.fromPtr ~1) toString_ self
    fun parse spec =
      let
        val color & retVal = (Utf8.FFI.withPtr 0 &&&> GdkColorRecord.FFI.withNewPtr ---> GdkColorRecord.FFI.fromPtr true && GBool.FFI.fromVal) parse_ (spec & ())
      in
        if retVal then SOME color else NONE
      end
  end
