structure GdkEventProperty :>
  GDK_EVENT_PROPERTY
    where type t = GdkEventPropertyRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type atom_t = GdkAtomRecord.t
    where type property_state_t = GdkPropertyState.t =
  struct
    val type'Offset_ = _import "giraffe_gdk_event_property_type_offset" : unit -> GSize.FFI.val_;
    val window'Offset_ = _import "giraffe_gdk_event_property_window_offset" : unit -> GSize.FFI.val_;
    val sendEvent'Offset_ = _import "giraffe_gdk_event_property_send_event_offset" : unit -> GSize.FFI.val_;
    val atom'Offset_ = _import "giraffe_gdk_event_property_atom_offset" : unit -> GSize.FFI.val_;
    val time'Offset_ = _import "giraffe_gdk_event_property_time_offset" : unit -> GSize.FFI.val_;
    val state'Offset_ = _import "giraffe_gdk_event_property_state_offset" : unit -> GSize.FFI.val_;
    type t = GdkEventPropertyRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type atom_t = GdkAtomRecord.t
    type property_state_t = GdkPropertyState.t
    structure TypeField =
      Field(
        structure Container = GdkEventPropertyRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventPropertyRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventPropertyRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure AtomField =
      Field(
        structure Container = GdkEventPropertyRecord
        structure FieldType = OptPointerFieldType(GdkAtomRecord)
        val offset = (I ---> GSize.FFI.fromVal) atom'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventPropertyRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventPropertyRecord
        structure FieldType = ValueFieldType(GdkPropertyState)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val atom =
      {
        get = fn x => AtomField.get x,
        set = fn x => AtomField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
  end
