structure GdkEventTouch :>
  GDK_EVENT_TOUCH
    where type t = GdkEventTouchRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type modifier_type_t = GdkModifierType.t
    where type event_sequence_t = GdkEventSequenceRecord.t
    where type 'a device_class = 'a GdkDeviceClass.class =
  struct
    val type'Offset_ = _import "giraffe_gdk_event_touch_type_offset" : unit -> GSize.FFI.val_;
    val window'Offset_ = _import "giraffe_gdk_event_touch_window_offset" : unit -> GSize.FFI.val_;
    val sendEvent'Offset_ = _import "giraffe_gdk_event_touch_send_event_offset" : unit -> GSize.FFI.val_;
    val time'Offset_ = _import "giraffe_gdk_event_touch_time_offset" : unit -> GSize.FFI.val_;
    val x'Offset_ = _import "giraffe_gdk_event_touch_x_offset" : unit -> GSize.FFI.val_;
    val y'Offset_ = _import "giraffe_gdk_event_touch_y_offset" : unit -> GSize.FFI.val_;
    val state'Offset_ = _import "giraffe_gdk_event_touch_state_offset" : unit -> GSize.FFI.val_;
    val sequence'Offset_ = _import "giraffe_gdk_event_touch_sequence_offset" : unit -> GSize.FFI.val_;
    val emulatingPointer'Offset_ = _import "giraffe_gdk_event_touch_emulating_pointer_offset" : unit -> GSize.FFI.val_;
    val device'Offset_ = _import "giraffe_gdk_event_touch_device_offset" : unit -> GSize.FFI.val_;
    val xRoot'Offset_ = _import "giraffe_gdk_event_touch_x_root_offset" : unit -> GSize.FFI.val_;
    val yRoot'Offset_ = _import "giraffe_gdk_event_touch_y_root_offset" : unit -> GSize.FFI.val_;
    type t = GdkEventTouchRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type modifier_type_t = GdkModifierType.t
    type event_sequence_t = GdkEventSequenceRecord.t
    type 'a device_class = 'a GdkDeviceClass.class
    structure TypeField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure XField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GdkModifierType)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    structure SequenceField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = OptPointerFieldType(GdkEventSequenceRecord)
        val offset = (I ---> GSize.FFI.fromVal) sequence'Offset_
      )
    structure EmulatingPointerField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GBool)
        val offset = (I ---> GSize.FFI.fromVal) emulatingPointer'Offset_
      )
    structure DeviceField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = OptPointerFieldType(GdkDeviceClass)
        val offset = (I ---> GSize.FFI.fromVal) device'Offset_
      )
    structure XRootField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) xRoot'Offset_
      )
    structure YRootField =
      Field(
        structure Container = GdkEventTouchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) yRoot'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
    val sequence =
      {
        get = fn x => SequenceField.get x,
        set = fn x => SequenceField.set x
      }
    val emulatingPointer =
      {
        get = fn x => EmulatingPointerField.get x,
        set = fn x => EmulatingPointerField.set x
      }
    val device =
      {
        get = fn x => DeviceField.get x,
        set = fn x => DeviceField.set (Option.map GdkDeviceClass.toBase x)
      }
    val xRoot =
      {
        get = fn x => XRootField.get x,
        set = fn x => XRootField.set x
      }
    val yRoot =
      {
        get = fn x => YRootField.get x,
        set = fn x => YRootField.set x
      }
  end
