structure GdkEventTouchpadPinch :>
  GDK_EVENT_TOUCHPAD_PINCH
    where type t = GdkEventTouchpadPinchRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type touchpad_gesture_phase_t = GdkTouchpadGesturePhase.t
    where type modifier_type_t = GdkModifierType.t =
  struct
    val type'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_type_offset" : unit -> GSize.FFI.val_;
    val window'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_window_offset" : unit -> GSize.FFI.val_;
    val sendEvent'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_send_event_offset" : unit -> GSize.FFI.val_;
    val phase'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_phase_offset" : unit -> GSize.FFI.val_;
    val nFingers'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_n_fingers_offset" : unit -> GSize.FFI.val_;
    val time'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_time_offset" : unit -> GSize.FFI.val_;
    val x'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_x_offset" : unit -> GSize.FFI.val_;
    val y'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_y_offset" : unit -> GSize.FFI.val_;
    val dx'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_dx_offset" : unit -> GSize.FFI.val_;
    val dy'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_dy_offset" : unit -> GSize.FFI.val_;
    val angleDelta'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_angle_delta_offset" : unit -> GSize.FFI.val_;
    val scale'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_scale_offset" : unit -> GSize.FFI.val_;
    val xRoot'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_x_root_offset" : unit -> GSize.FFI.val_;
    val yRoot'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_y_root_offset" : unit -> GSize.FFI.val_;
    val state'Offset_ = _import "giraffe_gdk_event_touchpad_pinch_state_offset" : unit -> GSize.FFI.val_;
    type t = GdkEventTouchpadPinchRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type touchpad_gesture_phase_t = GdkTouchpadGesturePhase.t
    type modifier_type_t = GdkModifierType.t
    structure TypeField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure PhaseField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GdkTouchpadGesturePhase)
        val offset = (I ---> GSize.FFI.fromVal) phase'Offset_
      )
    structure NFingersField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) nFingers'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure XField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure DxField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) dx'Offset_
      )
    structure DyField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) dy'Offset_
      )
    structure AngleDeltaField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) angleDelta'Offset_
      )
    structure ScaleField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) scale'Offset_
      )
    structure XRootField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) xRoot'Offset_
      )
    structure YRootField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) yRoot'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventTouchpadPinchRecord
        structure FieldType = ValueFieldType(GdkModifierType)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val phase =
      {
        get = fn x => PhaseField.get x,
        set = fn x => PhaseField.set x
      }
    val nFingers =
      {
        get = fn x => NFingersField.get x,
        set = fn x => NFingersField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val dx =
      {
        get = fn x => DxField.get x,
        set = fn x => DxField.set x
      }
    val dy =
      {
        get = fn x => DyField.get x,
        set = fn x => DyField.set x
      }
    val angleDelta =
      {
        get = fn x => AngleDeltaField.get x,
        set = fn x => AngleDeltaField.set x
      }
    val scale =
      {
        get = fn x => ScaleField.get x,
        set = fn x => ScaleField.set x
      }
    val xRoot =
      {
        get = fn x => XRootField.get x,
        set = fn x => XRootField.set x
      }
    val yRoot =
      {
        get = fn x => YRootField.get x,
        set = fn x => YRootField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
  end
