structure GdkKeymapKey :>
  GDK_KEYMAP_KEY
    where type t = GdkKeymapKeyRecord.t =
  struct
    val keycode'Offset_ = _import "giraffe_gdk_keymap_key_keycode_offset" : unit -> GSize.FFI.val_;
    val group'Offset_ = _import "giraffe_gdk_keymap_key_group_offset" : unit -> GSize.FFI.val_;
    val level'Offset_ = _import "giraffe_gdk_keymap_key_level_offset" : unit -> GSize.FFI.val_;
    type t = GdkKeymapKeyRecord.t
    structure KeycodeField =
      Field(
        structure Container = GdkKeymapKeyRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) keycode'Offset_
      )
    structure GroupField =
      Field(
        structure Container = GdkKeymapKeyRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) group'Offset_
      )
    structure LevelField =
      Field(
        structure Container = GdkKeymapKeyRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) level'Offset_
      )
    val keycode =
      {
        get = fn x => KeycodeField.get x,
        set = fn x => KeycodeField.set x
      }
    val group =
      {
        get = fn x => GroupField.get x,
        set = fn x => GroupField.set x
      }
    val level =
      {
        get = fn x => LevelField.get x,
        set = fn x => LevelField.set x
      }
    fun new
      {
        keycode,
        group,
        level
      } =
      let
        fun init_ p =
          (
            KeycodeField.C.set keycode p;
            GroupField.C.set group p;
            LevelField.C.set level p;
            ()
          )
        val retVal & () = (GdkKeymapKeyRecord.FFI.withNewPtr ---> GdkKeymapKeyRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
  end
