structure GdkRectangle :>
  GDK_RECTANGLE
    where type t = GdkRectangleRecord.t =
  struct
    val getType_ = _import "gdk_rectangle_get_type" : unit -> GObjectType.FFI.val_;
    val equal_ = fn x1 & x2 => (_import "gdk_rectangle_equal" : GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p * GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p -> GBool.FFI.val_;) (x1, x2)
    val intersect_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gdk_rectangle_intersect" :
              GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p
               * GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p
               * GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3
            )
    val union_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gdk_rectangle_union" :
              GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p
               * GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p
               * GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val x'Offset_ = _import "giraffe_gdk_rectangle_x_offset" : unit -> GSize.FFI.val_;
    val y'Offset_ = _import "giraffe_gdk_rectangle_y_offset" : unit -> GSize.FFI.val_;
    val width'Offset_ = _import "giraffe_gdk_rectangle_width_offset" : unit -> GSize.FFI.val_;
    val height'Offset_ = _import "giraffe_gdk_rectangle_height_offset" : unit -> GSize.FFI.val_;
    type t = GdkRectangleRecord.t
    structure XField =
      Field(
        structure Container = GdkRectangleRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkRectangleRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure WidthField =
      Field(
        structure Container = GdkRectangleRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) width'Offset_
      )
    structure HeightField =
      Field(
        structure Container = GdkRectangleRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) height'Offset_
      )
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val width =
      {
        get = fn x => WidthField.get x,
        set = fn x => WidthField.set x
      }
    val height =
      {
        get = fn x => HeightField.get x,
        set = fn x => HeightField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new
      {
        x,
        y,
        width,
        height
      } =
      let
        fun init_ p =
          (
            XField.C.set x p;
            YField.C.set y p;
            WidthField.C.set width p;
            HeightField.C.set height p;
            ()
          )
        val retVal & () = (GdkRectangleRecord.FFI.withNewPtr ---> GdkRectangleRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
    fun equal self rect2 = (GdkRectangleRecord.FFI.withPtr false &&&> GdkRectangleRecord.FFI.withPtr false ---> GBool.FFI.fromVal) equal_ (self & rect2)
    fun intersect self src2 =
      let
        val dest & retVal =
          (
            GdkRectangleRecord.FFI.withPtr false
             &&&> GdkRectangleRecord.FFI.withPtr false
             &&&> GdkRectangleRecord.FFI.withNewPtr
             ---> GdkRectangleRecord.FFI.fromPtr true && GBool.FFI.fromVal
          )
            intersect_
            (
              self
               & src2
               & ()
            )
      in
        if retVal then SOME dest else NONE
      end
    fun union self src2 =
      let
        val dest & () =
          (
            GdkRectangleRecord.FFI.withPtr false
             &&&> GdkRectangleRecord.FFI.withPtr false
             &&&> GdkRectangleRecord.FFI.withNewPtr
             ---> GdkRectangleRecord.FFI.fromPtr true && I
          )
            union_
            (
              self
               & src2
               & ()
            )
      in
        dest
      end
  end
