structure GdkSeat :>
  GDK_SEAT
    where type 'a class = 'a GdkSeatClass.class
    where type seat_capabilities_t = GdkSeatCapabilities.t
    where type 'a device_class = 'a GdkDeviceClass.class
    where type 'a device_tool_class = 'a GdkDeviceToolClass.class
    where type 'a display_class = 'a GdkDisplayClass.class =
  struct
    val getType_ = _import "gdk_seat_get_type" : unit -> GObjectType.FFI.val_;
    val getCapabilities_ = _import "gdk_seat_get_capabilities" : GdkSeatClass.FFI.non_opt GdkSeatClass.FFI.p -> GdkSeatCapabilities.FFI.val_;
    val getDisplay_ = _import "gdk_seat_get_display" : GdkSeatClass.FFI.non_opt GdkSeatClass.FFI.p -> GdkDisplayClass.FFI.non_opt GdkDisplayClass.FFI.p;
    val getKeyboard_ = _import "gdk_seat_get_keyboard" : GdkSeatClass.FFI.non_opt GdkSeatClass.FFI.p -> GdkDeviceClass.FFI.opt GdkDeviceClass.FFI.p;
    val getPointer_ = _import "gdk_seat_get_pointer" : GdkSeatClass.FFI.non_opt GdkSeatClass.FFI.p -> GdkDeviceClass.FFI.opt GdkDeviceClass.FFI.p;
    val ungrab_ = _import "gdk_seat_ungrab" : GdkSeatClass.FFI.non_opt GdkSeatClass.FFI.p -> unit;
    type 'a class = 'a GdkSeatClass.class
    type seat_capabilities_t = GdkSeatCapabilities.t
    type 'a device_class = 'a GdkDeviceClass.class
    type 'a device_tool_class = 'a GdkDeviceToolClass.class
    type 'a display_class = 'a GdkDisplayClass.class
    type t = base class
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun getCapabilities self = (GdkSeatClass.FFI.withPtr false ---> GdkSeatCapabilities.FFI.fromVal) getCapabilities_ self
    fun getDisplay self = (GdkSeatClass.FFI.withPtr false ---> GdkDisplayClass.FFI.fromPtr false) getDisplay_ self before GdkSeatClass.FFI.touchPtr self
    fun getKeyboard self = (GdkSeatClass.FFI.withPtr false ---> GdkDeviceClass.FFI.fromOptPtr false) getKeyboard_ self before GdkSeatClass.FFI.touchPtr self
    fun getPointer self = (GdkSeatClass.FFI.withPtr false ---> GdkDeviceClass.FFI.fromOptPtr false) getPointer_ self before GdkSeatClass.FFI.touchPtr self
    fun ungrab self = (GdkSeatClass.FFI.withPtr false ---> I) ungrab_ self
    local
      open ClosureMarshal Signal
    in
      fun deviceAddedSig f = signal "device-added" (get 0w1 GdkDeviceClass.t ---> ret_void) f
      fun deviceRemovedSig f = signal "device-removed" (get 0w1 GdkDeviceClass.t ---> ret_void) f
      fun toolAddedSig f = signal "tool-added" (get 0w1 GdkDeviceToolClass.t ---> ret_void) f
      fun toolRemovedSig f = signal "tool-removed" (get 0w1 GdkDeviceToolClass.t ---> ret_void) f
    end
    local
      open ValueAccessor
    in
      val displayProp =
        {
          name = "display",
          gtype = fn () => C.gtype GdkDisplayClass.tOpt (),
          get = fn x => fn () => C.get GdkDisplayClass.tOpt x,
          set = ignore,
          init = fn x => C.set GdkDisplayClass.tOpt x
        }
    end
  end
