structure GdkWindowAttr :>
  GDK_WINDOW_ATTR
    where type t = GdkWindowAttrRecord.t
    where type window_window_class_t = GdkWindowWindowClass.t
    where type 'a visual_class = 'a GdkVisualClass.class
    where type window_type_t = GdkWindowType.t
    where type 'a cursor_class = 'a GdkCursorClass.class
    where type window_type_hint_t = GdkWindowTypeHint.t =
  struct
    val title'Offset_ = _import "giraffe_gdk_window_attr_title_offset" : unit -> GSize.FFI.val_;
    val eventMask'Offset_ = _import "giraffe_gdk_window_attr_event_mask_offset" : unit -> GSize.FFI.val_;
    val x'Offset_ = _import "giraffe_gdk_window_attr_x_offset" : unit -> GSize.FFI.val_;
    val y'Offset_ = _import "giraffe_gdk_window_attr_y_offset" : unit -> GSize.FFI.val_;
    val width'Offset_ = _import "giraffe_gdk_window_attr_width_offset" : unit -> GSize.FFI.val_;
    val height'Offset_ = _import "giraffe_gdk_window_attr_height_offset" : unit -> GSize.FFI.val_;
    val wclass'Offset_ = _import "giraffe_gdk_window_attr_wclass_offset" : unit -> GSize.FFI.val_;
    val visual'Offset_ = _import "giraffe_gdk_window_attr_visual_offset" : unit -> GSize.FFI.val_;
    val windowType'Offset_ = _import "giraffe_gdk_window_attr_window_type_offset" : unit -> GSize.FFI.val_;
    val cursor'Offset_ = _import "giraffe_gdk_window_attr_cursor_offset" : unit -> GSize.FFI.val_;
    val wmclassName'Offset_ = _import "giraffe_gdk_window_attr_wmclass_name_offset" : unit -> GSize.FFI.val_;
    val wmclassClass'Offset_ = _import "giraffe_gdk_window_attr_wmclass_class_offset" : unit -> GSize.FFI.val_;
    val overrideRedirect'Offset_ = _import "giraffe_gdk_window_attr_override_redirect_offset" : unit -> GSize.FFI.val_;
    val typeHint'Offset_ = _import "giraffe_gdk_window_attr_type_hint_offset" : unit -> GSize.FFI.val_;
    type t = GdkWindowAttrRecord.t
    type window_window_class_t = GdkWindowWindowClass.t
    type 'a visual_class = 'a GdkVisualClass.class
    type window_type_t = GdkWindowType.t
    type 'a cursor_class = 'a GdkCursorClass.class
    type window_type_hint_t = GdkWindowTypeHint.t
    structure TitleField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) title'Offset_
      )
    structure EventMaskField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) eventMask'Offset_
      )
    structure XField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure WidthField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) width'Offset_
      )
    structure HeightField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) height'Offset_
      )
    structure WclassField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GdkWindowWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) wclass'Offset_
      )
    structure VisualField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = OptPointerFieldType(GdkVisualClass)
        val offset = (I ---> GSize.FFI.fromVal) visual'Offset_
      )
    structure WindowTypeField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GdkWindowType)
        val offset = (I ---> GSize.FFI.fromVal) windowType'Offset_
      )
    structure CursorField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = OptPointerFieldType(GdkCursorClass)
        val offset = (I ---> GSize.FFI.fromVal) cursor'Offset_
      )
    structure WmclassNameField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) wmclassName'Offset_
      )
    structure WmclassClassField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) wmclassClass'Offset_
      )
    structure OverrideRedirectField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GBool)
        val offset = (I ---> GSize.FFI.fromVal) overrideRedirect'Offset_
      )
    structure TypeHintField =
      Field(
        structure Container = GdkWindowAttrRecord
        structure FieldType = ValueFieldType(GdkWindowTypeHint)
        val offset = (I ---> GSize.FFI.fromVal) typeHint'Offset_
      )
    val title =
      {
        get = fn x => TitleField.get x,
        set = fn x => TitleField.set x
      }
    val eventMask =
      {
        get = fn x => EventMaskField.get x,
        set = fn x => EventMaskField.set x
      }
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val width =
      {
        get = fn x => WidthField.get x,
        set = fn x => WidthField.set x
      }
    val height =
      {
        get = fn x => HeightField.get x,
        set = fn x => HeightField.set x
      }
    val wclass =
      {
        get = fn x => WclassField.get x,
        set = fn x => WclassField.set x
      }
    val visual =
      {
        get = fn x => VisualField.get x,
        set = fn x => VisualField.set (Option.map GdkVisualClass.toBase x)
      }
    val windowType =
      {
        get = fn x => WindowTypeField.get x,
        set = fn x => WindowTypeField.set x
      }
    val cursor =
      {
        get = fn x => CursorField.get x,
        set = fn x => CursorField.set (Option.map GdkCursorClass.toBase x)
      }
    val wmclassName =
      {
        get = fn x => WmclassNameField.get x,
        set = fn x => WmclassNameField.set x
      }
    val wmclassClass =
      {
        get = fn x => WmclassClassField.get x,
        set = fn x => WmclassClassField.set x
      }
    val overrideRedirect =
      {
        get = fn x => OverrideRedirectField.get x,
        set = fn x => OverrideRedirectField.set x
      }
    val typeHint =
      {
        get = fn x => TypeHintField.get x,
        set = fn x => TypeHintField.set x
      }
  end
