structure GdkColor :>
  GDK_COLOR
    where type t = GdkColorRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "gdk_color_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val copy_ = call (getSymbol "gdk_color_copy") (GdkColorRecord.PolyML.cPtr --> GdkColorRecord.PolyML.cPtr)
      val equal_ = call (getSymbol "gdk_color_equal") (GdkColorRecord.PolyML.cPtr &&> GdkColorRecord.PolyML.cPtr --> GBool.PolyML.cVal)
      val hash_ = call (getSymbol "gdk_color_hash") (GdkColorRecord.PolyML.cPtr --> GUInt.PolyML.cVal)
      val toString_ = call (getSymbol "gdk_color_to_string") (GdkColorRecord.PolyML.cPtr --> Utf8.PolyML.cOutPtr)
      val parse_ = call (getSymbol "gdk_color_parse") (Utf8.PolyML.cInPtr &&> GdkColorRecord.PolyML.cPtr --> GBool.PolyML.cVal)
      val pixel'Offset_ = call (getSymbol "giraffe_gdk_color_pixel_offset") (cVoid --> GSize.PolyML.cVal)
      val red'Offset_ = call (getSymbol "giraffe_gdk_color_red_offset") (cVoid --> GSize.PolyML.cVal)
      val green'Offset_ = call (getSymbol "giraffe_gdk_color_green_offset") (cVoid --> GSize.PolyML.cVal)
      val blue'Offset_ = call (getSymbol "giraffe_gdk_color_blue_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkColorRecord.t
    structure PixelField =
      Field(
        structure Container = GdkColorRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) pixel'Offset_
      )
    structure RedField =
      Field(
        structure Container = GdkColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) red'Offset_
      )
    structure GreenField =
      Field(
        structure Container = GdkColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) green'Offset_
      )
    structure BlueField =
      Field(
        structure Container = GdkColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) blue'Offset_
      )
    val pixel =
      {
        get = fn x => PixelField.get x,
        set = fn x => PixelField.set x
      }
    val red =
      {
        get = fn x => RedField.get x,
        set = fn x => RedField.set x
      }
    val green =
      {
        get = fn x => GreenField.get x,
        set = fn x => GreenField.set x
      }
    val blue =
      {
        get = fn x => BlueField.get x,
        set = fn x => BlueField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new
      {
        pixel,
        red,
        green,
        blue
      } =
      let
        fun init_ p =
          (
            PixelField.C.set pixel p;
            RedField.C.set red p;
            GreenField.C.set green p;
            BlueField.C.set blue p;
            ()
          )
        val retVal & () = (GdkColorRecord.FFI.withNewPtr ---> GdkColorRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
    fun copy self = (GdkColorRecord.FFI.withPtr false ---> GdkColorRecord.FFI.fromPtr true) copy_ self
    fun equal self colorb = (GdkColorRecord.FFI.withPtr false &&&> GdkColorRecord.FFI.withPtr false ---> GBool.FFI.fromVal) equal_ (self & colorb)
    fun hash self = (GdkColorRecord.FFI.withPtr false ---> GUInt.FFI.fromVal) hash_ self
    fun toString self = (GdkColorRecord.FFI.withPtr false ---> Utf8.FFI.fromPtr ~1) toString_ self
    fun parse spec =
      let
        val color & retVal = (Utf8.FFI.withPtr 0 &&&> GdkColorRecord.FFI.withNewPtr ---> GdkColorRecord.FFI.fromPtr true && GBool.FFI.fromVal) parse_ (spec & ())
      in
        if retVal then SOME color else NONE
      end
  end
