structure GdkEventButton :>
  GDK_EVENT_BUTTON
    where type t = GdkEventButtonRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type modifier_type_t = GdkModifierType.t
    where type 'a device_class = 'a GdkDeviceClass.class =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_button_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_button_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_button_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_button_time_offset") (cVoid --> GSize.PolyML.cVal)
      val x'Offset_ = call (getSymbol "giraffe_gdk_event_button_x_offset") (cVoid --> GSize.PolyML.cVal)
      val y'Offset_ = call (getSymbol "giraffe_gdk_event_button_y_offset") (cVoid --> GSize.PolyML.cVal)
      val state'Offset_ = call (getSymbol "giraffe_gdk_event_button_state_offset") (cVoid --> GSize.PolyML.cVal)
      val button'Offset_ = call (getSymbol "giraffe_gdk_event_button_button_offset") (cVoid --> GSize.PolyML.cVal)
      val device'Offset_ = call (getSymbol "giraffe_gdk_event_button_device_offset") (cVoid --> GSize.PolyML.cVal)
      val xRoot'Offset_ = call (getSymbol "giraffe_gdk_event_button_x_root_offset") (cVoid --> GSize.PolyML.cVal)
      val yRoot'Offset_ = call (getSymbol "giraffe_gdk_event_button_y_root_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventButtonRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type modifier_type_t = GdkModifierType.t
    type 'a device_class = 'a GdkDeviceClass.class
    structure TypeField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure XField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GdkModifierType)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    structure ButtonField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) button'Offset_
      )
    structure DeviceField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = OptPointerFieldType(GdkDeviceClass)
        val offset = (I ---> GSize.FFI.fromVal) device'Offset_
      )
    structure XRootField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) xRoot'Offset_
      )
    structure YRootField =
      Field(
        structure Container = GdkEventButtonRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) yRoot'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
    val button =
      {
        get = fn x => ButtonField.get x,
        set = fn x => ButtonField.set x
      }
    val device =
      {
        get = fn x => DeviceField.get x,
        set = fn x => DeviceField.set (Option.map GdkDeviceClass.toBase x)
      }
    val xRoot =
      {
        get = fn x => XRootField.get x,
        set = fn x => XRootField.set x
      }
    val yRoot =
      {
        get = fn x => YRootField.get x,
        set = fn x => YRootField.set x
      }
  end
