structure GdkEventConfigure :>
  GDK_EVENT_CONFIGURE
    where type t = GdkEventConfigureRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_configure_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_configure_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_configure_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val x'Offset_ = call (getSymbol "giraffe_gdk_event_configure_x_offset") (cVoid --> GSize.PolyML.cVal)
      val y'Offset_ = call (getSymbol "giraffe_gdk_event_configure_y_offset") (cVoid --> GSize.PolyML.cVal)
      val width'Offset_ = call (getSymbol "giraffe_gdk_event_configure_width_offset") (cVoid --> GSize.PolyML.cVal)
      val height'Offset_ = call (getSymbol "giraffe_gdk_event_configure_height_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventConfigureRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    structure TypeField =
      Field(
        structure Container = GdkEventConfigureRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventConfigureRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventConfigureRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure XField =
      Field(
        structure Container = GdkEventConfigureRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkEventConfigureRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure WidthField =
      Field(
        structure Container = GdkEventConfigureRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) width'Offset_
      )
    structure HeightField =
      Field(
        structure Container = GdkEventConfigureRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) height'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val width =
      {
        get = fn x => WidthField.get x,
        set = fn x => WidthField.set x
      }
    val height =
      {
        get = fn x => HeightField.get x,
        set = fn x => HeightField.set x
      }
  end
