structure GdkEventCrossing :>
  GDK_EVENT_CROSSING
    where type t = GdkEventCrossingRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type crossing_mode_t = GdkCrossingMode.t
    where type notify_type_t = GdkNotifyType.t
    where type modifier_type_t = GdkModifierType.t =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val subwindow'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_subwindow_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_time_offset") (cVoid --> GSize.PolyML.cVal)
      val x'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_x_offset") (cVoid --> GSize.PolyML.cVal)
      val y'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_y_offset") (cVoid --> GSize.PolyML.cVal)
      val xRoot'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_x_root_offset") (cVoid --> GSize.PolyML.cVal)
      val yRoot'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_y_root_offset") (cVoid --> GSize.PolyML.cVal)
      val mode'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_mode_offset") (cVoid --> GSize.PolyML.cVal)
      val detail'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_detail_offset") (cVoid --> GSize.PolyML.cVal)
      val focus'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_focus_offset") (cVoid --> GSize.PolyML.cVal)
      val state'Offset_ = call (getSymbol "giraffe_gdk_event_crossing_state_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventCrossingRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type crossing_mode_t = GdkCrossingMode.t
    type notify_type_t = GdkNotifyType.t
    type modifier_type_t = GdkModifierType.t
    structure TypeField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure SubwindowField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) subwindow'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure XField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure XRootField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) xRoot'Offset_
      )
    structure YRootField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) yRoot'Offset_
      )
    structure ModeField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GdkCrossingMode)
        val offset = (I ---> GSize.FFI.fromVal) mode'Offset_
      )
    structure DetailField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GdkNotifyType)
        val offset = (I ---> GSize.FFI.fromVal) detail'Offset_
      )
    structure FocusField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GBool)
        val offset = (I ---> GSize.FFI.fromVal) focus'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventCrossingRecord
        structure FieldType = ValueFieldType(GdkModifierType)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val subwindow =
      {
        get = fn x => SubwindowField.get x,
        set = fn x => SubwindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val xRoot =
      {
        get = fn x => XRootField.get x,
        set = fn x => XRootField.set x
      }
    val yRoot =
      {
        get = fn x => YRootField.get x,
        set = fn x => YRootField.set x
      }
    val mode =
      {
        get = fn x => ModeField.get x,
        set = fn x => ModeField.set x
      }
    val detail =
      {
        get = fn x => DetailField.get x,
        set = fn x => DetailField.set x
      }
    val focus =
      {
        get = fn x => FocusField.get x,
        set = fn x => FocusField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
  end
