structure GdkEventExpose :>
  GDK_EVENT_EXPOSE
    where type t = GdkEventExposeRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type rectangle_t = GdkRectangleRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_expose_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_expose_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_expose_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val area'Offset_ = call (getSymbol "giraffe_gdk_event_expose_area_offset") (cVoid --> GSize.PolyML.cVal)
      val region'Offset_ = call (getSymbol "giraffe_gdk_event_expose_region_offset") (cVoid --> GSize.PolyML.cVal)
      val count'Offset_ = call (getSymbol "giraffe_gdk_event_expose_count_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventExposeRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type rectangle_t = GdkRectangleRecord.t
    structure TypeField =
      Field(
        structure Container = GdkEventExposeRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventExposeRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventExposeRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure AreaField =
      Field(
        structure Container = GdkEventExposeRecord
        structure FieldType = ValueFieldType(GdkRectangleRecord)
        val offset = (I ---> GSize.FFI.fromVal) area'Offset_
      )
    structure RegionField =
      Field(
        structure Container = GdkEventExposeRecord
        structure FieldType = OptPointerFieldType(CairoRegionRecord)
        val offset = (I ---> GSize.FFI.fromVal) region'Offset_
      )
    structure CountField =
      Field(
        structure Container = GdkEventExposeRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) count'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val area =
      {
        get = fn x => AreaField.get x,
        set = fn x => AreaField.set x
      }
    val region =
      {
        get = fn x => RegionField.get x,
        set = fn x => RegionField.set x
      }
    val count =
      {
        get = fn x => CountField.get x,
        set = fn x => CountField.set x
      }
  end
