structure GdkEventKey :>
  GDK_EVENT_KEY
    where type t = GdkEventKeyRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type modifier_type_t = GdkModifierType.t =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_key_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_key_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_key_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_key_time_offset") (cVoid --> GSize.PolyML.cVal)
      val state'Offset_ = call (getSymbol "giraffe_gdk_event_key_state_offset") (cVoid --> GSize.PolyML.cVal)
      val keyval'Offset_ = call (getSymbol "giraffe_gdk_event_key_keyval_offset") (cVoid --> GSize.PolyML.cVal)
      val length'Offset_ = call (getSymbol "giraffe_gdk_event_key_length_offset") (cVoid --> GSize.PolyML.cVal)
      val string'Offset_ = call (getSymbol "giraffe_gdk_event_key_string_offset") (cVoid --> GSize.PolyML.cVal)
      val hardwareKeycode'Offset_ = call (getSymbol "giraffe_gdk_event_key_hardware_keycode_offset") (cVoid --> GSize.PolyML.cVal)
      val group'Offset_ = call (getSymbol "giraffe_gdk_event_key_group_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventKeyRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type modifier_type_t = GdkModifierType.t
    structure TypeField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = ValueFieldType(GdkModifierType)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    structure KeyvalField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) keyval'Offset_
      )
    structure LengthField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) length'Offset_
      )
    structure StringField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) string'Offset_
      )
    structure HardwareKeycodeField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) hardwareKeycode'Offset_
      )
    structure GroupField =
      Field(
        structure Container = GdkEventKeyRecord
        structure FieldType = ValueFieldType(GUInt8)
        val offset = (I ---> GSize.FFI.fromVal) group'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
    val keyval =
      {
        get = fn x => KeyvalField.get x,
        set = fn x => KeyvalField.set x
      }
    val length =
      {
        get = fn x => LengthField.get x,
        set = fn x => LengthField.set x
      }
    val string =
      {
        get = fn x => StringField.get x,
        set = fn x => StringField.set x
      }
    val hardwareKeycode =
      {
        get = fn x => HardwareKeycodeField.get x,
        set = fn x => HardwareKeycodeField.set x
      }
    val group =
      {
        get = fn x => GroupField.get x,
        set = fn x => GroupField.set x
      }
  end
