structure GdkEventOwnerChange :>
  GDK_EVENT_OWNER_CHANGE
    where type t = GdkEventOwnerChangeRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type owner_change_t = GdkOwnerChange.t
    where type atom_t = GdkAtomRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_owner_change_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_owner_change_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_owner_change_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val owner'Offset_ = call (getSymbol "giraffe_gdk_event_owner_change_owner_offset") (cVoid --> GSize.PolyML.cVal)
      val reason'Offset_ = call (getSymbol "giraffe_gdk_event_owner_change_reason_offset") (cVoid --> GSize.PolyML.cVal)
      val selection'Offset_ = call (getSymbol "giraffe_gdk_event_owner_change_selection_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_owner_change_time_offset") (cVoid --> GSize.PolyML.cVal)
      val selectionTime'Offset_ = call (getSymbol "giraffe_gdk_event_owner_change_selection_time_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventOwnerChangeRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type owner_change_t = GdkOwnerChange.t
    type atom_t = GdkAtomRecord.t
    structure TypeField =
      Field(
        structure Container = GdkEventOwnerChangeRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventOwnerChangeRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventOwnerChangeRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure OwnerField =
      Field(
        structure Container = GdkEventOwnerChangeRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) owner'Offset_
      )
    structure ReasonField =
      Field(
        structure Container = GdkEventOwnerChangeRecord
        structure FieldType = ValueFieldType(GdkOwnerChange)
        val offset = (I ---> GSize.FFI.fromVal) reason'Offset_
      )
    structure SelectionField =
      Field(
        structure Container = GdkEventOwnerChangeRecord
        structure FieldType = OptPointerFieldType(GdkAtomRecord)
        val offset = (I ---> GSize.FFI.fromVal) selection'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventOwnerChangeRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure SelectionTimeField =
      Field(
        structure Container = GdkEventOwnerChangeRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) selectionTime'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val owner =
      {
        get = fn x => OwnerField.get x,
        set = fn x => OwnerField.set (Option.map GdkWindowClass.toBase x)
      }
    val reason =
      {
        get = fn x => ReasonField.get x,
        set = fn x => ReasonField.set x
      }
    val selection =
      {
        get = fn x => SelectionField.get x,
        set = fn x => SelectionField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val selectionTime =
      {
        get = fn x => SelectionTimeField.get x,
        set = fn x => SelectionTimeField.set x
      }
  end
