structure GdkEventPadAxis :>
  GDK_EVENT_PAD_AXIS
    where type t = GdkEventPadAxisRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_pad_axis_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_pad_axis_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_pad_axis_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_pad_axis_time_offset") (cVoid --> GSize.PolyML.cVal)
      val group'Offset_ = call (getSymbol "giraffe_gdk_event_pad_axis_group_offset") (cVoid --> GSize.PolyML.cVal)
      val index'Offset_ = call (getSymbol "giraffe_gdk_event_pad_axis_index_offset") (cVoid --> GSize.PolyML.cVal)
      val mode'Offset_ = call (getSymbol "giraffe_gdk_event_pad_axis_mode_offset") (cVoid --> GSize.PolyML.cVal)
      val value'Offset_ = call (getSymbol "giraffe_gdk_event_pad_axis_value_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventPadAxisRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    structure TypeField =
      Field(
        structure Container = GdkEventPadAxisRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventPadAxisRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventPadAxisRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventPadAxisRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure GroupField =
      Field(
        structure Container = GdkEventPadAxisRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) group'Offset_
      )
    structure IndexField =
      Field(
        structure Container = GdkEventPadAxisRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) index'Offset_
      )
    structure ModeField =
      Field(
        structure Container = GdkEventPadAxisRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) mode'Offset_
      )
    structure ValueField =
      Field(
        structure Container = GdkEventPadAxisRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) value'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val group =
      {
        get = fn x => GroupField.get x,
        set = fn x => GroupField.set x
      }
    val index =
      {
        get = fn x => IndexField.get x,
        set = fn x => IndexField.set x
      }
    val mode =
      {
        get = fn x => ModeField.get x,
        set = fn x => ModeField.set x
      }
    val value =
      {
        get = fn x => ValueField.get x,
        set = fn x => ValueField.set x
      }
  end
