structure GdkEventProximity :>
  GDK_EVENT_PROXIMITY
    where type t = GdkEventProximityRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type 'a device_class = 'a GdkDeviceClass.class =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_proximity_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_proximity_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_proximity_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_proximity_time_offset") (cVoid --> GSize.PolyML.cVal)
      val device'Offset_ = call (getSymbol "giraffe_gdk_event_proximity_device_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventProximityRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type 'a device_class = 'a GdkDeviceClass.class
    structure TypeField =
      Field(
        structure Container = GdkEventProximityRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventProximityRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventProximityRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventProximityRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure DeviceField =
      Field(
        structure Container = GdkEventProximityRecord
        structure FieldType = OptPointerFieldType(GdkDeviceClass)
        val offset = (I ---> GSize.FFI.fromVal) device'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val device =
      {
        get = fn x => DeviceField.get x,
        set = fn x => DeviceField.set (Option.map GdkDeviceClass.toBase x)
      }
  end
