structure GdkEventScroll :>
  GDK_EVENT_SCROLL
    where type t = GdkEventScrollRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type modifier_type_t = GdkModifierType.t
    where type scroll_direction_t = GdkScrollDirection.t
    where type 'a device_class = 'a GdkDeviceClass.class =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_time_offset") (cVoid --> GSize.PolyML.cVal)
      val x'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_x_offset") (cVoid --> GSize.PolyML.cVal)
      val y'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_y_offset") (cVoid --> GSize.PolyML.cVal)
      val state'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_state_offset") (cVoid --> GSize.PolyML.cVal)
      val direction'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_direction_offset") (cVoid --> GSize.PolyML.cVal)
      val device'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_device_offset") (cVoid --> GSize.PolyML.cVal)
      val xRoot'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_x_root_offset") (cVoid --> GSize.PolyML.cVal)
      val yRoot'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_y_root_offset") (cVoid --> GSize.PolyML.cVal)
      val deltaX'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_delta_x_offset") (cVoid --> GSize.PolyML.cVal)
      val deltaY'Offset_ = call (getSymbol "giraffe_gdk_event_scroll_delta_y_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventScrollRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type modifier_type_t = GdkModifierType.t
    type scroll_direction_t = GdkScrollDirection.t
    type 'a device_class = 'a GdkDeviceClass.class
    structure TypeField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure XField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GdkModifierType)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    structure DirectionField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GdkScrollDirection)
        val offset = (I ---> GSize.FFI.fromVal) direction'Offset_
      )
    structure DeviceField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = OptPointerFieldType(GdkDeviceClass)
        val offset = (I ---> GSize.FFI.fromVal) device'Offset_
      )
    structure XRootField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) xRoot'Offset_
      )
    structure YRootField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) yRoot'Offset_
      )
    structure DeltaXField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) deltaX'Offset_
      )
    structure DeltaYField =
      Field(
        structure Container = GdkEventScrollRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) deltaY'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
    val direction =
      {
        get = fn x => DirectionField.get x,
        set = fn x => DirectionField.set x
      }
    val device =
      {
        get = fn x => DeviceField.get x,
        set = fn x => DeviceField.set (Option.map GdkDeviceClass.toBase x)
      }
    val xRoot =
      {
        get = fn x => XRootField.get x,
        set = fn x => XRootField.set x
      }
    val yRoot =
      {
        get = fn x => YRootField.get x,
        set = fn x => YRootField.set x
      }
    val deltaX =
      {
        get = fn x => DeltaXField.get x,
        set = fn x => DeltaXField.set x
      }
    val deltaY =
      {
        get = fn x => DeltaYField.get x,
        set = fn x => DeltaYField.set x
      }
  end
