structure GdkEventSelection :>
  GDK_EVENT_SELECTION
    where type t = GdkEventSelectionRecord.t
    where type event_type_t = GdkEventType.t
    where type atom_t = GdkAtomRecord.t
    where type 'a window_class = 'a GdkWindowClass.class =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_selection_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_selection_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_selection_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val selection'Offset_ = call (getSymbol "giraffe_gdk_event_selection_selection_offset") (cVoid --> GSize.PolyML.cVal)
      val target'Offset_ = call (getSymbol "giraffe_gdk_event_selection_target_offset") (cVoid --> GSize.PolyML.cVal)
      val property'Offset_ = call (getSymbol "giraffe_gdk_event_selection_property_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_selection_time_offset") (cVoid --> GSize.PolyML.cVal)
      val requestor'Offset_ = call (getSymbol "giraffe_gdk_event_selection_requestor_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventSelectionRecord.t
    type event_type_t = GdkEventType.t
    type atom_t = GdkAtomRecord.t
    type 'a window_class = 'a GdkWindowClass.class
    structure TypeField =
      Field(
        structure Container = GdkEventSelectionRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventSelectionRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventSelectionRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure SelectionField =
      Field(
        structure Container = GdkEventSelectionRecord
        structure FieldType = OptPointerFieldType(GdkAtomRecord)
        val offset = (I ---> GSize.FFI.fromVal) selection'Offset_
      )
    structure TargetField =
      Field(
        structure Container = GdkEventSelectionRecord
        structure FieldType = OptPointerFieldType(GdkAtomRecord)
        val offset = (I ---> GSize.FFI.fromVal) target'Offset_
      )
    structure PropertyField =
      Field(
        structure Container = GdkEventSelectionRecord
        structure FieldType = OptPointerFieldType(GdkAtomRecord)
        val offset = (I ---> GSize.FFI.fromVal) property'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventSelectionRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure RequestorField =
      Field(
        structure Container = GdkEventSelectionRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) requestor'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val selection =
      {
        get = fn x => SelectionField.get x,
        set = fn x => SelectionField.set x
      }
    val target =
      {
        get = fn x => TargetField.get x,
        set = fn x => TargetField.set x
      }
    val property =
      {
        get = fn x => PropertyField.get x,
        set = fn x => PropertyField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val requestor =
      {
        get = fn x => RequestorField.get x,
        set = fn x => RequestorField.set (Option.map GdkWindowClass.toBase x)
      }
  end
