structure GdkEventSetting :>
  GDK_EVENT_SETTING
    where type t = GdkEventSettingRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type setting_action_t = GdkSettingAction.t =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_setting_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_setting_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_setting_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val action'Offset_ = call (getSymbol "giraffe_gdk_event_setting_action_offset") (cVoid --> GSize.PolyML.cVal)
      val name'Offset_ = call (getSymbol "giraffe_gdk_event_setting_name_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventSettingRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type setting_action_t = GdkSettingAction.t
    structure TypeField =
      Field(
        structure Container = GdkEventSettingRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventSettingRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventSettingRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure ActionField =
      Field(
        structure Container = GdkEventSettingRecord
        structure FieldType = ValueFieldType(GdkSettingAction)
        val offset = (I ---> GSize.FFI.fromVal) action'Offset_
      )
    structure NameField =
      Field(
        structure Container = GdkEventSettingRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) name'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val action =
      {
        get = fn x => ActionField.get x,
        set = fn x => ActionField.set x
      }
    val name =
      {
        get = fn x => NameField.get x,
        set = fn x => NameField.set x
      }
  end
