structure GdkEventTouchpadSwipe :>
  GDK_EVENT_TOUCHPAD_SWIPE
    where type t = GdkEventTouchpadSwipeRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type touchpad_gesture_phase_t = GdkTouchpadGesturePhase.t
    where type modifier_type_t = GdkModifierType.t =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val phase'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_phase_offset") (cVoid --> GSize.PolyML.cVal)
      val nFingers'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_n_fingers_offset") (cVoid --> GSize.PolyML.cVal)
      val time'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_time_offset") (cVoid --> GSize.PolyML.cVal)
      val x'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_x_offset") (cVoid --> GSize.PolyML.cVal)
      val y'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_y_offset") (cVoid --> GSize.PolyML.cVal)
      val dx'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_dx_offset") (cVoid --> GSize.PolyML.cVal)
      val dy'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_dy_offset") (cVoid --> GSize.PolyML.cVal)
      val xRoot'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_x_root_offset") (cVoid --> GSize.PolyML.cVal)
      val yRoot'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_y_root_offset") (cVoid --> GSize.PolyML.cVal)
      val state'Offset_ = call (getSymbol "giraffe_gdk_event_touchpad_swipe_state_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventTouchpadSwipeRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type touchpad_gesture_phase_t = GdkTouchpadGesturePhase.t
    type modifier_type_t = GdkModifierType.t
    structure TypeField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure PhaseField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GdkTouchpadGesturePhase)
        val offset = (I ---> GSize.FFI.fromVal) phase'Offset_
      )
    structure NFingersField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) nFingers'Offset_
      )
    structure TimeField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GUInt32)
        val offset = (I ---> GSize.FFI.fromVal) time'Offset_
      )
    structure XField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure DxField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) dx'Offset_
      )
    structure DyField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) dy'Offset_
      )
    structure XRootField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) xRoot'Offset_
      )
    structure YRootField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) yRoot'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventTouchpadSwipeRecord
        structure FieldType = ValueFieldType(GdkModifierType)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val phase =
      {
        get = fn x => PhaseField.get x,
        set = fn x => PhaseField.set x
      }
    val nFingers =
      {
        get = fn x => NFingersField.get x,
        set = fn x => NFingersField.set x
      }
    val time =
      {
        get = fn x => TimeField.get x,
        set = fn x => TimeField.set x
      }
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val dx =
      {
        get = fn x => DxField.get x,
        set = fn x => DxField.set x
      }
    val dy =
      {
        get = fn x => DyField.get x,
        set = fn x => DyField.set x
      }
    val xRoot =
      {
        get = fn x => XRootField.get x,
        set = fn x => XRootField.set x
      }
    val yRoot =
      {
        get = fn x => YRootField.get x,
        set = fn x => YRootField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
  end
