structure GdkEventVisibility :>
  GDK_EVENT_VISIBILITY
    where type t = GdkEventVisibilityRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type visibility_state_t = GdkVisibilityState.t =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_visibility_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_visibility_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_visibility_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val state'Offset_ = call (getSymbol "giraffe_gdk_event_visibility_state_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventVisibilityRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type visibility_state_t = GdkVisibilityState.t
    structure TypeField =
      Field(
        structure Container = GdkEventVisibilityRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventVisibilityRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventVisibilityRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure StateField =
      Field(
        structure Container = GdkEventVisibilityRecord
        structure FieldType = ValueFieldType(GdkVisibilityState)
        val offset = (I ---> GSize.FFI.fromVal) state'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val state =
      {
        get = fn x => StateField.get x,
        set = fn x => StateField.set x
      }
  end
