structure GdkEventWindowState :>
  GDK_EVENT_WINDOW_STATE
    where type t = GdkEventWindowStateRecord.t
    where type event_type_t = GdkEventType.t
    where type 'a window_class = 'a GdkWindowClass.class
    where type window_state_t = GdkWindowState.t =
  struct
    local
      open PolyMLFFI
    in
      val type'Offset_ = call (getSymbol "giraffe_gdk_event_window_state_type_offset") (cVoid --> GSize.PolyML.cVal)
      val window'Offset_ = call (getSymbol "giraffe_gdk_event_window_state_window_offset") (cVoid --> GSize.PolyML.cVal)
      val sendEvent'Offset_ = call (getSymbol "giraffe_gdk_event_window_state_send_event_offset") (cVoid --> GSize.PolyML.cVal)
      val changedMask'Offset_ = call (getSymbol "giraffe_gdk_event_window_state_changed_mask_offset") (cVoid --> GSize.PolyML.cVal)
      val newWindowState'Offset_ = call (getSymbol "giraffe_gdk_event_window_state_new_window_state_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkEventWindowStateRecord.t
    type event_type_t = GdkEventType.t
    type 'a window_class = 'a GdkWindowClass.class
    type window_state_t = GdkWindowState.t
    structure TypeField =
      Field(
        structure Container = GdkEventWindowStateRecord
        structure FieldType = ValueFieldType(GdkEventType)
        val offset = (I ---> GSize.FFI.fromVal) type'Offset_
      )
    structure WindowField =
      Field(
        structure Container = GdkEventWindowStateRecord
        structure FieldType = OptPointerFieldType(GdkWindowClass)
        val offset = (I ---> GSize.FFI.fromVal) window'Offset_
      )
    structure SendEventField =
      Field(
        structure Container = GdkEventWindowStateRecord
        structure FieldType = ValueFieldType(GInt8)
        val offset = (I ---> GSize.FFI.fromVal) sendEvent'Offset_
      )
    structure ChangedMaskField =
      Field(
        structure Container = GdkEventWindowStateRecord
        structure FieldType = ValueFieldType(GdkWindowState)
        val offset = (I ---> GSize.FFI.fromVal) changedMask'Offset_
      )
    structure NewWindowStateField =
      Field(
        structure Container = GdkEventWindowStateRecord
        structure FieldType = ValueFieldType(GdkWindowState)
        val offset = (I ---> GSize.FFI.fromVal) newWindowState'Offset_
      )
    val type' =
      {
        get = fn x => TypeField.get x,
        set = fn x => TypeField.set x
      }
    val window =
      {
        get = fn x => WindowField.get x,
        set = fn x => WindowField.set (Option.map GdkWindowClass.toBase x)
      }
    val sendEvent =
      {
        get = fn x => SendEventField.get x,
        set = fn x => SendEventField.set x
      }
    val changedMask =
      {
        get = fn x => ChangedMaskField.get x,
        set = fn x => ChangedMaskField.set x
      }
    val newWindowState =
      {
        get = fn x => NewWindowStateField.get x,
        set = fn x => NewWindowStateField.set x
      }
  end
