structure GdkPoint :>
  GDK_POINT
    where type t = GdkPointRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val x'Offset_ = call (getSymbol "giraffe_gdk_point_x_offset") (cVoid --> GSize.PolyML.cVal)
      val y'Offset_ = call (getSymbol "giraffe_gdk_point_y_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GdkPointRecord.t
    structure XField =
      Field(
        structure Container = GdkPointRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = GdkPointRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    fun new
      {
        x,
        y
      } =
      let
        fun init_ p =
          (
            XField.C.set x p;
            YField.C.set y p;
            ()
          )
        val retVal & () = (GdkPointRecord.FFI.withNewPtr ---> GdkPointRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
  end
