structure GioDBusInterfaceInfo :>
  GIO_D_BUS_INTERFACE_INFO
    where type t = GioDBusInterfaceInfoRecord.t
    where type d_bus_method_info_record_c_ptr_array_t = GioDBusMethodInfoRecordCPtrArray.t
    where type d_bus_signal_info_record_c_ptr_array_t = GioDBusSignalInfoRecordCPtrArray.t
    where type d_bus_property_info_record_c_ptr_array_t = GioDBusPropertyInfoRecordCPtrArray.t
    where type d_bus_annotation_info_record_c_ptr_array_t = GioDBusAnnotationInfoRecordCPtrArray.t
    where type d_bus_method_info_t = GioDBusMethodInfoRecord.t
    where type d_bus_property_info_t = GioDBusPropertyInfoRecord.t
    where type d_bus_signal_info_t = GioDBusSignalInfoRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "g_dbus_interface_info_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val cacheBuild_ = call (getSymbol "g_dbus_interface_info_cache_build") (GioDBusInterfaceInfoRecord.PolyML.cPtr --> cVoid)
      val cacheRelease_ = call (getSymbol "g_dbus_interface_info_cache_release") (GioDBusInterfaceInfoRecord.PolyML.cPtr --> cVoid)
      val generateXml_ =
        call (getSymbol "g_dbus_interface_info_generate_xml")
          (
            GioDBusInterfaceInfoRecord.PolyML.cPtr
             &&> GUInt.PolyML.cVal
             &&> GLibStringRecord.PolyML.cPtr
             --> cVoid
          )
      val lookupMethod_ = call (getSymbol "g_dbus_interface_info_lookup_method") (GioDBusInterfaceInfoRecord.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GioDBusMethodInfoRecord.PolyML.cPtr)
      val lookupProperty_ = call (getSymbol "g_dbus_interface_info_lookup_property") (GioDBusInterfaceInfoRecord.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GioDBusPropertyInfoRecord.PolyML.cPtr)
      val lookupSignal_ = call (getSymbol "g_dbus_interface_info_lookup_signal") (GioDBusInterfaceInfoRecord.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GioDBusSignalInfoRecord.PolyML.cPtr)
      val refCount'Offset_ = call (getSymbol "giraffe_gio_d_bus_interface_info_ref_count_offset") (cVoid --> GSize.PolyML.cVal)
      val name'Offset_ = call (getSymbol "giraffe_gio_d_bus_interface_info_name_offset") (cVoid --> GSize.PolyML.cVal)
      val methods'Offset_ = call (getSymbol "giraffe_gio_d_bus_interface_info_methods_offset") (cVoid --> GSize.PolyML.cVal)
      val signals'Offset_ = call (getSymbol "giraffe_gio_d_bus_interface_info_signals_offset") (cVoid --> GSize.PolyML.cVal)
      val properties'Offset_ = call (getSymbol "giraffe_gio_d_bus_interface_info_properties_offset") (cVoid --> GSize.PolyML.cVal)
      val annotations'Offset_ = call (getSymbol "giraffe_gio_d_bus_interface_info_annotations_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GioDBusInterfaceInfoRecord.t
    type d_bus_method_info_record_c_ptr_array_t = GioDBusMethodInfoRecordCPtrArray.t
    type d_bus_signal_info_record_c_ptr_array_t = GioDBusSignalInfoRecordCPtrArray.t
    type d_bus_property_info_record_c_ptr_array_t = GioDBusPropertyInfoRecordCPtrArray.t
    type d_bus_annotation_info_record_c_ptr_array_t = GioDBusAnnotationInfoRecordCPtrArray.t
    type d_bus_method_info_t = GioDBusMethodInfoRecord.t
    type d_bus_property_info_t = GioDBusPropertyInfoRecord.t
    type d_bus_signal_info_t = GioDBusSignalInfoRecord.t
    structure RefCountField =
      Field(
        structure Container = GioDBusInterfaceInfoRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) refCount'Offset_
      )
    structure NameField =
      Field(
        structure Container = GioDBusInterfaceInfoRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) name'Offset_
      )
    structure MethodsField =
      Field(
        structure Container = GioDBusInterfaceInfoRecord
        structure FieldType = OptPointerFieldType(GioDBusMethodInfoRecordCPtrArray)
        val offset = (I ---> GSize.FFI.fromVal) methods'Offset_
      )
    structure SignalsField =
      Field(
        structure Container = GioDBusInterfaceInfoRecord
        structure FieldType = OptPointerFieldType(GioDBusSignalInfoRecordCPtrArray)
        val offset = (I ---> GSize.FFI.fromVal) signals'Offset_
      )
    structure PropertiesField =
      Field(
        structure Container = GioDBusInterfaceInfoRecord
        structure FieldType = OptPointerFieldType(GioDBusPropertyInfoRecordCPtrArray)
        val offset = (I ---> GSize.FFI.fromVal) properties'Offset_
      )
    structure AnnotationsField =
      Field(
        structure Container = GioDBusInterfaceInfoRecord
        structure FieldType = OptPointerFieldType(GioDBusAnnotationInfoRecordCPtrArray)
        val offset = (I ---> GSize.FFI.fromVal) annotations'Offset_
      )
    val refCount =
      {
        get = fn x => RefCountField.get x,
        set = fn x => RefCountField.set x
      }
    val name =
      {
        get = fn x => NameField.get x,
        set = fn x => NameField.set x
      }
    val methods =
      {
        get = fn x => MethodsField.get x,
        set = fn x => MethodsField.set x
      }
    val signals =
      {
        get = fn x => SignalsField.get x,
        set = fn x => SignalsField.set x
      }
    val properties =
      {
        get = fn x => PropertiesField.get x,
        set = fn x => PropertiesField.set x
      }
    val annotations =
      {
        get = fn x => AnnotationsField.get x,
        set = fn x => AnnotationsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun cacheBuild self = (GioDBusInterfaceInfoRecord.FFI.withPtr false ---> I) cacheBuild_ self
    fun cacheRelease self = (GioDBusInterfaceInfoRecord.FFI.withPtr false ---> I) cacheRelease_ self
    fun generateXml self (indent, stringBuilder) =
      (
        GioDBusInterfaceInfoRecord.FFI.withPtr false
         &&&> GUInt.FFI.withVal
         &&&> GLibStringRecord.FFI.withPtr false
         ---> I
      )
        generateXml_
        (
          self
           & indent
           & stringBuilder
        )
    fun lookupMethod self name = (GioDBusInterfaceInfoRecord.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GioDBusMethodInfoRecord.FFI.fromPtr false) lookupMethod_ (self & name) before GioDBusInterfaceInfoRecord.FFI.touchPtr self before Utf8.FFI.touchPtr name
    fun lookupProperty self name = (GioDBusInterfaceInfoRecord.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GioDBusPropertyInfoRecord.FFI.fromPtr false) lookupProperty_ (self & name) before GioDBusInterfaceInfoRecord.FFI.touchPtr self before Utf8.FFI.touchPtr name
    fun lookupSignal self name = (GioDBusInterfaceInfoRecord.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GioDBusSignalInfoRecord.FFI.fromPtr false) lookupSignal_ (self & name) before GioDBusInterfaceInfoRecord.FFI.touchPtr self before Utf8.FFI.touchPtr name
  end
