structure GioDBusNodeInfo :>
  GIO_D_BUS_NODE_INFO
    where type t = GioDBusNodeInfoRecord.t
    where type d_bus_interface_info_record_c_ptr_array_t = GioDBusInterfaceInfoRecordCPtrArray.t
    where type d_bus_node_info_record_c_ptr_array_t = GioDBusNodeInfoRecordCPtrArray.t
    where type d_bus_annotation_info_record_c_ptr_array_t = GioDBusAnnotationInfoRecordCPtrArray.t
    where type d_bus_interface_info_t = GioDBusInterfaceInfoRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "g_dbus_node_info_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val newForXml_ = call (getSymbol "g_dbus_node_info_new_for_xml") (Utf8.PolyML.cInPtr &&> GLibErrorRecord.PolyML.cOutOptRef --> GioDBusNodeInfoRecord.PolyML.cPtr)
      val generateXml_ =
        call (getSymbol "g_dbus_node_info_generate_xml")
          (
            GioDBusNodeInfoRecord.PolyML.cPtr
             &&> GUInt.PolyML.cVal
             &&> GLibStringRecord.PolyML.cPtr
             --> cVoid
          )
      val lookupInterface_ = call (getSymbol "g_dbus_node_info_lookup_interface") (GioDBusNodeInfoRecord.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GioDBusInterfaceInfoRecord.PolyML.cPtr)
      val refCount'Offset_ = call (getSymbol "giraffe_gio_d_bus_node_info_ref_count_offset") (cVoid --> GSize.PolyML.cVal)
      val path'Offset_ = call (getSymbol "giraffe_gio_d_bus_node_info_path_offset") (cVoid --> GSize.PolyML.cVal)
      val interfaces'Offset_ = call (getSymbol "giraffe_gio_d_bus_node_info_interfaces_offset") (cVoid --> GSize.PolyML.cVal)
      val nodes'Offset_ = call (getSymbol "giraffe_gio_d_bus_node_info_nodes_offset") (cVoid --> GSize.PolyML.cVal)
      val annotations'Offset_ = call (getSymbol "giraffe_gio_d_bus_node_info_annotations_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GioDBusNodeInfoRecord.t
    type d_bus_interface_info_record_c_ptr_array_t = GioDBusInterfaceInfoRecordCPtrArray.t
    type d_bus_node_info_record_c_ptr_array_t = GioDBusNodeInfoRecordCPtrArray.t
    type d_bus_annotation_info_record_c_ptr_array_t = GioDBusAnnotationInfoRecordCPtrArray.t
    type d_bus_interface_info_t = GioDBusInterfaceInfoRecord.t
    structure RefCountField =
      Field(
        structure Container = GioDBusNodeInfoRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) refCount'Offset_
      )
    structure PathField =
      Field(
        structure Container = GioDBusNodeInfoRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) path'Offset_
      )
    structure InterfacesField =
      Field(
        structure Container = GioDBusNodeInfoRecord
        structure FieldType = OptPointerFieldType(GioDBusInterfaceInfoRecordCPtrArray)
        val offset = (I ---> GSize.FFI.fromVal) interfaces'Offset_
      )
    structure NodesField =
      Field(
        structure Container = GioDBusNodeInfoRecord
        structure FieldType = OptPointerFieldType(GioDBusNodeInfoRecordCPtrArray)
        val offset = (I ---> GSize.FFI.fromVal) nodes'Offset_
      )
    structure AnnotationsField =
      Field(
        structure Container = GioDBusNodeInfoRecord
        structure FieldType = OptPointerFieldType(GioDBusAnnotationInfoRecordCPtrArray)
        val offset = (I ---> GSize.FFI.fromVal) annotations'Offset_
      )
    val refCount =
      {
        get = fn x => RefCountField.get x,
        set = fn x => RefCountField.set x
      }
    val path =
      {
        get = fn x => PathField.get x,
        set = fn x => PathField.set x
      }
    val interfaces =
      {
        get = fn x => InterfacesField.get x,
        set = fn x => InterfacesField.set x
      }
    val nodes =
      {
        get = fn x => NodesField.get x,
        set = fn x => NodesField.set x
      }
    val annotations =
      {
        get = fn x => AnnotationsField.get x,
        set = fn x => AnnotationsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun newForXml xmlData = (Utf8.FFI.withPtr 0 &&&> GLibErrorRecord.handleError ---> GioDBusNodeInfoRecord.FFI.fromPtr true) newForXml_ (xmlData & [])
    fun generateXml self (indent, stringBuilder) =
      (
        GioDBusNodeInfoRecord.FFI.withPtr false
         &&&> GUInt.FFI.withVal
         &&&> GLibStringRecord.FFI.withPtr false
         ---> I
      )
        generateXml_
        (
          self
           & indent
           & stringBuilder
        )
    fun lookupInterface self name = (GioDBusNodeInfoRecord.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GioDBusInterfaceInfoRecord.FFI.fromPtr false) lookupInterface_ (self & name) before GioDBusNodeInfoRecord.FFI.touchPtr self before Utf8.FFI.touchPtr name
  end
