structure GioDBusPropertyInfo :>
  GIO_D_BUS_PROPERTY_INFO
    where type t = GioDBusPropertyInfoRecord.t
    where type d_bus_property_info_flags_t = GioDBusPropertyInfoFlags.t
    where type d_bus_annotation_info_record_c_ptr_array_t = GioDBusAnnotationInfoRecordCPtrArray.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "g_dbus_property_info_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val refCount'Offset_ = call (getSymbol "giraffe_gio_d_bus_property_info_ref_count_offset") (cVoid --> GSize.PolyML.cVal)
      val name'Offset_ = call (getSymbol "giraffe_gio_d_bus_property_info_name_offset") (cVoid --> GSize.PolyML.cVal)
      val signature'Offset_ = call (getSymbol "giraffe_gio_d_bus_property_info_signature_offset") (cVoid --> GSize.PolyML.cVal)
      val flags'Offset_ = call (getSymbol "giraffe_gio_d_bus_property_info_flags_offset") (cVoid --> GSize.PolyML.cVal)
      val annotations'Offset_ = call (getSymbol "giraffe_gio_d_bus_property_info_annotations_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GioDBusPropertyInfoRecord.t
    type d_bus_property_info_flags_t = GioDBusPropertyInfoFlags.t
    type d_bus_annotation_info_record_c_ptr_array_t = GioDBusAnnotationInfoRecordCPtrArray.t
    structure RefCountField =
      Field(
        structure Container = GioDBusPropertyInfoRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) refCount'Offset_
      )
    structure NameField =
      Field(
        structure Container = GioDBusPropertyInfoRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) name'Offset_
      )
    structure SignatureField =
      Field(
        structure Container = GioDBusPropertyInfoRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) signature'Offset_
      )
    structure FlagsField =
      Field(
        structure Container = GioDBusPropertyInfoRecord
        structure FieldType = ValueFieldType(GioDBusPropertyInfoFlags)
        val offset = (I ---> GSize.FFI.fromVal) flags'Offset_
      )
    structure AnnotationsField =
      Field(
        structure Container = GioDBusPropertyInfoRecord
        structure FieldType = OptPointerFieldType(GioDBusAnnotationInfoRecordCPtrArray)
        val offset = (I ---> GSize.FFI.fromVal) annotations'Offset_
      )
    val refCount =
      {
        get = fn x => RefCountField.get x,
        set = fn x => RefCountField.set x
      }
    val name =
      {
        get = fn x => NameField.get x,
        set = fn x => NameField.set x
      }
    val signature' =
      {
        get = fn x => SignatureField.get x,
        set = fn x => SignatureField.set x
      }
    val flags =
      {
        get = fn x => FlagsField.get x,
        set = fn x => FlagsField.set x
      }
    val annotations =
      {
        get = fn x => AnnotationsField.get x,
        set = fn x => AnnotationsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
  end
