structure GioNetworkConnectivity :> GIO_NETWORK_CONNECTIVITY =
  struct
    datatype enum =
      LOCAL
    | LIMITED
    | PORTAL
    | FULL
    structure Enum =
      Enum(
        type enum = enum
        val null = LOCAL
        val toInt =
          fn
            LOCAL => 1
          | LIMITED => 2
          | PORTAL => 3
          | FULL => 4
        exception Value of GInt.t
        val fromInt =
          fn
            1 => LOCAL
          | 2 => LIMITED
          | 3 => PORTAL
          | 4 => FULL
          | n => raise Value n
      )
    open Enum
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "g_network_connectivity_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val getValue_ = call (getSymbol "g_value_get_enum") (GObjectValueRecord.PolyML.cPtr --> PolyML.cVal)
      val setValue_ = call (getSymbol "g_value_set_enum") (GObjectValueRecord.PolyML.cPtr &&> PolyML.cVal --> cVoid)
    end
    val t =
      ValueAccessor.C.createAccessor
        {
          getType = (I ---> GObjectType.FFI.fromVal) getType_,
          getValue = (I ---> FFI.fromVal) getValue_,
          setValue = (I &&&> FFI.withVal ---> I) setValue_
        }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
  end
