structure GLibError :>
  G_LIB_ERROR
    where type t = GLibErrorRecord.t
    where type quark_t = GLibQuark.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "g_error_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val domain'Offset_ = call (getSymbol "giraffe_g_lib_error_domain_offset") (cVoid --> GSize.PolyML.cVal)
      val code'Offset_ = call (getSymbol "giraffe_g_lib_error_code_offset") (cVoid --> GSize.PolyML.cVal)
      val message'Offset_ = call (getSymbol "giraffe_g_lib_error_message_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GLibErrorRecord.t
    type quark_t = GLibQuark.t
    structure DomainField =
      Field(
        structure Container = GLibErrorRecord
        structure FieldType = ValueFieldType(GLibQuark)
        val offset = (I ---> GSize.FFI.fromVal) domain'Offset_
      )
    structure CodeField =
      Field(
        structure Container = GLibErrorRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) code'Offset_
      )
    structure MessageField =
      Field(
        structure Container = GLibErrorRecord
        structure FieldType = PointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) message'Offset_
      )
    val domain =
      {
        get = fn x => DomainField.get x,
        set = fn x => DomainField.set x
      }
    val code =
      {
        get = fn x => CodeField.get x,
        set = fn x => CodeField.set x
      }
    val message =
      {
        get = fn x => MessageField.get x,
        set = fn x => MessageField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
  end
