structure GLibTimeVal :>
  G_LIB_TIME_VAL
    where type t = GLibTimeValRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val add_ = call (getSymbol "g_time_val_add") (GLibTimeValRecord.PolyML.cPtr &&> GLong.PolyML.cVal --> cVoid)
      val toIso8601_ = call (getSymbol "g_time_val_to_iso8601") (GLibTimeValRecord.PolyML.cPtr --> Utf8.PolyML.cOutPtr)
      val fromIso8601_ = call (getSymbol "g_time_val_from_iso8601") (Utf8.PolyML.cInPtr &&> GLibTimeValRecord.PolyML.cPtr --> GBool.PolyML.cVal)
      val tvSec'Offset_ = call (getSymbol "giraffe_g_lib_time_val_tv_sec_offset") (cVoid --> GSize.PolyML.cVal)
      val tvUsec'Offset_ = call (getSymbol "giraffe_g_lib_time_val_tv_usec_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GLibTimeValRecord.t
    structure TvSecField =
      Field(
        structure Container = GLibTimeValRecord
        structure FieldType = ValueFieldType(GLong)
        val offset = (I ---> GSize.FFI.fromVal) tvSec'Offset_
      )
    structure TvUsecField =
      Field(
        structure Container = GLibTimeValRecord
        structure FieldType = ValueFieldType(GLong)
        val offset = (I ---> GSize.FFI.fromVal) tvUsec'Offset_
      )
    val tvSec =
      {
        get = fn x => TvSecField.get x,
        set = fn x => TvSecField.set x
      }
    val tvUsec =
      {
        get = fn x => TvUsecField.get x,
        set = fn x => TvUsecField.set x
      }
    fun new
      {
        tvSec,
        tvUsec
      } =
      let
        fun init_ p =
          (
            TvSecField.C.set tvSec p;
            TvUsecField.C.set tvUsec p;
            ()
          )
        val retVal & () = (GLibTimeValRecord.FFI.withNewPtr ---> GLibTimeValRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
    fun add self microseconds = (GLibTimeValRecord.FFI.withPtr false &&&> GLong.FFI.withVal ---> I) add_ (self & microseconds)
    fun toIso8601 self = (GLibTimeValRecord.FFI.withPtr false ---> Utf8.FFI.fromPtr ~1) toIso8601_ self
    fun fromIso8601 isoDate =
      let
        val time & retVal = (Utf8.FFI.withPtr 0 &&&> GLibTimeValRecord.FFI.withNewPtr ---> GLibTimeValRecord.FFI.fromPtr true && GBool.FFI.fromVal) fromIso8601_ (isoDate & ())
      in
        if retVal then SOME time else NONE
      end
  end
