signature GTK_TEXT_ATTRIBUTES =
  sig
    type t
    type text_appearance_t
    type justification_t
    type text_direction_t
    type wrap_mode_t
    val appearance :
      {
        get : t -> text_appearance_t,
        set :
          text_appearance_t
           -> t
           -> unit
      }
    val justification :
      {
        get : t -> justification_t,
        set :
          justification_t
           -> t
           -> unit
      }
    val direction :
      {
        get : t -> text_direction_t,
        set :
          text_direction_t
           -> t
           -> unit
      }
    val font :
      {
        get : t -> Pango.FontDescriptionRecord.t option,
        set :
          Pango.FontDescriptionRecord.t option
           -> t
           -> unit
      }
    val fontScale :
      {
        get : t -> real,
        set :
          real
           -> t
           -> unit
      }
    val leftMargin :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val rightMargin :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val indent :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val pixelsAboveLines :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val pixelsBelowLines :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val pixelsInsideWrap :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val tabs :
      {
        get : t -> Pango.TabArrayRecord.t option,
        set :
          Pango.TabArrayRecord.t option
           -> t
           -> unit
      }
    val wrapMode :
      {
        get : t -> wrap_mode_t,
        set :
          wrap_mode_t
           -> t
           -> unit
      }
    val language :
      {
        get : t -> Pango.LanguageRecord.t option,
        set :
          Pango.LanguageRecord.t option
           -> t
           -> unit
      }
    val letterSpacing :
      {
        get : t -> LargeInt.int,
        set :
          LargeInt.int
           -> t
           -> unit
      }
    val getType : unit -> GObject.Type.t
    val new : unit -> t
    val copy : t -> t
    val copyValues :
      t
       -> t
       -> unit
  end
