structure GtkTextAttributes :>
  GTK_TEXT_ATTRIBUTES
    where type t = GtkTextAttributesRecord.t
    where type text_appearance_t = GtkTextAppearanceRecord.t
    where type justification_t = GtkJustification.t
    where type text_direction_t = GtkTextDirection.t
    where type wrap_mode_t = GtkWrapMode.t =
  struct
    val getType_ = _import "gtk_text_attributes_get_type" : unit -> GObjectType.FFI.val_;
    val new_ = _import "gtk_text_attributes_new" : unit -> GtkTextAttributesRecord.FFI.non_opt GtkTextAttributesRecord.FFI.p;
    val copy_ = _import "gtk_text_attributes_copy" : GtkTextAttributesRecord.FFI.non_opt GtkTextAttributesRecord.FFI.p -> GtkTextAttributesRecord.FFI.non_opt GtkTextAttributesRecord.FFI.p;
    val copyValues_ = fn x1 & x2 => (_import "gtk_text_attributes_copy_values" : GtkTextAttributesRecord.FFI.non_opt GtkTextAttributesRecord.FFI.p * GtkTextAttributesRecord.FFI.non_opt GtkTextAttributesRecord.FFI.p -> unit;) (x1, x2)
    val appearance'Offset_ = _import "giraffe_gtk_text_attributes_appearance_offset" : unit -> GSize.FFI.val_;
    val justification'Offset_ = _import "giraffe_gtk_text_attributes_justification_offset" : unit -> GSize.FFI.val_;
    val direction'Offset_ = _import "giraffe_gtk_text_attributes_direction_offset" : unit -> GSize.FFI.val_;
    val font'Offset_ = _import "giraffe_gtk_text_attributes_font_offset" : unit -> GSize.FFI.val_;
    val fontScale'Offset_ = _import "giraffe_gtk_text_attributes_font_scale_offset" : unit -> GSize.FFI.val_;
    val leftMargin'Offset_ = _import "giraffe_gtk_text_attributes_left_margin_offset" : unit -> GSize.FFI.val_;
    val rightMargin'Offset_ = _import "giraffe_gtk_text_attributes_right_margin_offset" : unit -> GSize.FFI.val_;
    val indent'Offset_ = _import "giraffe_gtk_text_attributes_indent_offset" : unit -> GSize.FFI.val_;
    val pixelsAboveLines'Offset_ = _import "giraffe_gtk_text_attributes_pixels_above_lines_offset" : unit -> GSize.FFI.val_;
    val pixelsBelowLines'Offset_ = _import "giraffe_gtk_text_attributes_pixels_below_lines_offset" : unit -> GSize.FFI.val_;
    val pixelsInsideWrap'Offset_ = _import "giraffe_gtk_text_attributes_pixels_inside_wrap_offset" : unit -> GSize.FFI.val_;
    val tabs'Offset_ = _import "giraffe_gtk_text_attributes_tabs_offset" : unit -> GSize.FFI.val_;
    val wrapMode'Offset_ = _import "giraffe_gtk_text_attributes_wrap_mode_offset" : unit -> GSize.FFI.val_;
    val language'Offset_ = _import "giraffe_gtk_text_attributes_language_offset" : unit -> GSize.FFI.val_;
    val letterSpacing'Offset_ = _import "giraffe_gtk_text_attributes_letter_spacing_offset" : unit -> GSize.FFI.val_;
    type t = GtkTextAttributesRecord.t
    type text_appearance_t = GtkTextAppearanceRecord.t
    type justification_t = GtkJustification.t
    type text_direction_t = GtkTextDirection.t
    type wrap_mode_t = GtkWrapMode.t
    structure AppearanceField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GtkTextAppearanceRecord)
        val offset = (I ---> GSize.FFI.fromVal) appearance'Offset_
      )
    structure JustificationField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GtkJustification)
        val offset = (I ---> GSize.FFI.fromVal) justification'Offset_
      )
    structure DirectionField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GtkTextDirection)
        val offset = (I ---> GSize.FFI.fromVal) direction'Offset_
      )
    structure FontField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = OptPointerFieldType(PangoFontDescriptionRecord)
        val offset = (I ---> GSize.FFI.fromVal) font'Offset_
      )
    structure FontScaleField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) fontScale'Offset_
      )
    structure LeftMarginField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) leftMargin'Offset_
      )
    structure RightMarginField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) rightMargin'Offset_
      )
    structure IndentField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) indent'Offset_
      )
    structure PixelsAboveLinesField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) pixelsAboveLines'Offset_
      )
    structure PixelsBelowLinesField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) pixelsBelowLines'Offset_
      )
    structure PixelsInsideWrapField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) pixelsInsideWrap'Offset_
      )
    structure TabsField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = OptPointerFieldType(PangoTabArrayRecord)
        val offset = (I ---> GSize.FFI.fromVal) tabs'Offset_
      )
    structure WrapModeField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GtkWrapMode)
        val offset = (I ---> GSize.FFI.fromVal) wrapMode'Offset_
      )
    structure LanguageField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = OptPointerFieldType(PangoLanguageRecord)
        val offset = (I ---> GSize.FFI.fromVal) language'Offset_
      )
    structure LetterSpacingField =
      Field(
        structure Container = GtkTextAttributesRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) letterSpacing'Offset_
      )
    val appearance =
      {
        get = fn x => AppearanceField.get x,
        set = fn x => AppearanceField.set x
      }
    val justification =
      {
        get = fn x => JustificationField.get x,
        set = fn x => JustificationField.set x
      }
    val direction =
      {
        get = fn x => DirectionField.get x,
        set = fn x => DirectionField.set x
      }
    val font =
      {
        get = fn x => FontField.get x,
        set = fn x => FontField.set x
      }
    val fontScale =
      {
        get = fn x => FontScaleField.get x,
        set = fn x => FontScaleField.set x
      }
    val leftMargin =
      {
        get = fn x => LeftMarginField.get x,
        set = fn x => LeftMarginField.set x
      }
    val rightMargin =
      {
        get = fn x => RightMarginField.get x,
        set = fn x => RightMarginField.set x
      }
    val indent =
      {
        get = fn x => IndentField.get x,
        set = fn x => IndentField.set x
      }
    val pixelsAboveLines =
      {
        get = fn x => PixelsAboveLinesField.get x,
        set = fn x => PixelsAboveLinesField.set x
      }
    val pixelsBelowLines =
      {
        get = fn x => PixelsBelowLinesField.get x,
        set = fn x => PixelsBelowLinesField.set x
      }
    val pixelsInsideWrap =
      {
        get = fn x => PixelsInsideWrapField.get x,
        set = fn x => PixelsInsideWrapField.set x
      }
    val tabs =
      {
        get = fn x => TabsField.get x,
        set = fn x => TabsField.set x
      }
    val wrapMode =
      {
        get = fn x => WrapModeField.get x,
        set = fn x => WrapModeField.set x
      }
    val language =
      {
        get = fn x => LanguageField.get x,
        set = fn x => LanguageField.set x
      }
    val letterSpacing =
      {
        get = fn x => LetterSpacingField.get x,
        set = fn x => LetterSpacingField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new () = (I ---> GtkTextAttributesRecord.FFI.fromPtr true) new_ ()
    fun copy self = (GtkTextAttributesRecord.FFI.withPtr false ---> GtkTextAttributesRecord.FFI.fromPtr true) copy_ self
    fun copyValues self dest = (GtkTextAttributesRecord.FFI.withPtr false &&&> GtkTextAttributesRecord.FFI.withPtr false ---> I) copyValues_ (self & dest)
  end
