structure GtkTreeView :>
  GTK_TREE_VIEW
    where type 'a class = 'a GtkTreeViewClass.class
    where type 'a buildable_class = 'a GtkBuildableClass.class
    where type 'a scrollable_class = 'a GtkScrollableClass.class
    where type target_entry_record_c_array_n_t = GtkTargetEntryRecordCArrayN.t
    where type 'a tree_selection_class = 'a GtkTreeSelectionClass.class
    where type tree_view_drop_position_t = GtkTreeViewDropPosition.t
    where type 'a entry_class = 'a GtkEntryClass.class
    where type 'a cell_renderer_class = 'a GtkCellRendererClass.class
    where type 'a tooltip_class = 'a GtkTooltipClass.class
    where type 'a adjustment_class = 'a GtkAdjustmentClass.class
    where type movement_step_t = GtkMovementStep.t
    where type tree_path_t = GtkTreePathRecord.t
    where type tree_iter_t = GtkTreeIterRecord.t
    where type tree_view_grid_lines_t = GtkTreeViewGridLines.t
    where type 'a tree_view_column_class = 'a GtkTreeViewColumnClass.class
    where type 'a tree_model_class = 'a GtkTreeModelClass.class =
  struct
    val getType_ = _import "gtk_tree_view_get_type" : unit -> GObjectType.FFI.val_;
    val new_ = _import "gtk_tree_view_new" : unit -> GtkWidgetClass.FFI.non_opt GtkWidgetClass.FFI.p;
    val newWithModel_ = _import "gtk_tree_view_new_with_model" : GtkTreeModelClass.FFI.non_opt GtkTreeModelClass.FFI.p -> GtkWidgetClass.FFI.non_opt GtkWidgetClass.FFI.p;
    val appendColumn_ = fn x1 & x2 => (_import "gtk_tree_view_append_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreeViewColumnClass.FFI.non_opt GtkTreeViewColumnClass.FFI.p -> GInt.FFI.val_;) (x1, x2)
    val collapseAll_ = _import "gtk_tree_view_collapse_all" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> unit;
    val collapseRow_ = fn x1 & x2 => (_import "gtk_tree_view_collapse_row" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p -> GBool.FFI.val_;) (x1, x2)
    val columnsAutosize_ = _import "gtk_tree_view_columns_autosize" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> unit;
    val convertBinWindowToTreeCoords_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_convert_bin_window_to_tree_coords" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val convertBinWindowToWidgetCoords_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_convert_bin_window_to_widget_coords" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val convertTreeToBinWindowCoords_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_convert_tree_to_bin_window_coords" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val convertTreeToWidgetCoords_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_convert_tree_to_widget_coords" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val convertWidgetToBinWindowCoords_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_convert_widget_to_bin_window_coords" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val convertWidgetToTreeCoords_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_convert_widget_to_tree_coords" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val createRowDragIcon_ = fn x1 & x2 => (_import "gtk_tree_view_create_row_drag_icon" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p -> CairoSurfaceRecord.FFI.non_opt CairoSurfaceRecord.FFI.p;) (x1, x2)
    val enableModelDragDest_ =
      fn
        x1
         & (x2, x3)
         & x4
         & x5 =>
          (
            _import "mlton_gtk_tree_view_enable_model_drag_dest" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTargetEntryRecordCArrayN.MLton.p1
               * GtkTargetEntryRecordCArrayN.FFI.non_opt GtkTargetEntryRecordCArrayN.MLton.p2
               * GInt.FFI.val_
               * GdkDragAction.FFI.val_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val enableModelDragSource_ =
      fn
        x1
         & x2
         & (x3, x4)
         & x5
         & x6 =>
          (
            _import "mlton_gtk_tree_view_enable_model_drag_source" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GdkModifierType.FFI.val_
               * GtkTargetEntryRecordCArrayN.MLton.p1
               * GtkTargetEntryRecordCArrayN.FFI.non_opt GtkTargetEntryRecordCArrayN.MLton.p2
               * GInt.FFI.val_
               * GdkDragAction.FFI.val_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5,
              x6
            )
    val expandAll_ = _import "gtk_tree_view_expand_all" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> unit;
    val expandRow_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_expand_row" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p
               * GBool.FFI.val_
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3
            )
    val expandToPath_ = fn x1 & x2 => (_import "gtk_tree_view_expand_to_path" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p -> unit;) (x1, x2)
    val getActivateOnSingleClick_ = _import "gtk_tree_view_get_activate_on_single_click" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getBackgroundArea_ =
      fn
        x1
         & x2
         & x3
         & x4 =>
          (
            _import "gtk_tree_view_get_background_area" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreePathRecord.FFI.opt GtkTreePathRecord.FFI.p
               * GtkTreeViewColumnClass.FFI.opt GtkTreeViewColumnClass.FFI.p
               * GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4
            )
    val getBinWindow_ = _import "gtk_tree_view_get_bin_window" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GdkWindowClass.FFI.opt GdkWindowClass.FFI.p;
    val getCellArea_ =
      fn
        x1
         & x2
         & x3
         & x4 =>
          (
            _import "gtk_tree_view_get_cell_area" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreePathRecord.FFI.opt GtkTreePathRecord.FFI.p
               * GtkTreeViewColumnClass.FFI.opt GtkTreeViewColumnClass.FFI.p
               * GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4
            )
    val getColumn_ = fn x1 & x2 => (_import "gtk_tree_view_get_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GInt.FFI.val_ -> GtkTreeViewColumnClass.FFI.opt GtkTreeViewColumnClass.FFI.p;) (x1, x2)
    val getCursor_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_get_cursor" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * (GtkTreePathRecord.FFI.opt, GtkTreePathRecord.FFI.opt) GtkTreePathRecord.FFI.r
               * (GtkTreeViewColumnClass.FFI.opt, GtkTreeViewColumnClass.FFI.opt) GtkTreeViewColumnClass.FFI.r
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val getDestRowAtPos_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_get_dest_row_at_pos" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * (GtkTreePathRecord.FFI.opt, GtkTreePathRecord.FFI.opt) GtkTreePathRecord.FFI.r
               * GtkTreeViewDropPosition.FFI.ref_
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val getDragDestRow_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_get_drag_dest_row" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * (GtkTreePathRecord.FFI.opt, GtkTreePathRecord.FFI.opt) GtkTreePathRecord.FFI.r
               * GtkTreeViewDropPosition.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val getEnableSearch_ = _import "gtk_tree_view_get_enable_search" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getEnableTreeLines_ = _import "gtk_tree_view_get_enable_tree_lines" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getExpanderColumn_ = _import "gtk_tree_view_get_expander_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GtkTreeViewColumnClass.FFI.non_opt GtkTreeViewColumnClass.FFI.p;
    val getFixedHeightMode_ = _import "gtk_tree_view_get_fixed_height_mode" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getGridLines_ = _import "gtk_tree_view_get_grid_lines" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GtkTreeViewGridLines.FFI.val_;
    val getHadjustment_ = _import "gtk_tree_view_get_hadjustment" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GtkAdjustmentClass.FFI.non_opt GtkAdjustmentClass.FFI.p;
    val getHeadersClickable_ = _import "gtk_tree_view_get_headers_clickable" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getHeadersVisible_ = _import "gtk_tree_view_get_headers_visible" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getHoverExpand_ = _import "gtk_tree_view_get_hover_expand" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getHoverSelection_ = _import "gtk_tree_view_get_hover_selection" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getLevelIndentation_ = _import "gtk_tree_view_get_level_indentation" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GInt.FFI.val_;
    val getModel_ = _import "gtk_tree_view_get_model" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GtkTreeModelClass.FFI.opt GtkTreeModelClass.FFI.p;
    val getNColumns_ = _import "gtk_tree_view_get_n_columns" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GUInt.FFI.val_;
    val getPathAtPos_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5
         & x6
         & x7 =>
          (
            _import "gtk_tree_view_get_path_at_pos" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * (GtkTreePathRecord.FFI.opt, GtkTreePathRecord.FFI.opt) GtkTreePathRecord.FFI.r
               * (GtkTreeViewColumnClass.FFI.opt, GtkTreeViewColumnClass.FFI.opt) GtkTreeViewColumnClass.FFI.r
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5,
              x6,
              x7
            )
    val getReorderable_ = _import "gtk_tree_view_get_reorderable" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getRubberBanding_ = _import "gtk_tree_view_get_rubber_banding" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getRulesHint_ = _import "gtk_tree_view_get_rules_hint" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getSearchColumn_ = _import "gtk_tree_view_get_search_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GInt.FFI.val_;
    val getSearchEntry_ = _import "gtk_tree_view_get_search_entry" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GtkEntryClass.FFI.non_opt GtkEntryClass.FFI.p;
    val getSelection_ = _import "gtk_tree_view_get_selection" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GtkTreeSelectionClass.FFI.non_opt GtkTreeSelectionClass.FFI.p;
    val getShowExpanders_ = _import "gtk_tree_view_get_show_expanders" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val getTooltipColumn_ = _import "gtk_tree_view_get_tooltip_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GInt.FFI.val_;
    val getTooltipContext_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5
         & x6
         & x7 =>
          (
            _import "gtk_tree_view_get_tooltip_context" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               * GBool.FFI.val_
               * (GtkTreeModelClass.FFI.opt, GtkTreeModelClass.FFI.opt) GtkTreeModelClass.FFI.r
               * (GtkTreePathRecord.FFI.opt, GtkTreePathRecord.FFI.non_opt) GtkTreePathRecord.FFI.r
               * GtkTreeIterRecord.FFI.non_opt GtkTreeIterRecord.FFI.p
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5,
              x6,
              x7
            )
    val getVadjustment_ = _import "gtk_tree_view_get_vadjustment" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GtkAdjustmentClass.FFI.non_opt GtkAdjustmentClass.FFI.p;
    val getVisibleRange_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_get_visible_range" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * (GtkTreePathRecord.FFI.opt, GtkTreePathRecord.FFI.non_opt) GtkTreePathRecord.FFI.r
               * (GtkTreePathRecord.FFI.opt, GtkTreePathRecord.FFI.non_opt) GtkTreePathRecord.FFI.r
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3
            )
    val getVisibleRect_ = fn x1 & x2 => (_import "gtk_tree_view_get_visible_rect" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GdkRectangleRecord.FFI.non_opt GdkRectangleRecord.FFI.p -> unit;) (x1, x2)
    val insertColumn_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_insert_column" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreeViewColumnClass.FFI.non_opt GtkTreeViewColumnClass.FFI.p
               * GInt.FFI.val_
               -> GInt.FFI.val_;
          )
            (
              x1,
              x2,
              x3
            )
    val isBlankAtPos_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5
         & x6
         & x7 =>
          (
            _import "gtk_tree_view_is_blank_at_pos" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * (GtkTreePathRecord.FFI.opt, GtkTreePathRecord.FFI.non_opt) GtkTreePathRecord.FFI.r
               * (GtkTreeViewColumnClass.FFI.opt, GtkTreeViewColumnClass.FFI.non_opt) GtkTreeViewColumnClass.FFI.r
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5,
              x6,
              x7
            )
    val isRubberBandingActive_ = _import "gtk_tree_view_is_rubber_banding_active" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> GBool.FFI.val_;
    val moveColumnAfter_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_move_column_after" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreeViewColumnClass.FFI.non_opt GtkTreeViewColumnClass.FFI.p
               * GtkTreeViewColumnClass.FFI.opt GtkTreeViewColumnClass.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val removeColumn_ = fn x1 & x2 => (_import "gtk_tree_view_remove_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreeViewColumnClass.FFI.non_opt GtkTreeViewColumnClass.FFI.p -> GInt.FFI.val_;) (x1, x2)
    val rowActivated_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_row_activated" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p
               * GtkTreeViewColumnClass.FFI.non_opt GtkTreeViewColumnClass.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val rowExpanded_ = fn x1 & x2 => (_import "gtk_tree_view_row_expanded" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p -> GBool.FFI.val_;) (x1, x2)
    val scrollToCell_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5
         & x6 =>
          (
            _import "gtk_tree_view_scroll_to_cell" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreePathRecord.FFI.opt GtkTreePathRecord.FFI.p
               * GtkTreeViewColumnClass.FFI.opt GtkTreeViewColumnClass.FFI.p
               * GBool.FFI.val_
               * GFloat.FFI.val_
               * GFloat.FFI.val_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5,
              x6
            )
    val scrollToPoint_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_scroll_to_point" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val setActivateOnSingleClick_ = fn x1 & x2 => (_import "gtk_tree_view_set_activate_on_single_click" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setCursor_ =
      fn
        x1
         & x2
         & x3
         & x4 =>
          (
            _import "gtk_tree_view_set_cursor" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p
               * GtkTreeViewColumnClass.FFI.opt GtkTreeViewColumnClass.FFI.p
               * GBool.FFI.val_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4
            )
    val setCursorOnCell_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_set_cursor_on_cell" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p
               * GtkTreeViewColumnClass.FFI.opt GtkTreeViewColumnClass.FFI.p
               * GtkCellRendererClass.FFI.opt GtkCellRendererClass.FFI.p
               * GBool.FFI.val_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val setDragDestRow_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_set_drag_dest_row" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTreePathRecord.FFI.opt GtkTreePathRecord.FFI.p
               * GtkTreeViewDropPosition.FFI.val_
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val setEnableSearch_ = fn x1 & x2 => (_import "gtk_tree_view_set_enable_search" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setEnableTreeLines_ = fn x1 & x2 => (_import "gtk_tree_view_set_enable_tree_lines" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setExpanderColumn_ = fn x1 & x2 => (_import "gtk_tree_view_set_expander_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreeViewColumnClass.FFI.non_opt GtkTreeViewColumnClass.FFI.p -> unit;) (x1, x2)
    val setFixedHeightMode_ = fn x1 & x2 => (_import "gtk_tree_view_set_fixed_height_mode" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setGridLines_ = fn x1 & x2 => (_import "gtk_tree_view_set_grid_lines" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreeViewGridLines.FFI.val_ -> unit;) (x1, x2)
    val setHadjustment_ = fn x1 & x2 => (_import "gtk_tree_view_set_hadjustment" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkAdjustmentClass.FFI.opt GtkAdjustmentClass.FFI.p -> unit;) (x1, x2)
    val setHeadersClickable_ = fn x1 & x2 => (_import "gtk_tree_view_set_headers_clickable" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setHeadersVisible_ = fn x1 & x2 => (_import "gtk_tree_view_set_headers_visible" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setHoverExpand_ = fn x1 & x2 => (_import "gtk_tree_view_set_hover_expand" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setHoverSelection_ = fn x1 & x2 => (_import "gtk_tree_view_set_hover_selection" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setLevelIndentation_ = fn x1 & x2 => (_import "gtk_tree_view_set_level_indentation" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GInt.FFI.val_ -> unit;) (x1, x2)
    val setModel_ = fn x1 & x2 => (_import "gtk_tree_view_set_model" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkTreeModelClass.FFI.opt GtkTreeModelClass.FFI.p -> unit;) (x1, x2)
    val setReorderable_ = fn x1 & x2 => (_import "gtk_tree_view_set_reorderable" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setRubberBanding_ = fn x1 & x2 => (_import "gtk_tree_view_set_rubber_banding" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setRulesHint_ = fn x1 & x2 => (_import "gtk_tree_view_set_rules_hint" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setSearchColumn_ = fn x1 & x2 => (_import "gtk_tree_view_set_search_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GInt.FFI.val_ -> unit;) (x1, x2)
    val setSearchEntry_ = fn x1 & x2 => (_import "gtk_tree_view_set_search_entry" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkEntryClass.FFI.opt GtkEntryClass.FFI.p -> unit;) (x1, x2)
    val setShowExpanders_ = fn x1 & x2 => (_import "gtk_tree_view_set_show_expanders" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GBool.FFI.val_ -> unit;) (x1, x2)
    val setTooltipCell_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5 =>
          (
            _import "gtk_tree_view_set_tooltip_cell" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTooltipClass.FFI.non_opt GtkTooltipClass.FFI.p
               * GtkTreePathRecord.FFI.opt GtkTreePathRecord.FFI.p
               * GtkTreeViewColumnClass.FFI.opt GtkTreeViewColumnClass.FFI.p
               * GtkCellRendererClass.FFI.opt GtkCellRendererClass.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5
            )
    val setTooltipColumn_ = fn x1 & x2 => (_import "gtk_tree_view_set_tooltip_column" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GInt.FFI.val_ -> unit;) (x1, x2)
    val setTooltipRow_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "gtk_tree_view_set_tooltip_row" :
              GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p
               * GtkTooltipClass.FFI.non_opt GtkTooltipClass.FFI.p
               * GtkTreePathRecord.FFI.non_opt GtkTreePathRecord.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val setVadjustment_ = fn x1 & x2 => (_import "gtk_tree_view_set_vadjustment" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p * GtkAdjustmentClass.FFI.opt GtkAdjustmentClass.FFI.p -> unit;) (x1, x2)
    val unsetRowsDragDest_ = _import "gtk_tree_view_unset_rows_drag_dest" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> unit;
    val unsetRowsDragSource_ = _import "gtk_tree_view_unset_rows_drag_source" : GtkTreeViewClass.FFI.non_opt GtkTreeViewClass.FFI.p -> unit;
    type 'a class = 'a GtkTreeViewClass.class
    type 'a buildable_class = 'a GtkBuildableClass.class
    type 'a scrollable_class = 'a GtkScrollableClass.class
    type target_entry_record_c_array_n_t = GtkTargetEntryRecordCArrayN.t
    type 'a tree_selection_class = 'a GtkTreeSelectionClass.class
    type tree_view_drop_position_t = GtkTreeViewDropPosition.t
    type 'a entry_class = 'a GtkEntryClass.class
    type 'a cell_renderer_class = 'a GtkCellRendererClass.class
    type 'a tooltip_class = 'a GtkTooltipClass.class
    type 'a adjustment_class = 'a GtkAdjustmentClass.class
    type movement_step_t = GtkMovementStep.t
    type tree_path_t = GtkTreePathRecord.t
    type tree_iter_t = GtkTreeIterRecord.t
    type tree_view_grid_lines_t = GtkTreeViewGridLines.t
    type 'a tree_view_column_class = 'a GtkTreeViewColumnClass.class
    type 'a tree_model_class = 'a GtkTreeModelClass.class
    type t = base class
    fun asImplementorIface self = (GObjectObjectClass.FFI.withPtr false ---> AtkImplementorIfaceClass.FFI.fromPtr false) I self
    fun asBuildable self = (GObjectObjectClass.FFI.withPtr false ---> GtkBuildableClass.FFI.fromPtr false) I self
    fun asScrollable self = (GObjectObjectClass.FFI.withPtr false ---> GtkScrollableClass.FFI.fromPtr false) I self
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new () = (I ---> GtkTreeViewClass.FFI.fromPtr false) new_ ()
    fun newWithModel model = (GtkTreeModelClass.FFI.withPtr false ---> GtkTreeViewClass.FFI.fromPtr false) newWithModel_ model before GtkTreeModelClass.FFI.touchPtr model
    fun appendColumn self column = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreeViewColumnClass.FFI.withPtr false ---> GInt.FFI.fromVal) appendColumn_ (self & column)
    fun collapseAll self = (GtkTreeViewClass.FFI.withPtr false ---> I) collapseAll_ self
    fun collapseRow self path = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreePathRecord.FFI.withPtr false ---> GBool.FFI.fromVal) collapseRow_ (self & path)
    fun columnsAutosize self = (GtkTreeViewClass.FFI.withPtr false ---> I) columnsAutosize_ self
    fun convertBinWindowToTreeCoords self (bx, by) =
      let
        val tx
         & ty
         & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && I
          )
            convertBinWindowToTreeCoords_
            (
              self
               & bx
               & by
               & GInt.null
               & GInt.null
            )
      in
        (tx, ty)
      end
    fun convertBinWindowToWidgetCoords self (bx, by) =
      let
        val wx
         & wy
         & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && I
          )
            convertBinWindowToWidgetCoords_
            (
              self
               & bx
               & by
               & GInt.null
               & GInt.null
            )
      in
        (wx, wy)
      end
    fun convertTreeToBinWindowCoords self (tx, ty) =
      let
        val bx
         & by
         & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && I
          )
            convertTreeToBinWindowCoords_
            (
              self
               & tx
               & ty
               & GInt.null
               & GInt.null
            )
      in
        (bx, by)
      end
    fun convertTreeToWidgetCoords self (tx, ty) =
      let
        val wx
         & wy
         & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && I
          )
            convertTreeToWidgetCoords_
            (
              self
               & tx
               & ty
               & GInt.null
               & GInt.null
            )
      in
        (wx, wy)
      end
    fun convertWidgetToBinWindowCoords self (wx, wy) =
      let
        val bx
         & by
         & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && I
          )
            convertWidgetToBinWindowCoords_
            (
              self
               & wx
               & wy
               & GInt.null
               & GInt.null
            )
      in
        (bx, by)
      end
    fun convertWidgetToTreeCoords self (wx, wy) =
      let
        val tx
         & ty
         & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && I
          )
            convertWidgetToTreeCoords_
            (
              self
               & wx
               & wy
               & GInt.null
               & GInt.null
            )
      in
        (tx, ty)
      end
    fun createRowDragIcon self path = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreePathRecord.FFI.withPtr false ---> CairoSurfaceRecord.FFI.fromPtr true) createRowDragIcon_ (self & path)
    fun enableModelDragDest self (targets, actions) =
      let
        val nTargets = LargeInt.fromInt (GtkTargetEntryRecordCArrayN.length targets)
        val () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GtkTargetEntryRecordCArrayN.FFI.withPtr 0
             &&&> GInt.FFI.withVal
             &&&> GdkDragAction.FFI.withVal
             ---> I
          )
            enableModelDragDest_
            (
              self
               & targets
               & nTargets
               & actions
            )
      in
        ()
      end
    fun enableModelDragSource
      self
      (
        startButtonMask,
        targets,
        actions
      ) =
      let
        val nTargets = LargeInt.fromInt (GtkTargetEntryRecordCArrayN.length targets)
        val () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GdkModifierType.FFI.withVal
             &&&> GtkTargetEntryRecordCArrayN.FFI.withPtr 0
             &&&> GInt.FFI.withVal
             &&&> GdkDragAction.FFI.withVal
             ---> I
          )
            enableModelDragSource_
            (
              self
               & startButtonMask
               & targets
               & nTargets
               & actions
            )
      in
        ()
      end
    fun expandAll self = (GtkTreeViewClass.FFI.withPtr false ---> I) expandAll_ self
    fun expandRow self (path, openAll) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTreePathRecord.FFI.withPtr false
         &&&> GBool.FFI.withVal
         ---> GBool.FFI.fromVal
      )
        expandRow_
        (
          self
           & path
           & openAll
        )
    fun expandToPath self path = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreePathRecord.FFI.withPtr false ---> I) expandToPath_ (self & path)
    fun getActivateOnSingleClick self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getActivateOnSingleClick_ self
    fun getBackgroundArea self (path, column) =
      let
        val rect & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GtkTreePathRecord.FFI.withOptPtr false
             &&&> GtkTreeViewColumnClass.FFI.withOptPtr false
             &&&> GdkRectangleRecord.FFI.withNewPtr
             ---> GdkRectangleRecord.FFI.fromPtr true && I
          )
            getBackgroundArea_
            (
              self
               & path
               & column
               & ()
            )
      in
        rect
      end
    fun getBinWindow self = (GtkTreeViewClass.FFI.withPtr false ---> GdkWindowClass.FFI.fromOptPtr false) getBinWindow_ self before GtkTreeViewClass.FFI.touchPtr self
    fun getCellArea self (path, column) =
      let
        val rect & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GtkTreePathRecord.FFI.withOptPtr false
             &&&> GtkTreeViewColumnClass.FFI.withOptPtr false
             &&&> GdkRectangleRecord.FFI.withNewPtr
             ---> GdkRectangleRecord.FFI.fromPtr true && I
          )
            getCellArea_
            (
              self
               & path
               & column
               & ()
            )
      in
        rect
      end
    fun getColumn self n = (GtkTreeViewClass.FFI.withPtr false &&&> GInt.FFI.withVal ---> GtkTreeViewColumnClass.FFI.fromOptPtr false) getColumn_ (self & n) before GtkTreeViewClass.FFI.touchPtr self
    fun getCursor self =
      let
        val path
         & focusColumn
         & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GtkTreePathRecord.FFI.withRefOptPtr true
             &&&> GtkTreeViewColumnClass.FFI.withRefOptPtr false
             ---> GtkTreePathRecord.FFI.fromOptPtr true
                   && GtkTreeViewColumnClass.FFI.fromOptPtr false
                   && I
          )
            getCursor_
            (
              self
               & NONE
               & NONE
            )
      in
        (path, focusColumn) before GtkTreeViewClass.FFI.touchPtr self
      end
    fun getDestRowAtPos self (dragX, dragY) =
      let
        val path
         & pos
         & retVal =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GtkTreePathRecord.FFI.withRefOptPtr true
             &&&> GtkTreeViewDropPosition.FFI.withRefVal
             ---> GtkTreePathRecord.FFI.fromOptPtr true
                   && GtkTreeViewDropPosition.FFI.fromVal
                   && GBool.FFI.fromVal
          )
            getDestRowAtPos_
            (
              self
               & dragX
               & dragY
               & NONE
               & GtkTreeViewDropPosition.null
            )
      in
        if retVal then SOME (path, pos) else NONE
      end
    fun getDragDestRow self =
      let
        val path
         & pos
         & () =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GtkTreePathRecord.FFI.withRefOptPtr true
             &&&> GtkTreeViewDropPosition.FFI.withRefVal
             ---> GtkTreePathRecord.FFI.fromOptPtr true
                   && GtkTreeViewDropPosition.FFI.fromVal
                   && I
          )
            getDragDestRow_
            (
              self
               & NONE
               & GtkTreeViewDropPosition.null
            )
      in
        (path, pos)
      end
    fun getEnableSearch self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getEnableSearch_ self
    fun getEnableTreeLines self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getEnableTreeLines_ self
    fun getExpanderColumn self = (GtkTreeViewClass.FFI.withPtr false ---> GtkTreeViewColumnClass.FFI.fromPtr false) getExpanderColumn_ self before GtkTreeViewClass.FFI.touchPtr self
    fun getFixedHeightMode self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getFixedHeightMode_ self
    fun getGridLines self = (GtkTreeViewClass.FFI.withPtr false ---> GtkTreeViewGridLines.FFI.fromVal) getGridLines_ self
    fun getHadjustment self = (GtkTreeViewClass.FFI.withPtr false ---> GtkAdjustmentClass.FFI.fromPtr false) getHadjustment_ self before GtkTreeViewClass.FFI.touchPtr self
    fun getHeadersClickable self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getHeadersClickable_ self
    fun getHeadersVisible self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getHeadersVisible_ self
    fun getHoverExpand self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getHoverExpand_ self
    fun getHoverSelection self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getHoverSelection_ self
    fun getLevelIndentation self = (GtkTreeViewClass.FFI.withPtr false ---> GInt.FFI.fromVal) getLevelIndentation_ self
    fun getModel self = (GtkTreeViewClass.FFI.withPtr false ---> GtkTreeModelClass.FFI.fromOptPtr false) getModel_ self before GtkTreeViewClass.FFI.touchPtr self
    fun getNColumns self = (GtkTreeViewClass.FFI.withPtr false ---> GUInt.FFI.fromVal) getNColumns_ self
    fun getPathAtPos self (x, y) =
      let
        val path
         & column
         & cellX
         & cellY
         & retVal =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GtkTreePathRecord.FFI.withRefOptPtr true
             &&&> GtkTreeViewColumnClass.FFI.withRefOptPtr false
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GtkTreePathRecord.FFI.fromOptPtr true
                   && GtkTreeViewColumnClass.FFI.fromOptPtr false
                   && GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && GBool.FFI.fromVal
          )
            getPathAtPos_
            (
              self
               & x
               & y
               & NONE
               & NONE
               & GInt.null
               & GInt.null
            )
      in
        (
          if retVal
          then
            SOME
              (
                path,
                column,
                cellX,
                cellY
              )
          else NONE
        )
         before GtkTreeViewClass.FFI.touchPtr self
      end
    fun getReorderable self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getReorderable_ self
    fun getRubberBanding self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getRubberBanding_ self
    fun getRulesHint self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getRulesHint_ self
    fun getSearchColumn self = (GtkTreeViewClass.FFI.withPtr false ---> GInt.FFI.fromVal) getSearchColumn_ self
    fun getSearchEntry self = (GtkTreeViewClass.FFI.withPtr false ---> GtkEntryClass.FFI.fromPtr false) getSearchEntry_ self before GtkTreeViewClass.FFI.touchPtr self
    fun getSelection self = (GtkTreeViewClass.FFI.withPtr false ---> GtkTreeSelectionClass.FFI.fromPtr false) getSelection_ self before GtkTreeViewClass.FFI.touchPtr self
    fun getShowExpanders self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) getShowExpanders_ self
    fun getTooltipColumn self = (GtkTreeViewClass.FFI.withPtr false ---> GInt.FFI.fromVal) getTooltipColumn_ self
    fun getTooltipContext
      self
      (
        x,
        y,
        keyboardTip
      ) =
      let
        val x
         & y
         & model
         & path
         & iter
         & retVal =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             &&&> GBool.FFI.withVal
             &&&> GtkTreeModelClass.FFI.withRefOptPtr false
             &&&> GtkTreePathRecord.FFI.withRefOptPtr true
             &&&> GtkTreeIterRecord.FFI.withNewPtr
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && GtkTreeModelClass.FFI.fromOptPtr false
                   && GtkTreePathRecord.FFI.fromPtr true
                   && GtkTreeIterRecord.FFI.fromPtr true
                   && GBool.FFI.fromVal
          )
            getTooltipContext_
            (
              self
               & x
               & y
               & keyboardTip
               & NONE
               & NONE
               & ()
            )
      in
        (
          if retVal
          then
            SOME
              (
                model,
                path,
                iter
              )
          else NONE,
          x,
          y
        )
         before GtkTreeViewClass.FFI.touchPtr self
      end
    fun getVadjustment self = (GtkTreeViewClass.FFI.withPtr false ---> GtkAdjustmentClass.FFI.fromPtr false) getVadjustment_ self before GtkTreeViewClass.FFI.touchPtr self
    fun getVisibleRange self =
      let
        val startPath
         & endPath
         & retVal =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GtkTreePathRecord.FFI.withRefOptPtr true
             &&&> GtkTreePathRecord.FFI.withRefOptPtr true
             ---> GtkTreePathRecord.FFI.fromPtr true
                   && GtkTreePathRecord.FFI.fromPtr true
                   && GBool.FFI.fromVal
          )
            getVisibleRange_
            (
              self
               & NONE
               & NONE
            )
      in
        if retVal then SOME (startPath, endPath) else NONE
      end
    fun getVisibleRect self =
      let
        val visibleRect & () = (GtkTreeViewClass.FFI.withPtr false &&&> GdkRectangleRecord.FFI.withNewPtr ---> GdkRectangleRecord.FFI.fromPtr true && I) getVisibleRect_ (self & ())
      in
        visibleRect
      end
    fun insertColumn self (column, position) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTreeViewColumnClass.FFI.withPtr false
         &&&> GInt.FFI.withVal
         ---> GInt.FFI.fromVal
      )
        insertColumn_
        (
          self
           & column
           & position
        )
    fun isBlankAtPos self (x, y) =
      let
        val path
         & column
         & cellX
         & cellY
         & retVal =
          (
            GtkTreeViewClass.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GtkTreePathRecord.FFI.withRefOptPtr true
             &&&> GtkTreeViewColumnClass.FFI.withRefOptPtr true
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GtkTreePathRecord.FFI.fromPtr true
                   && GtkTreeViewColumnClass.FFI.fromPtr true
                   && GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && GBool.FFI.fromVal
          )
            isBlankAtPos_
            (
              self
               & x
               & y
               & NONE
               & NONE
               & GInt.null
               & GInt.null
            )
      in
        if retVal
        then
          SOME
            (
              path,
              column,
              cellX,
              cellY
            )
        else NONE
      end
    fun isRubberBandingActive self = (GtkTreeViewClass.FFI.withPtr false ---> GBool.FFI.fromVal) isRubberBandingActive_ self
    fun moveColumnAfter self (column, baseColumn) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTreeViewColumnClass.FFI.withPtr false
         &&&> GtkTreeViewColumnClass.FFI.withOptPtr false
         ---> I
      )
        moveColumnAfter_
        (
          self
           & column
           & baseColumn
        )
    fun removeColumn self column = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreeViewColumnClass.FFI.withPtr false ---> GInt.FFI.fromVal) removeColumn_ (self & column)
    fun rowActivated self (path, column) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTreePathRecord.FFI.withPtr false
         &&&> GtkTreeViewColumnClass.FFI.withPtr false
         ---> I
      )
        rowActivated_
        (
          self
           & path
           & column
        )
    fun rowExpanded self path = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreePathRecord.FFI.withPtr false ---> GBool.FFI.fromVal) rowExpanded_ (self & path)
    fun scrollToCell
      self
      (
        path,
        column,
        useAlign,
        rowAlign,
        colAlign
      ) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTreePathRecord.FFI.withOptPtr false
         &&&> GtkTreeViewColumnClass.FFI.withOptPtr false
         &&&> GBool.FFI.withVal
         &&&> GFloat.FFI.withVal
         &&&> GFloat.FFI.withVal
         ---> I
      )
        scrollToCell_
        (
          self
           & path
           & column
           & useAlign
           & rowAlign
           & colAlign
        )
    fun scrollToPoint self (treeX, treeY) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GInt.FFI.withVal
         &&&> GInt.FFI.withVal
         ---> I
      )
        scrollToPoint_
        (
          self
           & treeX
           & treeY
        )
    fun setActivateOnSingleClick self single = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setActivateOnSingleClick_ (self & single)
    fun setCursor
      self
      (
        path,
        focusColumn,
        startEditing
      ) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTreePathRecord.FFI.withPtr false
         &&&> GtkTreeViewColumnClass.FFI.withOptPtr false
         &&&> GBool.FFI.withVal
         ---> I
      )
        setCursor_
        (
          self
           & path
           & focusColumn
           & startEditing
        )
    fun setCursorOnCell
      self
      (
        path,
        focusColumn,
        focusCell,
        startEditing
      ) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTreePathRecord.FFI.withPtr false
         &&&> GtkTreeViewColumnClass.FFI.withOptPtr false
         &&&> GtkCellRendererClass.FFI.withOptPtr false
         &&&> GBool.FFI.withVal
         ---> I
      )
        setCursorOnCell_
        (
          self
           & path
           & focusColumn
           & focusCell
           & startEditing
        )
    fun setDragDestRow self (path, pos) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTreePathRecord.FFI.withOptPtr false
         &&&> GtkTreeViewDropPosition.FFI.withVal
         ---> I
      )
        setDragDestRow_
        (
          self
           & path
           & pos
        )
    fun setEnableSearch self enableSearch = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setEnableSearch_ (self & enableSearch)
    fun setEnableTreeLines self enabled = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setEnableTreeLines_ (self & enabled)
    fun setExpanderColumn self column = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreeViewColumnClass.FFI.withPtr false ---> I) setExpanderColumn_ (self & column)
    fun setFixedHeightMode self enable = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setFixedHeightMode_ (self & enable)
    fun setGridLines self gridLines = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreeViewGridLines.FFI.withVal ---> I) setGridLines_ (self & gridLines)
    fun setHadjustment self adjustment = (GtkTreeViewClass.FFI.withPtr false &&&> GtkAdjustmentClass.FFI.withOptPtr false ---> I) setHadjustment_ (self & adjustment)
    fun setHeadersClickable self setting = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setHeadersClickable_ (self & setting)
    fun setHeadersVisible self headersVisible = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setHeadersVisible_ (self & headersVisible)
    fun setHoverExpand self expand = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setHoverExpand_ (self & expand)
    fun setHoverSelection self hover = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setHoverSelection_ (self & hover)
    fun setLevelIndentation self indentation = (GtkTreeViewClass.FFI.withPtr false &&&> GInt.FFI.withVal ---> I) setLevelIndentation_ (self & indentation)
    fun setModel self model = (GtkTreeViewClass.FFI.withPtr false &&&> GtkTreeModelClass.FFI.withOptPtr false ---> I) setModel_ (self & model)
    fun setReorderable self reorderable = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setReorderable_ (self & reorderable)
    fun setRubberBanding self enable = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setRubberBanding_ (self & enable)
    fun setRulesHint self setting = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setRulesHint_ (self & setting)
    fun setSearchColumn self column = (GtkTreeViewClass.FFI.withPtr false &&&> GInt.FFI.withVal ---> I) setSearchColumn_ (self & column)
    fun setSearchEntry self entry = (GtkTreeViewClass.FFI.withPtr false &&&> GtkEntryClass.FFI.withOptPtr false ---> I) setSearchEntry_ (self & entry)
    fun setShowExpanders self enabled = (GtkTreeViewClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setShowExpanders_ (self & enabled)
    fun setTooltipCell
      self
      (
        tooltip,
        path,
        column,
        cell
      ) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTooltipClass.FFI.withPtr false
         &&&> GtkTreePathRecord.FFI.withOptPtr false
         &&&> GtkTreeViewColumnClass.FFI.withOptPtr false
         &&&> GtkCellRendererClass.FFI.withOptPtr false
         ---> I
      )
        setTooltipCell_
        (
          self
           & tooltip
           & path
           & column
           & cell
        )
    fun setTooltipColumn self column = (GtkTreeViewClass.FFI.withPtr false &&&> GInt.FFI.withVal ---> I) setTooltipColumn_ (self & column)
    fun setTooltipRow self (tooltip, path) =
      (
        GtkTreeViewClass.FFI.withPtr false
         &&&> GtkTooltipClass.FFI.withPtr false
         &&&> GtkTreePathRecord.FFI.withPtr false
         ---> I
      )
        setTooltipRow_
        (
          self
           & tooltip
           & path
        )
    fun setVadjustment self adjustment = (GtkTreeViewClass.FFI.withPtr false &&&> GtkAdjustmentClass.FFI.withOptPtr false ---> I) setVadjustment_ (self & adjustment)
    fun unsetRowsDragDest self = (GtkTreeViewClass.FFI.withPtr false ---> I) unsetRowsDragDest_ self
    fun unsetRowsDragSource self = (GtkTreeViewClass.FFI.withPtr false ---> I) unsetRowsDragSource_ self
    local
      open ClosureMarshal Signal
    in
      fun columnsChangedSig f = signal "columns-changed" (void ---> ret_void) f
      fun cursorChangedSig f = signal "cursor-changed" (void ---> ret_void) f
      fun expandCollapseCursorRowSig f =
        signal "expand-collapse-cursor-row"
          (
            get 0w1 boolean
             &&&> get 0w2 boolean
             &&&> get 0w3 boolean
             ---> ret boolean
          )
          (
            fn
              object
               & p0
               & p1 =>
                f
                  (
                    object,
                    p0,
                    p1
                  )
          )
      fun moveCursorSig f = signal "move-cursor" (get 0w1 GtkMovementStep.t &&&> get 0w2 int ---> ret boolean) (fn step & direction => f (step, direction))
      fun rowActivatedSig f = signal "row-activated" (get 0w1 GtkTreePathRecord.t &&&> get 0w2 GtkTreeViewColumnClass.t ---> ret_void) (fn path & column => f (path, column))
      fun rowCollapsedSig f = signal "row-collapsed" (get 0w1 GtkTreeIterRecord.t &&&> get 0w2 GtkTreePathRecord.t ---> ret_void) (fn iter & path => f (iter, path))
      fun rowExpandedSig f = signal "row-expanded" (get 0w1 GtkTreeIterRecord.t &&&> get 0w2 GtkTreePathRecord.t ---> ret_void) (fn iter & path => f (iter, path))
      fun selectAllSig f = signal "select-all" (void ---> ret boolean) f
      fun selectCursorParentSig f = signal "select-cursor-parent" (void ---> ret boolean) f
      fun selectCursorRowSig f = signal "select-cursor-row" (get 0w1 boolean ---> ret boolean) f
      fun startInteractiveSearchSig f = signal "start-interactive-search" (void ---> ret boolean) f
      fun testCollapseRowSig f = signal "test-collapse-row" (get 0w1 GtkTreeIterRecord.t &&&> get 0w2 GtkTreePathRecord.t ---> ret boolean) (fn iter & path => f (iter, path))
      fun testExpandRowSig f = signal "test-expand-row" (get 0w1 GtkTreeIterRecord.t &&&> get 0w2 GtkTreePathRecord.t ---> ret boolean) (fn iter & path => f (iter, path))
      fun toggleCursorRowSig f = signal "toggle-cursor-row" (void ---> ret boolean) f
      fun unselectAllSig f = signal "unselect-all" (void ---> ret boolean) f
    end
    local
      open ValueAccessor
    in
      val activateOnSingleClickProp =
        {
          name = "activate-on-single-click",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val enableGridLinesProp =
        {
          name = "enable-grid-lines",
          gtype = fn () => C.gtype GtkTreeViewGridLines.t (),
          get = fn x => fn () => C.get GtkTreeViewGridLines.t x,
          set = fn x => C.set GtkTreeViewGridLines.t x,
          init = fn x => C.set GtkTreeViewGridLines.t x
        }
      val enableSearchProp =
        {
          name = "enable-search",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val enableTreeLinesProp =
        {
          name = "enable-tree-lines",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val expanderColumnProp =
        {
          name = "expander-column",
          gtype = fn () => C.gtype GtkTreeViewColumnClass.tOpt (),
          get = fn x => fn () => C.get GtkTreeViewColumnClass.tOpt x,
          set = fn x => C.set GtkTreeViewColumnClass.tOpt x,
          init = fn x => C.set GtkTreeViewColumnClass.tOpt x
        }
      val fixedHeightModeProp =
        {
          name = "fixed-height-mode",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val headersClickableProp =
        {
          name = "headers-clickable",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val headersVisibleProp =
        {
          name = "headers-visible",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val hoverExpandProp =
        {
          name = "hover-expand",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val hoverSelectionProp =
        {
          name = "hover-selection",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val levelIndentationProp =
        {
          name = "level-indentation",
          gtype = fn () => C.gtype int (),
          get = fn x => fn () => C.get int x,
          set = fn x => C.set int x,
          init = fn x => C.set int x
        }
      val modelProp =
        {
          name = "model",
          gtype = fn () => C.gtype GtkTreeModelClass.tOpt (),
          get = fn x => fn () => C.get GtkTreeModelClass.tOpt x,
          set = fn x => C.set GtkTreeModelClass.tOpt x,
          init = fn x => C.set GtkTreeModelClass.tOpt x
        }
      val reorderableProp =
        {
          name = "reorderable",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val rubberBandingProp =
        {
          name = "rubber-banding",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val rulesHintProp =
        {
          name = "rules-hint",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val searchColumnProp =
        {
          name = "search-column",
          gtype = fn () => C.gtype int (),
          get = fn x => fn () => C.get int x,
          set = fn x => C.set int x,
          init = fn x => C.set int x
        }
      val showExpandersProp =
        {
          name = "show-expanders",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val tooltipColumnProp =
        {
          name = "tooltip-column",
          gtype = fn () => C.gtype int (),
          get = fn x => fn () => C.get int x,
          set = fn x => C.set int x,
          init = fn x => C.set int x
        }
    end
  end
