structure GtkFileChooser :>
  GTK_FILE_CHOOSER
    where type 'a class = 'a GtkFileChooserClass.class
    where type file_chooser_confirmation_t = GtkFileChooserConfirmation.t
    where type file_chooser_action_t = GtkFileChooserAction.t
    where type 'a file_filter_class = 'a GtkFileFilterClass.class
    where type 'a widget_class = 'a GtkWidgetClass.class =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "gtk_file_chooser_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val addChoice_ =
        call (getSymbol "gtk_file_chooser_add_choice")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> Utf8.PolyML.cInPtr
             &&> Utf8.PolyML.cInPtr
             &&> Utf8.PolyML.cInPtr
             --> cVoid
          )
      val addFilter_ = call (getSymbol "gtk_file_chooser_add_filter") (GtkFileChooserClass.PolyML.cPtr &&> GtkFileFilterClass.PolyML.cPtr --> cVoid)
      val addShortcutFolder_ =
        call (getSymbol "gtk_file_chooser_add_shortcut_folder")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> GLibErrorRecord.PolyML.cOutOptRef
             --> GBool.PolyML.cVal
          )
      val addShortcutFolderUri_ =
        call (getSymbol "gtk_file_chooser_add_shortcut_folder_uri")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> GLibErrorRecord.PolyML.cOutOptRef
             --> GBool.PolyML.cVal
          )
      val getAction_ = call (getSymbol "gtk_file_chooser_get_action") (GtkFileChooserClass.PolyML.cPtr --> GtkFileChooserAction.PolyML.cVal)
      val getChoice_ = call (getSymbol "gtk_file_chooser_get_choice") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> Utf8.PolyML.cOutPtr)
      val getCreateFolders_ = call (getSymbol "gtk_file_chooser_get_create_folders") (GtkFileChooserClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getCurrentFolder_ = call (getSymbol "gtk_file_chooser_get_current_folder") (GtkFileChooserClass.PolyML.cPtr --> Utf8.PolyML.cOutOptPtr)
      val getCurrentFolderFile_ = call (getSymbol "gtk_file_chooser_get_current_folder_file") (GtkFileChooserClass.PolyML.cPtr --> GioFileClass.PolyML.cPtr)
      val getCurrentFolderUri_ = call (getSymbol "gtk_file_chooser_get_current_folder_uri") (GtkFileChooserClass.PolyML.cPtr --> Utf8.PolyML.cOutOptPtr)
      val getCurrentName_ = call (getSymbol "gtk_file_chooser_get_current_name") (GtkFileChooserClass.PolyML.cPtr --> Utf8.PolyML.cOutPtr)
      val getDoOverwriteConfirmation_ = call (getSymbol "gtk_file_chooser_get_do_overwrite_confirmation") (GtkFileChooserClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getExtraWidget_ = call (getSymbol "gtk_file_chooser_get_extra_widget") (GtkFileChooserClass.PolyML.cPtr --> GtkWidgetClass.PolyML.cOptPtr)
      val getFile_ = call (getSymbol "gtk_file_chooser_get_file") (GtkFileChooserClass.PolyML.cPtr --> GioFileClass.PolyML.cPtr)
      val getFilename_ = call (getSymbol "gtk_file_chooser_get_filename") (GtkFileChooserClass.PolyML.cPtr --> Utf8.PolyML.cOutOptPtr)
      val getFilter_ = call (getSymbol "gtk_file_chooser_get_filter") (GtkFileChooserClass.PolyML.cPtr --> GtkFileFilterClass.PolyML.cOptPtr)
      val getLocalOnly_ = call (getSymbol "gtk_file_chooser_get_local_only") (GtkFileChooserClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getPreviewFile_ = call (getSymbol "gtk_file_chooser_get_preview_file") (GtkFileChooserClass.PolyML.cPtr --> GioFileClass.PolyML.cOptPtr)
      val getPreviewFilename_ = call (getSymbol "gtk_file_chooser_get_preview_filename") (GtkFileChooserClass.PolyML.cPtr --> Utf8.PolyML.cOutOptPtr)
      val getPreviewUri_ = call (getSymbol "gtk_file_chooser_get_preview_uri") (GtkFileChooserClass.PolyML.cPtr --> Utf8.PolyML.cOutOptPtr)
      val getPreviewWidget_ = call (getSymbol "gtk_file_chooser_get_preview_widget") (GtkFileChooserClass.PolyML.cPtr --> GtkWidgetClass.PolyML.cOptPtr)
      val getPreviewWidgetActive_ = call (getSymbol "gtk_file_chooser_get_preview_widget_active") (GtkFileChooserClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getSelectMultiple_ = call (getSymbol "gtk_file_chooser_get_select_multiple") (GtkFileChooserClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getShowHidden_ = call (getSymbol "gtk_file_chooser_get_show_hidden") (GtkFileChooserClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getUri_ = call (getSymbol "gtk_file_chooser_get_uri") (GtkFileChooserClass.PolyML.cPtr --> Utf8.PolyML.cOutOptPtr)
      val getUsePreviewLabel_ = call (getSymbol "gtk_file_chooser_get_use_preview_label") (GtkFileChooserClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val removeChoice_ = call (getSymbol "gtk_file_chooser_remove_choice") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> cVoid)
      val removeFilter_ = call (getSymbol "gtk_file_chooser_remove_filter") (GtkFileChooserClass.PolyML.cPtr &&> GtkFileFilterClass.PolyML.cPtr --> cVoid)
      val removeShortcutFolder_ =
        call (getSymbol "gtk_file_chooser_remove_shortcut_folder")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> GLibErrorRecord.PolyML.cOutOptRef
             --> GBool.PolyML.cVal
          )
      val removeShortcutFolderUri_ =
        call (getSymbol "gtk_file_chooser_remove_shortcut_folder_uri")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> GLibErrorRecord.PolyML.cOutOptRef
             --> GBool.PolyML.cVal
          )
      val selectAll_ = call (getSymbol "gtk_file_chooser_select_all") (GtkFileChooserClass.PolyML.cPtr --> cVoid)
      val selectFile_ =
        call (getSymbol "gtk_file_chooser_select_file")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> GioFileClass.PolyML.cPtr
             &&> GLibErrorRecord.PolyML.cOutOptRef
             --> GBool.PolyML.cVal
          )
      val selectFilename_ = call (getSymbol "gtk_file_chooser_select_filename") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GBool.PolyML.cVal)
      val selectUri_ = call (getSymbol "gtk_file_chooser_select_uri") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GBool.PolyML.cVal)
      val setAction_ = call (getSymbol "gtk_file_chooser_set_action") (GtkFileChooserClass.PolyML.cPtr &&> GtkFileChooserAction.PolyML.cVal --> cVoid)
      val setChoice_ =
        call (getSymbol "gtk_file_chooser_set_choice")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> Utf8.PolyML.cInPtr
             --> cVoid
          )
      val setCreateFolders_ = call (getSymbol "gtk_file_chooser_set_create_folders") (GtkFileChooserClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setCurrentFolder_ = call (getSymbol "gtk_file_chooser_set_current_folder") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GBool.PolyML.cVal)
      val setCurrentFolderFile_ =
        call (getSymbol "gtk_file_chooser_set_current_folder_file")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> GioFileClass.PolyML.cPtr
             &&> GLibErrorRecord.PolyML.cOutOptRef
             --> GBool.PolyML.cVal
          )
      val setCurrentFolderUri_ = call (getSymbol "gtk_file_chooser_set_current_folder_uri") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GBool.PolyML.cVal)
      val setCurrentName_ = call (getSymbol "gtk_file_chooser_set_current_name") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> cVoid)
      val setDoOverwriteConfirmation_ = call (getSymbol "gtk_file_chooser_set_do_overwrite_confirmation") (GtkFileChooserClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setExtraWidget_ = call (getSymbol "gtk_file_chooser_set_extra_widget") (GtkFileChooserClass.PolyML.cPtr &&> GtkWidgetClass.PolyML.cPtr --> cVoid)
      val setFile_ =
        call (getSymbol "gtk_file_chooser_set_file")
          (
            GtkFileChooserClass.PolyML.cPtr
             &&> GioFileClass.PolyML.cPtr
             &&> GLibErrorRecord.PolyML.cOutOptRef
             --> GBool.PolyML.cVal
          )
      val setFilename_ = call (getSymbol "gtk_file_chooser_set_filename") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GBool.PolyML.cVal)
      val setFilter_ = call (getSymbol "gtk_file_chooser_set_filter") (GtkFileChooserClass.PolyML.cPtr &&> GtkFileFilterClass.PolyML.cPtr --> cVoid)
      val setLocalOnly_ = call (getSymbol "gtk_file_chooser_set_local_only") (GtkFileChooserClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setPreviewWidget_ = call (getSymbol "gtk_file_chooser_set_preview_widget") (GtkFileChooserClass.PolyML.cPtr &&> GtkWidgetClass.PolyML.cPtr --> cVoid)
      val setPreviewWidgetActive_ = call (getSymbol "gtk_file_chooser_set_preview_widget_active") (GtkFileChooserClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setSelectMultiple_ = call (getSymbol "gtk_file_chooser_set_select_multiple") (GtkFileChooserClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setShowHidden_ = call (getSymbol "gtk_file_chooser_set_show_hidden") (GtkFileChooserClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setUri_ = call (getSymbol "gtk_file_chooser_set_uri") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GBool.PolyML.cVal)
      val setUsePreviewLabel_ = call (getSymbol "gtk_file_chooser_set_use_preview_label") (GtkFileChooserClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val unselectAll_ = call (getSymbol "gtk_file_chooser_unselect_all") (GtkFileChooserClass.PolyML.cPtr --> cVoid)
      val unselectFile_ = call (getSymbol "gtk_file_chooser_unselect_file") (GtkFileChooserClass.PolyML.cPtr &&> GioFileClass.PolyML.cPtr --> cVoid)
      val unselectFilename_ = call (getSymbol "gtk_file_chooser_unselect_filename") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> cVoid)
      val unselectUri_ = call (getSymbol "gtk_file_chooser_unselect_uri") (GtkFileChooserClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> cVoid)
    end
    type 'a class = 'a GtkFileChooserClass.class
    type file_chooser_confirmation_t = GtkFileChooserConfirmation.t
    type file_chooser_action_t = GtkFileChooserAction.t
    type 'a file_filter_class = 'a GtkFileFilterClass.class
    type 'a widget_class = 'a GtkWidgetClass.class
    type t = base class
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun addChoice
      self
      (
        id,
        label,
        options,
        optionLabels
      ) =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> Utf8.FFI.withPtr 0
         &&&> Utf8.FFI.withPtr 0
         &&&> Utf8.FFI.withPtr 0
         ---> I
      )
        addChoice_
        (
          self
           & id
           & label
           & options
           & optionLabels
        )
    fun addFilter self filter = (GtkFileChooserClass.FFI.withPtr false &&&> GtkFileFilterClass.FFI.withPtr true ---> I) addFilter_ (self & filter)
    fun addShortcutFolder self folder =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> GLibErrorRecord.handleError
         ---> ignore
      )
        addShortcutFolder_
        (
          self
           & folder
           & []
        )
    fun addShortcutFolderUri self uri =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> GLibErrorRecord.handleError
         ---> ignore
      )
        addShortcutFolderUri_
        (
          self
           & uri
           & []
        )
    fun getAction self = (GtkFileChooserClass.FFI.withPtr false ---> GtkFileChooserAction.FFI.fromVal) getAction_ self
    fun getChoice self id = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> Utf8.FFI.fromPtr 0) getChoice_ (self & id) before GtkFileChooserClass.FFI.touchPtr self before Utf8.FFI.touchPtr id
    fun getCreateFolders self = (GtkFileChooserClass.FFI.withPtr false ---> GBool.FFI.fromVal) getCreateFolders_ self
    fun getCurrentFolder self = (GtkFileChooserClass.FFI.withPtr false ---> Utf8.FFI.fromOptPtr ~1) getCurrentFolder_ self
    fun getCurrentFolderFile self = (GtkFileChooserClass.FFI.withPtr false ---> GioFileClass.FFI.fromPtr true) getCurrentFolderFile_ self
    fun getCurrentFolderUri self = (GtkFileChooserClass.FFI.withPtr false ---> Utf8.FFI.fromOptPtr ~1) getCurrentFolderUri_ self
    fun getCurrentName self = (GtkFileChooserClass.FFI.withPtr false ---> Utf8.FFI.fromPtr ~1) getCurrentName_ self
    fun getDoOverwriteConfirmation self = (GtkFileChooserClass.FFI.withPtr false ---> GBool.FFI.fromVal) getDoOverwriteConfirmation_ self
    fun getExtraWidget self = (GtkFileChooserClass.FFI.withPtr false ---> GtkWidgetClass.FFI.fromOptPtr false) getExtraWidget_ self before GtkFileChooserClass.FFI.touchPtr self
    fun getFile self = (GtkFileChooserClass.FFI.withPtr false ---> GioFileClass.FFI.fromPtr true) getFile_ self
    fun getFilename self = (GtkFileChooserClass.FFI.withPtr false ---> Utf8.FFI.fromOptPtr ~1) getFilename_ self
    fun getFilter self = (GtkFileChooserClass.FFI.withPtr false ---> GtkFileFilterClass.FFI.fromOptPtr false) getFilter_ self before GtkFileChooserClass.FFI.touchPtr self
    fun getLocalOnly self = (GtkFileChooserClass.FFI.withPtr false ---> GBool.FFI.fromVal) getLocalOnly_ self
    fun getPreviewFile self = (GtkFileChooserClass.FFI.withPtr false ---> GioFileClass.FFI.fromOptPtr true) getPreviewFile_ self
    fun getPreviewFilename self = (GtkFileChooserClass.FFI.withPtr false ---> Utf8.FFI.fromOptPtr ~1) getPreviewFilename_ self
    fun getPreviewUri self = (GtkFileChooserClass.FFI.withPtr false ---> Utf8.FFI.fromOptPtr ~1) getPreviewUri_ self
    fun getPreviewWidget self = (GtkFileChooserClass.FFI.withPtr false ---> GtkWidgetClass.FFI.fromOptPtr false) getPreviewWidget_ self before GtkFileChooserClass.FFI.touchPtr self
    fun getPreviewWidgetActive self = (GtkFileChooserClass.FFI.withPtr false ---> GBool.FFI.fromVal) getPreviewWidgetActive_ self
    fun getSelectMultiple self = (GtkFileChooserClass.FFI.withPtr false ---> GBool.FFI.fromVal) getSelectMultiple_ self
    fun getShowHidden self = (GtkFileChooserClass.FFI.withPtr false ---> GBool.FFI.fromVal) getShowHidden_ self
    fun getUri self = (GtkFileChooserClass.FFI.withPtr false ---> Utf8.FFI.fromOptPtr ~1) getUri_ self
    fun getUsePreviewLabel self = (GtkFileChooserClass.FFI.withPtr false ---> GBool.FFI.fromVal) getUsePreviewLabel_ self
    fun removeChoice self id = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> I) removeChoice_ (self & id)
    fun removeFilter self filter = (GtkFileChooserClass.FFI.withPtr false &&&> GtkFileFilterClass.FFI.withPtr false ---> I) removeFilter_ (self & filter)
    fun removeShortcutFolder self folder =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> GLibErrorRecord.handleError
         ---> ignore
      )
        removeShortcutFolder_
        (
          self
           & folder
           & []
        )
    fun removeShortcutFolderUri self uri =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> GLibErrorRecord.handleError
         ---> ignore
      )
        removeShortcutFolderUri_
        (
          self
           & uri
           & []
        )
    fun selectAll self = (GtkFileChooserClass.FFI.withPtr false ---> I) selectAll_ self
    fun selectFile self file =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> GioFileClass.FFI.withPtr false
         &&&> GLibErrorRecord.handleError
         ---> ignore
      )
        selectFile_
        (
          self
           & file
           & []
        )
    fun selectFilename self filename = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GBool.FFI.fromVal) selectFilename_ (self & filename)
    fun selectUri self uri = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GBool.FFI.fromVal) selectUri_ (self & uri)
    fun setAction self action = (GtkFileChooserClass.FFI.withPtr false &&&> GtkFileChooserAction.FFI.withVal ---> I) setAction_ (self & action)
    fun setChoice self (id, option) =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> Utf8.FFI.withPtr 0
         ---> I
      )
        setChoice_
        (
          self
           & id
           & option
        )
    fun setCreateFolders self createFolders = (GtkFileChooserClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setCreateFolders_ (self & createFolders)
    fun setCurrentFolder self filename = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GBool.FFI.fromVal) setCurrentFolder_ (self & filename)
    fun setCurrentFolderFile self file =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> GioFileClass.FFI.withPtr false
         &&&> GLibErrorRecord.handleError
         ---> ignore
      )
        setCurrentFolderFile_
        (
          self
           & file
           & []
        )
    fun setCurrentFolderUri self uri = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GBool.FFI.fromVal) setCurrentFolderUri_ (self & uri)
    fun setCurrentName self name = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> I) setCurrentName_ (self & name)
    fun setDoOverwriteConfirmation self doOverwriteConfirmation = (GtkFileChooserClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setDoOverwriteConfirmation_ (self & doOverwriteConfirmation)
    fun setExtraWidget self extraWidget = (GtkFileChooserClass.FFI.withPtr false &&&> GtkWidgetClass.FFI.withPtr false ---> I) setExtraWidget_ (self & extraWidget)
    fun setFile self file =
      (
        GtkFileChooserClass.FFI.withPtr false
         &&&> GioFileClass.FFI.withPtr false
         &&&> GLibErrorRecord.handleError
         ---> ignore
      )
        setFile_
        (
          self
           & file
           & []
        )
    fun setFilename self filename = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GBool.FFI.fromVal) setFilename_ (self & filename)
    fun setFilter self filter = (GtkFileChooserClass.FFI.withPtr false &&&> GtkFileFilterClass.FFI.withPtr false ---> I) setFilter_ (self & filter)
    fun setLocalOnly self localOnly = (GtkFileChooserClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setLocalOnly_ (self & localOnly)
    fun setPreviewWidget self previewWidget = (GtkFileChooserClass.FFI.withPtr false &&&> GtkWidgetClass.FFI.withPtr false ---> I) setPreviewWidget_ (self & previewWidget)
    fun setPreviewWidgetActive self active = (GtkFileChooserClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setPreviewWidgetActive_ (self & active)
    fun setSelectMultiple self selectMultiple = (GtkFileChooserClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setSelectMultiple_ (self & selectMultiple)
    fun setShowHidden self showHidden = (GtkFileChooserClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setShowHidden_ (self & showHidden)
    fun setUri self uri = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GBool.FFI.fromVal) setUri_ (self & uri)
    fun setUsePreviewLabel self useLabel = (GtkFileChooserClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setUsePreviewLabel_ (self & useLabel)
    fun unselectAll self = (GtkFileChooserClass.FFI.withPtr false ---> I) unselectAll_ self
    fun unselectFile self file = (GtkFileChooserClass.FFI.withPtr false &&&> GioFileClass.FFI.withPtr false ---> I) unselectFile_ (self & file)
    fun unselectFilename self filename = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> I) unselectFilename_ (self & filename)
    fun unselectUri self uri = (GtkFileChooserClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> I) unselectUri_ (self & uri)
    local
      open ClosureMarshal Signal
    in
      fun confirmOverwriteSig f = signal "confirm-overwrite" (void ---> ret GtkFileChooserConfirmation.t) f
      fun currentFolderChangedSig f = signal "current-folder-changed" (void ---> ret_void) f
      fun fileActivatedSig f = signal "file-activated" (void ---> ret_void) f
      fun selectionChangedSig f = signal "selection-changed" (void ---> ret_void) f
      fun updatePreviewSig f = signal "update-preview" (void ---> ret_void) f
    end
    local
      open ValueAccessor
    in
      val actionProp =
        {
          name = "action",
          gtype = fn () => C.gtype GtkFileChooserAction.t (),
          get = fn x => fn () => C.get GtkFileChooserAction.t x,
          set = fn x => C.set GtkFileChooserAction.t x,
          init = fn x => C.set GtkFileChooserAction.t x
        }
      val createFoldersProp =
        {
          name = "create-folders",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val doOverwriteConfirmationProp =
        {
          name = "do-overwrite-confirmation",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val extraWidgetProp =
        {
          name = "extra-widget",
          gtype = fn () => C.gtype GtkWidgetClass.tOpt (),
          get = fn x => fn () => C.get GtkWidgetClass.tOpt x,
          set = fn x => C.set GtkWidgetClass.tOpt x,
          init = fn x => C.set GtkWidgetClass.tOpt x
        }
      val filterProp =
        {
          name = "filter",
          gtype = fn () => C.gtype GtkFileFilterClass.tOpt (),
          get = fn x => fn () => C.get GtkFileFilterClass.tOpt x,
          set = fn x => C.set GtkFileFilterClass.tOpt x,
          init = fn x => C.set GtkFileFilterClass.tOpt x
        }
      val localOnlyProp =
        {
          name = "local-only",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val previewWidgetProp =
        {
          name = "preview-widget",
          gtype = fn () => C.gtype GtkWidgetClass.tOpt (),
          get = fn x => fn () => C.get GtkWidgetClass.tOpt x,
          set = fn x => C.set GtkWidgetClass.tOpt x,
          init = fn x => C.set GtkWidgetClass.tOpt x
        }
      val previewWidgetActiveProp =
        {
          name = "preview-widget-active",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val selectMultipleProp =
        {
          name = "select-multiple",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val showHiddenProp =
        {
          name = "show-hidden",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val usePreviewLabelProp =
        {
          name = "use-preview-label",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
    end
  end
