structure GtkPageRange :>
  GTK_PAGE_RANGE
    where type t = GtkPageRangeRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val start'Offset_ = call (getSymbol "giraffe_gtk_page_range_start_offset") (cVoid --> GSize.PolyML.cVal)
      val end'Offset_ = call (getSymbol "giraffe_gtk_page_range_end_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GtkPageRangeRecord.t
    structure StartField =
      Field(
        structure Container = GtkPageRangeRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) start'Offset_
      )
    structure EndField =
      Field(
        structure Container = GtkPageRangeRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) end'Offset_
      )
    val start =
      {
        get = fn x => StartField.get x,
        set = fn x => StartField.set x
      }
    val end' =
      {
        get = fn x => EndField.get x,
        set = fn x => EndField.set x
      }
    fun new
      {
        start,
        end'
      } =
      let
        fun init_ p =
          (
            StartField.C.set start p;
            EndField.C.set end' p;
            ()
          )
        val retVal & () = (GtkPageRangeRecord.FFI.withNewPtr ---> GtkPageRangeRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
  end
