structure GtkPrintDuplex :> GTK_PRINT_DUPLEX =
  struct
    datatype enum =
      SIMPLEX
    | HORIZONTAL
    | VERTICAL
    structure Enum =
      Enum(
        type enum = enum
        val null = SIMPLEX
        val toInt =
          fn
            SIMPLEX => 0
          | HORIZONTAL => 1
          | VERTICAL => 2
        exception Value of GInt.t
        val fromInt =
          fn
            0 => SIMPLEX
          | 1 => HORIZONTAL
          | 2 => VERTICAL
          | n => raise Value n
      )
    open Enum
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "gtk_print_duplex_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val getValue_ = call (getSymbol "g_value_get_enum") (GObjectValueRecord.PolyML.cPtr --> PolyML.cVal)
      val setValue_ = call (getSymbol "g_value_set_enum") (GObjectValueRecord.PolyML.cPtr &&> PolyML.cVal --> cVoid)
    end
    val t =
      ValueAccessor.C.createAccessor
        {
          getType = (I ---> GObjectType.FFI.fromVal) getType_,
          getValue = (I ---> FFI.fromVal) getValue_,
          setValue = (I &&&> FFI.withVal ---> I) setValue_
        }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
  end
