structure GtkStack :>
  GTK_STACK
    where type 'a class = 'a GtkStackClass.class
    where type 'a buildable_class = 'a GtkBuildableClass.class
    where type stack_transition_type_t = GtkStackTransitionType.t
    where type 'a widget_class = 'a GtkWidgetClass.class =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "gtk_stack_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val new_ = call (getSymbol "gtk_stack_new") (cVoid --> GtkWidgetClass.PolyML.cPtr)
      val addNamed_ =
        call (getSymbol "gtk_stack_add_named")
          (
            GtkStackClass.PolyML.cPtr
             &&> GtkWidgetClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             --> cVoid
          )
      val addTitled_ =
        call (getSymbol "gtk_stack_add_titled")
          (
            GtkStackClass.PolyML.cPtr
             &&> GtkWidgetClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> Utf8.PolyML.cInPtr
             --> cVoid
          )
      val getChildByName_ = call (getSymbol "gtk_stack_get_child_by_name") (GtkStackClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GtkWidgetClass.PolyML.cOptPtr)
      val getHhomogeneous_ = call (getSymbol "gtk_stack_get_hhomogeneous") (GtkStackClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getHomogeneous_ = call (getSymbol "gtk_stack_get_homogeneous") (GtkStackClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getInterpolateSize_ = call (getSymbol "gtk_stack_get_interpolate_size") (GtkStackClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getTransitionDuration_ = call (getSymbol "gtk_stack_get_transition_duration") (GtkStackClass.PolyML.cPtr --> GUInt.PolyML.cVal)
      val getTransitionRunning_ = call (getSymbol "gtk_stack_get_transition_running") (GtkStackClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getTransitionType_ = call (getSymbol "gtk_stack_get_transition_type") (GtkStackClass.PolyML.cPtr --> GtkStackTransitionType.PolyML.cVal)
      val getVhomogeneous_ = call (getSymbol "gtk_stack_get_vhomogeneous") (GtkStackClass.PolyML.cPtr --> GBool.PolyML.cVal)
      val getVisibleChild_ = call (getSymbol "gtk_stack_get_visible_child") (GtkStackClass.PolyML.cPtr --> GtkWidgetClass.PolyML.cOptPtr)
      val getVisibleChildName_ = call (getSymbol "gtk_stack_get_visible_child_name") (GtkStackClass.PolyML.cPtr --> Utf8.PolyML.cOutOptPtr)
      val setHhomogeneous_ = call (getSymbol "gtk_stack_set_hhomogeneous") (GtkStackClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setHomogeneous_ = call (getSymbol "gtk_stack_set_homogeneous") (GtkStackClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setInterpolateSize_ = call (getSymbol "gtk_stack_set_interpolate_size") (GtkStackClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setTransitionDuration_ = call (getSymbol "gtk_stack_set_transition_duration") (GtkStackClass.PolyML.cPtr &&> GUInt.PolyML.cVal --> cVoid)
      val setTransitionType_ = call (getSymbol "gtk_stack_set_transition_type") (GtkStackClass.PolyML.cPtr &&> GtkStackTransitionType.PolyML.cVal --> cVoid)
      val setVhomogeneous_ = call (getSymbol "gtk_stack_set_vhomogeneous") (GtkStackClass.PolyML.cPtr &&> GBool.PolyML.cVal --> cVoid)
      val setVisibleChild_ = call (getSymbol "gtk_stack_set_visible_child") (GtkStackClass.PolyML.cPtr &&> GtkWidgetClass.PolyML.cPtr --> cVoid)
      val setVisibleChildFull_ =
        call (getSymbol "gtk_stack_set_visible_child_full")
          (
            GtkStackClass.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> GtkStackTransitionType.PolyML.cVal
             --> cVoid
          )
      val setVisibleChildName_ = call (getSymbol "gtk_stack_set_visible_child_name") (GtkStackClass.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> cVoid)
    end
    type 'a class = 'a GtkStackClass.class
    type 'a buildable_class = 'a GtkBuildableClass.class
    type stack_transition_type_t = GtkStackTransitionType.t
    type 'a widget_class = 'a GtkWidgetClass.class
    type t = base class
    fun asImplementorIface self = (GObjectObjectClass.FFI.withPtr false ---> AtkImplementorIfaceClass.FFI.fromPtr false) I self
    fun asBuildable self = (GObjectObjectClass.FFI.withPtr false ---> GtkBuildableClass.FFI.fromPtr false) I self
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new () = (I ---> GtkStackClass.FFI.fromPtr false) new_ ()
    fun addNamed self (child, name) =
      (
        GtkStackClass.FFI.withPtr false
         &&&> GtkWidgetClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         ---> I
      )
        addNamed_
        (
          self
           & child
           & name
        )
    fun addTitled
      self
      (
        child,
        name,
        title
      ) =
      (
        GtkStackClass.FFI.withPtr false
         &&&> GtkWidgetClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> Utf8.FFI.withPtr 0
         ---> I
      )
        addTitled_
        (
          self
           & child
           & name
           & title
        )
    fun getChildByName self name = (GtkStackClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GtkWidgetClass.FFI.fromOptPtr false) getChildByName_ (self & name) before GtkStackClass.FFI.touchPtr self before Utf8.FFI.touchPtr name
    fun getHhomogeneous self = (GtkStackClass.FFI.withPtr false ---> GBool.FFI.fromVal) getHhomogeneous_ self
    fun getHomogeneous self = (GtkStackClass.FFI.withPtr false ---> GBool.FFI.fromVal) getHomogeneous_ self
    fun getInterpolateSize self = (GtkStackClass.FFI.withPtr false ---> GBool.FFI.fromVal) getInterpolateSize_ self
    fun getTransitionDuration self = (GtkStackClass.FFI.withPtr false ---> GUInt.FFI.fromVal) getTransitionDuration_ self
    fun getTransitionRunning self = (GtkStackClass.FFI.withPtr false ---> GBool.FFI.fromVal) getTransitionRunning_ self
    fun getTransitionType self = (GtkStackClass.FFI.withPtr false ---> GtkStackTransitionType.FFI.fromVal) getTransitionType_ self
    fun getVhomogeneous self = (GtkStackClass.FFI.withPtr false ---> GBool.FFI.fromVal) getVhomogeneous_ self
    fun getVisibleChild self = (GtkStackClass.FFI.withPtr false ---> GtkWidgetClass.FFI.fromOptPtr false) getVisibleChild_ self before GtkStackClass.FFI.touchPtr self
    fun getVisibleChildName self = (GtkStackClass.FFI.withPtr false ---> Utf8.FFI.fromOptPtr 0) getVisibleChildName_ self before GtkStackClass.FFI.touchPtr self
    fun setHhomogeneous self hhomogeneous = (GtkStackClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setHhomogeneous_ (self & hhomogeneous)
    fun setHomogeneous self homogeneous = (GtkStackClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setHomogeneous_ (self & homogeneous)
    fun setInterpolateSize self interpolateSize = (GtkStackClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setInterpolateSize_ (self & interpolateSize)
    fun setTransitionDuration self duration = (GtkStackClass.FFI.withPtr false &&&> GUInt.FFI.withVal ---> I) setTransitionDuration_ (self & duration)
    fun setTransitionType self transition = (GtkStackClass.FFI.withPtr false &&&> GtkStackTransitionType.FFI.withVal ---> I) setTransitionType_ (self & transition)
    fun setVhomogeneous self vhomogeneous = (GtkStackClass.FFI.withPtr false &&&> GBool.FFI.withVal ---> I) setVhomogeneous_ (self & vhomogeneous)
    fun setVisibleChild self child = (GtkStackClass.FFI.withPtr false &&&> GtkWidgetClass.FFI.withPtr false ---> I) setVisibleChild_ (self & child)
    fun setVisibleChildFull self (name, transition) =
      (
        GtkStackClass.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> GtkStackTransitionType.FFI.withVal
         ---> I
      )
        setVisibleChildFull_
        (
          self
           & name
           & transition
        )
    fun setVisibleChildName self name = (GtkStackClass.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> I) setVisibleChildName_ (self & name)
    local
      open ValueAccessor
    in
      val hhomogeneousProp =
        {
          name = "hhomogeneous",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val homogeneousProp =
        {
          name = "homogeneous",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val interpolateSizeProp =
        {
          name = "interpolate-size",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val transitionDurationProp =
        {
          name = "transition-duration",
          gtype = fn () => C.gtype uint (),
          get = fn x => fn () => C.get uint x,
          set = fn x => C.set uint x,
          init = fn x => C.set uint x
        }
      val transitionRunningProp =
        {
          name = "transition-running",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = ignore,
          init = ignore
        }
      val transitionTypeProp =
        {
          name = "transition-type",
          gtype = fn () => C.gtype GtkStackTransitionType.t (),
          get = fn x => fn () => C.get GtkStackTransitionType.t x,
          set = fn x => C.set GtkStackTransitionType.t x,
          init = fn x => C.set GtkStackTransitionType.t x
        }
      val vhomogeneousProp =
        {
          name = "vhomogeneous",
          gtype = fn () => C.gtype boolean (),
          get = fn x => fn () => C.get boolean x,
          set = fn x => C.set boolean x,
          init = fn x => C.set boolean x
        }
      val visibleChildProp =
        {
          name = "visible-child",
          gtype = fn () => C.gtype GtkWidgetClass.tOpt (),
          get = fn x => fn () => C.get GtkWidgetClass.tOpt x,
          set = fn x => C.set GtkWidgetClass.tOpt x,
          init = fn x => C.set GtkWidgetClass.tOpt x
        }
      val visibleChildNameProp =
        {
          name = "visible-child-name",
          gtype = fn () => C.gtype stringOpt (),
          get = fn x => fn () => C.get stringOpt x,
          set = fn x => C.set stringOpt x,
          init = fn x => C.set stringOpt x
        }
    end
  end
