structure GtkTableRowCol :>
  GTK_TABLE_ROW_COL
    where type t = GtkTableRowColRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val requisition'Offset_ = call (getSymbol "giraffe_gtk_table_row_col_requisition_offset") (cVoid --> GSize.PolyML.cVal)
      val allocation'Offset_ = call (getSymbol "giraffe_gtk_table_row_col_allocation_offset") (cVoid --> GSize.PolyML.cVal)
      val spacing'Offset_ = call (getSymbol "giraffe_gtk_table_row_col_spacing_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GtkTableRowColRecord.t
    structure RequisitionField =
      Field(
        structure Container = GtkTableRowColRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) requisition'Offset_
      )
    structure AllocationField =
      Field(
        structure Container = GtkTableRowColRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) allocation'Offset_
      )
    structure SpacingField =
      Field(
        structure Container = GtkTableRowColRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) spacing'Offset_
      )
    val requisition =
      {
        get = fn x => RequisitionField.get x,
        set = fn x => RequisitionField.set x
      }
    val allocation =
      {
        get = fn x => AllocationField.get x,
        set = fn x => AllocationField.set x
      }
    val spacing =
      {
        get = fn x => SpacingField.get x,
        set = fn x => SpacingField.set x
      }
  end
