structure GtkTargetEntry :>
  GTK_TARGET_ENTRY
    where type t = GtkTargetEntryRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "gtk_target_entry_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val new_ =
        call (getSymbol "gtk_target_entry_new")
          (
            Utf8.PolyML.cInPtr
             &&> GUInt.PolyML.cVal
             &&> GUInt.PolyML.cVal
             --> GtkTargetEntryRecord.PolyML.cPtr
          )
      val copy_ = call (getSymbol "gtk_target_entry_copy") (GtkTargetEntryRecord.PolyML.cPtr --> GtkTargetEntryRecord.PolyML.cPtr)
      val target'Offset_ = call (getSymbol "giraffe_gtk_target_entry_target_offset") (cVoid --> GSize.PolyML.cVal)
      val flags'Offset_ = call (getSymbol "giraffe_gtk_target_entry_flags_offset") (cVoid --> GSize.PolyML.cVal)
      val info'Offset_ = call (getSymbol "giraffe_gtk_target_entry_info_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = GtkTargetEntryRecord.t
    structure TargetField =
      Field(
        structure Container = GtkTargetEntryRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) target'Offset_
      )
    structure FlagsField =
      Field(
        structure Container = GtkTargetEntryRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) flags'Offset_
      )
    structure InfoField =
      Field(
        structure Container = GtkTargetEntryRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) info'Offset_
      )
    val target =
      {
        get = fn x => TargetField.get x,
        set = fn x => TargetField.set x
      }
    val flags =
      {
        get = fn x => FlagsField.get x,
        set = fn x => FlagsField.set x
      }
    val info =
      {
        get = fn x => InfoField.get x,
        set = fn x => InfoField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new
      (
        target,
        flags,
        info
      ) =
      (
        Utf8.FFI.withPtr 0
         &&&> GUInt.FFI.withVal
         &&&> GUInt.FFI.withVal
         ---> GtkTargetEntryRecord.FFI.fromPtr true
      )
        new_
        (
          target
           & flags
           & info
        )
    fun copy self = (GtkTargetEntryRecord.FFI.withPtr false ---> GtkTargetEntryRecord.FFI.fromPtr true) copy_ self
  end
