structure GtkSource : GTK_SOURCE =
  struct
    local
      open PolyMLFFI
    in
      val utilsEscapeSearchText_ = call (getSymbol "gtk_source_utils_escape_search_text") (Utf8.PolyML.cInPtr --> Utf8.PolyML.cOutPtr)
      val utilsUnescapeSearchText_ = call (getSymbol "gtk_source_utils_unescape_search_text") (Utf8.PolyML.cInPtr --> Utf8.PolyML.cOutPtr)
    end
    structure BackgroundPatternType = GtkSourceBackgroundPatternType
    structure BracketMatchType = GtkSourceBracketMatchType
    structure BufferClass = GtkSourceBufferClass
    structure ChangeCaseType = GtkSourceChangeCaseType
    structure CompletionClass = GtkSourceCompletionClass
    structure CompletionActivation = GtkSourceCompletionActivation
    structure CompletionContextClass = GtkSourceCompletionContextClass
    structure CompletionError = GtkSourceCompletionError
    exception CompletionError = GtkSourceCompletionError
    structure CompletionInfoClass = GtkSourceCompletionInfoClass
    structure CompletionItemClass = GtkSourceCompletionItemClass
    structure CompletionProposalClass = GtkSourceCompletionProposalClass
    structure CompletionProviderClass = GtkSourceCompletionProviderClass
    structure CompletionWordsClass = GtkSourceCompletionWordsClass
    structure CompressionType = GtkSourceCompressionType
    structure DrawSpacesFlags = GtkSourceDrawSpacesFlags
    structure EncodingRecord = GtkSourceEncodingRecord
    structure FileClass = GtkSourceFileClass
    structure FileLoaderClass = GtkSourceFileLoaderClass
    structure FileLoaderError = GtkSourceFileLoaderError
    exception FileLoaderError = GtkSourceFileLoaderError
    structure FileSaverClass = GtkSourceFileSaverClass
    structure FileSaverError = GtkSourceFileSaverError
    exception FileSaverError = GtkSourceFileSaverError
    structure FileSaverFlags = GtkSourceFileSaverFlags
    structure GutterClass = GtkSourceGutterClass
    structure GutterRendererClass = GtkSourceGutterRendererClass
    structure GutterRendererAlignmentMode = GtkSourceGutterRendererAlignmentMode
    structure GutterRendererState = GtkSourceGutterRendererState
    structure LanguageClass = GtkSourceLanguageClass
    structure LanguageManagerClass = GtkSourceLanguageManagerClass
    structure MarkClass = GtkSourceMarkClass
    structure MarkAttributesClass = GtkSourceMarkAttributesClass
    structure NewlineType = GtkSourceNewlineType
    structure PrintCompositorClass = GtkSourcePrintCompositorClass
    structure RegionClass = GtkSourceRegionClass
    structure SearchContextClass = GtkSourceSearchContextClass
    structure SearchSettingsClass = GtkSourceSearchSettingsClass
    structure SmartHomeEndType = GtkSourceSmartHomeEndType
    structure SortFlags = GtkSourceSortFlags
    structure StyleClass = GtkSourceStyleClass
    structure StyleSchemeClass = GtkSourceStyleSchemeClass
    structure StyleSchemeChooserClass = GtkSourceStyleSchemeChooserClass
    structure StyleSchemeChooserButtonClass = GtkSourceStyleSchemeChooserButtonClass
    structure StyleSchemeChooserWidgetClass = GtkSourceStyleSchemeChooserWidgetClass
    structure StyleSchemeManagerClass = GtkSourceStyleSchemeManagerClass
    structure TagClass = GtkSourceTagClass
    structure UndoManagerClass = GtkSourceUndoManagerClass
    structure ViewClass = GtkSourceViewClass
    structure ViewGutterPosition = GtkSourceViewGutterPosition
    structure Buffer = GtkSourceBuffer
    structure Completion = GtkSourceCompletion
    structure CompletionContext = GtkSourceCompletionContext
    structure CompletionInfo = GtkSourceCompletionInfo
    structure CompletionItem = GtkSourceCompletionItem
    structure CompletionProposal = GtkSourceCompletionProposal
    structure CompletionProvider = GtkSourceCompletionProvider
    structure CompletionWords = GtkSourceCompletionWords
    structure Encoding = GtkSourceEncoding
    structure File = GtkSourceFile
    structure FileLoader = GtkSourceFileLoader
    structure FileSaver = GtkSourceFileSaver
    structure Gutter = GtkSourceGutter
    structure GutterRenderer = GtkSourceGutterRenderer
    structure GutterRendererPixbufClass = GtkSourceGutterRendererPixbufClass
    structure GutterRendererTextClass = GtkSourceGutterRendererTextClass
    structure Language = GtkSourceLanguage
    structure LanguageManager = GtkSourceLanguageManager
    structure MapClass = GtkSourceMapClass
    structure Mark = GtkSourceMark
    structure MarkAttributes = GtkSourceMarkAttributes
    structure PrintCompositor = GtkSourcePrintCompositor
    structure Region = GtkSourceRegion
    structure SearchContext = GtkSourceSearchContext
    structure SearchSettings = GtkSourceSearchSettings
    structure Style = GtkSourceStyle
    structure StyleScheme = GtkSourceStyleScheme
    structure StyleSchemeChooser = GtkSourceStyleSchemeChooser
    structure StyleSchemeChooserButton = GtkSourceStyleSchemeChooserButton
    structure StyleSchemeChooserWidget = GtkSourceStyleSchemeChooserWidget
    structure StyleSchemeManager = GtkSourceStyleSchemeManager
    structure Tag = GtkSourceTag
    structure UndoManager = GtkSourceUndoManager
    structure View = GtkSourceView
    structure GutterRendererPixbuf = GtkSourceGutterRendererPixbuf
    structure GutterRendererText = GtkSourceGutterRendererText
    structure Map = GtkSourceMap
    fun utilsEscapeSearchText text = (Utf8.FFI.withPtr 0 ---> Utf8.FFI.fromPtr ~1) utilsEscapeSearchText_ text
    fun utilsUnescapeSearchText text = (Utf8.FFI.withPtr 0 ---> Utf8.FFI.fromPtr ~1) utilsUnescapeSearchText_ text
  end
