structure PangoGlyphInfo :>
  PANGO_GLYPH_INFO
    where type t = PangoGlyphInfoRecord.t
    where type glyph_t = PangoGlyph.t
    where type glyph_geometry_t = PangoGlyphGeometryRecord.t
    where type glyph_vis_attr_t = PangoGlyphVisAttrRecord.t =
  struct
    val glyph'Offset_ = _import "giraffe_pango_glyph_info_glyph_offset" : unit -> GSize.FFI.val_;
    val geometry'Offset_ = _import "giraffe_pango_glyph_info_geometry_offset" : unit -> GSize.FFI.val_;
    val attr'Offset_ = _import "giraffe_pango_glyph_info_attr_offset" : unit -> GSize.FFI.val_;
    type t = PangoGlyphInfoRecord.t
    type glyph_t = PangoGlyph.t
    type glyph_geometry_t = PangoGlyphGeometryRecord.t
    type glyph_vis_attr_t = PangoGlyphVisAttrRecord.t
    structure GlyphField =
      Field(
        structure Container = PangoGlyphInfoRecord
        structure FieldType = ValueFieldType(PangoGlyph)
        val offset = (I ---> GSize.FFI.fromVal) glyph'Offset_
      )
    structure GeometryField =
      Field(
        structure Container = PangoGlyphInfoRecord
        structure FieldType = ValueFieldType(PangoGlyphGeometryRecord)
        val offset = (I ---> GSize.FFI.fromVal) geometry'Offset_
      )
    structure AttrField =
      Field(
        structure Container = PangoGlyphInfoRecord
        structure FieldType = ValueFieldType(PangoGlyphVisAttrRecord)
        val offset = (I ---> GSize.FFI.fromVal) attr'Offset_
      )
    val glyph =
      {
        get = fn x => GlyphField.get x,
        set = fn x => GlyphField.set x
      }
    val geometry =
      {
        get = fn x => GeometryField.get x,
        set = fn x => GeometryField.set x
      }
    val attr =
      {
        get = fn x => AttrField.get x,
        set = fn x => AttrField.set x
      }
    fun new
      {
        glyph,
        geometry,
        attr
      } =
      let
        fun init_ p =
          (
            GlyphField.C.set glyph p;
            GeometryField.C.set geometry p;
            AttrField.C.set attr p;
            ()
          )
        val retVal & () = (PangoGlyphInfoRecord.FFI.withNewPtr ---> PangoGlyphInfoRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
  end
