structure PangoGlyphItem :>
  PANGO_GLYPH_ITEM
    where type t = PangoGlyphItemRecord.t
    where type item_t = PangoItemRecord.t
    where type glyph_string_t = PangoGlyphStringRecord.t =
  struct
    val getType_ = _import "pango_glyph_item_get_type" : unit -> GObjectType.FFI.val_;
    val copy_ = _import "pango_glyph_item_copy" : PangoGlyphItemRecord.FFI.non_opt PangoGlyphItemRecord.FFI.p -> PangoGlyphItemRecord.FFI.opt PangoGlyphItemRecord.FFI.p;
    val split_ =
      fn
        x1
         & (x2, x3)
         & x4 =>
          (
            _import "mlton_pango_glyph_item_split" :
              PangoGlyphItemRecord.FFI.non_opt PangoGlyphItemRecord.FFI.p
               * Utf8.MLton.p1
               * Utf8.FFI.non_opt Utf8.MLton.p2
               * GInt.FFI.val_
               -> PangoGlyphItemRecord.FFI.non_opt PangoGlyphItemRecord.FFI.p;
          )
            (
              x1,
              x2,
              x3,
              x4
            )
    val item'Offset_ = _import "giraffe_pango_glyph_item_item_offset" : unit -> GSize.FFI.val_;
    val glyphs'Offset_ = _import "giraffe_pango_glyph_item_glyphs_offset" : unit -> GSize.FFI.val_;
    type t = PangoGlyphItemRecord.t
    type item_t = PangoItemRecord.t
    type glyph_string_t = PangoGlyphStringRecord.t
    structure ItemField =
      Field(
        structure Container = PangoGlyphItemRecord
        structure FieldType = OptPointerFieldType(PangoItemRecord)
        val offset = (I ---> GSize.FFI.fromVal) item'Offset_
      )
    structure GlyphsField =
      Field(
        structure Container = PangoGlyphItemRecord
        structure FieldType = OptPointerFieldType(PangoGlyphStringRecord)
        val offset = (I ---> GSize.FFI.fromVal) glyphs'Offset_
      )
    val item =
      {
        get = fn x => ItemField.get x,
        set = fn x => ItemField.set x
      }
    val glyphs =
      {
        get = fn x => GlyphsField.get x,
        set = fn x => GlyphsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun copy self = (PangoGlyphItemRecord.FFI.withPtr false ---> PangoGlyphItemRecord.FFI.fromOptPtr true) copy_ self
    fun split self (text, splitIndex) =
      (
        PangoGlyphItemRecord.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> GInt.FFI.withVal
         ---> PangoGlyphItemRecord.FFI.fromPtr true
      )
        split_
        (
          self
           & text
           & splitIndex
        )
  end
