structure PangoGlyphString :>
  PANGO_GLYPH_STRING
    where type t = PangoGlyphStringRecord.t
    where type glyph_info_record_c_array_n_t = PangoGlyphInfoRecordCArrayN.t
    where type rectangle_t = PangoRectangleRecord.t
    where type 'a font_class = 'a PangoFontClass.class =
  struct
    val getType_ = _import "pango_glyph_string_get_type" : unit -> GObjectType.FFI.val_;
    val new_ = _import "pango_glyph_string_new" : unit -> PangoGlyphStringRecord.FFI.non_opt PangoGlyphStringRecord.FFI.p;
    val copy_ = _import "pango_glyph_string_copy" : PangoGlyphStringRecord.FFI.non_opt PangoGlyphStringRecord.FFI.p -> PangoGlyphStringRecord.FFI.opt PangoGlyphStringRecord.FFI.p;
    val extents_ =
      fn
        x1
         & x2
         & x3
         & x4 =>
          (
            _import "pango_glyph_string_extents" :
              PangoGlyphStringRecord.FFI.non_opt PangoGlyphStringRecord.FFI.p
               * PangoFontClass.FFI.non_opt PangoFontClass.FFI.p
               * PangoRectangleRecord.FFI.non_opt PangoRectangleRecord.FFI.p
               * PangoRectangleRecord.FFI.non_opt PangoRectangleRecord.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4
            )
    val extentsRange_ =
      fn
        x1
         & x2
         & x3
         & x4
         & x5
         & x6 =>
          (
            _import "pango_glyph_string_extents_range" :
              PangoGlyphStringRecord.FFI.non_opt PangoGlyphStringRecord.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * PangoFontClass.FFI.non_opt PangoFontClass.FFI.p
               * PangoRectangleRecord.FFI.non_opt PangoRectangleRecord.FFI.p
               * PangoRectangleRecord.FFI.non_opt PangoRectangleRecord.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5,
              x6
            )
    val getWidth_ = _import "pango_glyph_string_get_width" : PangoGlyphStringRecord.FFI.non_opt PangoGlyphStringRecord.FFI.p -> GInt.FFI.val_;
    val setSize_ = fn x1 & x2 => (_import "pango_glyph_string_set_size" : PangoGlyphStringRecord.FFI.non_opt PangoGlyphStringRecord.FFI.p * GInt.FFI.val_ -> unit;) (x1, x2)
    val numGlyphs'Offset_ = _import "giraffe_pango_glyph_string_num_glyphs_offset" : unit -> GSize.FFI.val_;
    val glyphs'Offset_ = _import "giraffe_pango_glyph_string_glyphs_offset" : unit -> GSize.FFI.val_;
    type t = PangoGlyphStringRecord.t
    type glyph_info_record_c_array_n_t = PangoGlyphInfoRecordCArrayN.t
    type rectangle_t = PangoRectangleRecord.t
    type 'a font_class = 'a PangoFontClass.class
    structure NumGlyphsField =
      Field(
        structure Container = PangoGlyphStringRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) numGlyphs'Offset_
      )
    structure GlyphsField =
      FieldN(
        structure Container = PangoGlyphStringRecord
        structure FieldType = PointerNFieldType(PangoGlyphInfoRecordCArrayN)
        val offset = (I ---> GSize.FFI.fromVal) glyphs'Offset_
        structure NField = NumGlyphsField
        val toInt = LargeInt.toInt
        val fromInt = LargeInt.fromInt
      )
    val numGlyphs =
      {
        get = fn x => NumGlyphsField.get x,
        set = fn x => NumGlyphsField.set x
      }
    val glyphs =
      {
        get = fn x => GlyphsField.get x,
        set = fn x => GlyphsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new () = (I ---> PangoGlyphStringRecord.FFI.fromPtr true) new_ ()
    fun copy self = (PangoGlyphStringRecord.FFI.withPtr false ---> PangoGlyphStringRecord.FFI.fromOptPtr true) copy_ self
    fun extents self font =
      let
        val inkRect
         & logicalRect
         & () =
          (
            PangoGlyphStringRecord.FFI.withPtr false
             &&&> PangoFontClass.FFI.withPtr false
             &&&> PangoRectangleRecord.FFI.withNewPtr
             &&&> PangoRectangleRecord.FFI.withNewPtr
             ---> PangoRectangleRecord.FFI.fromPtr true
                   && PangoRectangleRecord.FFI.fromPtr true
                   && I
          )
            extents_
            (
              self
               & font
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun extentsRange
      self
      (
        start,
        end',
        font
      ) =
      let
        val inkRect
         & logicalRect
         & () =
          (
            PangoGlyphStringRecord.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> PangoFontClass.FFI.withPtr false
             &&&> PangoRectangleRecord.FFI.withNewPtr
             &&&> PangoRectangleRecord.FFI.withNewPtr
             ---> PangoRectangleRecord.FFI.fromPtr true
                   && PangoRectangleRecord.FFI.fromPtr true
                   && I
          )
            extentsRange_
            (
              self
               & start
               & end'
               & font
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun getWidth self = (PangoGlyphStringRecord.FFI.withPtr false ---> GInt.FFI.fromVal) getWidth_ self
    fun setSize self newLen = (PangoGlyphStringRecord.FFI.withPtr false &&&> GInt.FFI.withVal ---> I) setSize_ (self & newLen)
  end
