structure PangoItem :>
  PANGO_ITEM
    where type t = PangoItemRecord.t =
  struct
    val getType_ = _import "pango_item_get_type" : unit -> GObjectType.FFI.val_;
    val new_ = _import "pango_item_new" : unit -> PangoItemRecord.FFI.non_opt PangoItemRecord.FFI.p;
    val copy_ = _import "pango_item_copy" : PangoItemRecord.FFI.non_opt PangoItemRecord.FFI.p -> PangoItemRecord.FFI.opt PangoItemRecord.FFI.p;
    val split_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "pango_item_split" :
              PangoItemRecord.FFI.non_opt PangoItemRecord.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               -> PangoItemRecord.FFI.non_opt PangoItemRecord.FFI.p;
          )
            (
              x1,
              x2,
              x3
            )
    val offset'Offset_ = _import "giraffe_pango_item_offset_offset" : unit -> GSize.FFI.val_;
    val length'Offset_ = _import "giraffe_pango_item_length_offset" : unit -> GSize.FFI.val_;
    val numChars'Offset_ = _import "giraffe_pango_item_num_chars_offset" : unit -> GSize.FFI.val_;
    type t = PangoItemRecord.t
    structure OffsetField =
      Field(
        structure Container = PangoItemRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) offset'Offset_
      )
    structure LengthField =
      Field(
        structure Container = PangoItemRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) length'Offset_
      )
    structure NumCharsField =
      Field(
        structure Container = PangoItemRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) numChars'Offset_
      )
    val offset =
      {
        get = fn x => OffsetField.get x,
        set = fn x => OffsetField.set x
      }
    val length =
      {
        get = fn x => LengthField.get x,
        set = fn x => LengthField.set x
      }
    val numChars =
      {
        get = fn x => NumCharsField.get x,
        set = fn x => NumCharsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new () = (I ---> PangoItemRecord.FFI.fromPtr true) new_ ()
    fun copy self = (PangoItemRecord.FFI.withPtr false ---> PangoItemRecord.FFI.fromOptPtr true) copy_ self
    fun split self (splitIndex, splitOffset) =
      (
        PangoItemRecord.FFI.withPtr false
         &&&> GInt.FFI.withVal
         &&&> GInt.FFI.withVal
         ---> PangoItemRecord.FFI.fromPtr true
      )
        split_
        (
          self
           & splitIndex
           & splitOffset
        )
  end
