structure PangoLayoutLine :>
  PANGO_LAYOUT_LINE
    where type t = PangoLayoutLineRecord.t
    where type 'a layout_class = 'a PangoLayoutClass.class
    where type rectangle_t = PangoRectangleRecord.t =
  struct
    val getType_ = _import "pango_layout_line_get_type" : unit -> GObjectType.FFI.val_;
    val getExtents_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "pango_layout_line_get_extents" :
              PangoLayoutLineRecord.FFI.non_opt PangoLayoutLineRecord.FFI.p
               * PangoRectangleRecord.FFI.non_opt PangoRectangleRecord.FFI.p
               * PangoRectangleRecord.FFI.non_opt PangoRectangleRecord.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val getPixelExtents_ =
      fn
        x1
         & x2
         & x3 =>
          (
            _import "pango_layout_line_get_pixel_extents" :
              PangoLayoutLineRecord.FFI.non_opt PangoLayoutLineRecord.FFI.p
               * PangoRectangleRecord.FFI.non_opt PangoRectangleRecord.FFI.p
               * PangoRectangleRecord.FFI.non_opt PangoRectangleRecord.FFI.p
               -> unit;
          )
            (
              x1,
              x2,
              x3
            )
    val getXRanges_ =
      fn
        x1
         & x2
         & x3
         & (x4, x5)
         & x6 =>
          (
            _import "mlton_pango_layout_line_get_x_ranges" :
              PangoLayoutLineRecord.FFI.non_opt PangoLayoutLineRecord.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.val_
               * GIntCArrayN.MLton.r1
               * (GIntCArrayN.FFI.opt, GIntCArrayN.FFI.non_opt) GIntCArrayN.MLton.r2
               * GInt.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4,
              x5,
              x6
            )
    val indexToX_ =
      fn
        x1
         & x2
         & x3
         & x4 =>
          (
            _import "pango_layout_line_index_to_x" :
              PangoLayoutLineRecord.FFI.non_opt PangoLayoutLineRecord.FFI.p
               * GInt.FFI.val_
               * GBool.FFI.val_
               * GInt.FFI.ref_
               -> unit;
          )
            (
              x1,
              x2,
              x3,
              x4
            )
    val xToIndex_ =
      fn
        x1
         & x2
         & x3
         & x4 =>
          (
            _import "pango_layout_line_x_to_index" :
              PangoLayoutLineRecord.FFI.non_opt PangoLayoutLineRecord.FFI.p
               * GInt.FFI.val_
               * GInt.FFI.ref_
               * GInt.FFI.ref_
               -> GBool.FFI.val_;
          )
            (
              x1,
              x2,
              x3,
              x4
            )
    val layout'Offset_ = _import "giraffe_pango_layout_line_layout_offset" : unit -> GSize.FFI.val_;
    val startIndex'Offset_ = _import "giraffe_pango_layout_line_start_index_offset" : unit -> GSize.FFI.val_;
    val length'Offset_ = _import "giraffe_pango_layout_line_length_offset" : unit -> GSize.FFI.val_;
    type t = PangoLayoutLineRecord.t
    type 'a layout_class = 'a PangoLayoutClass.class
    type rectangle_t = PangoRectangleRecord.t
    structure LayoutField =
      Field(
        structure Container = PangoLayoutLineRecord
        structure FieldType = OptPointerFieldType(PangoLayoutClass)
        val offset = (I ---> GSize.FFI.fromVal) layout'Offset_
      )
    structure StartIndexField =
      Field(
        structure Container = PangoLayoutLineRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) startIndex'Offset_
      )
    structure LengthField =
      Field(
        structure Container = PangoLayoutLineRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) length'Offset_
      )
    val layout =
      {
        get = fn x => LayoutField.get x,
        set = fn x => LayoutField.set (Option.map PangoLayoutClass.toBase x)
      }
    val startIndex =
      {
        get = fn x => StartIndexField.get x,
        set = fn x => StartIndexField.set x
      }
    val length =
      {
        get = fn x => LengthField.get x,
        set = fn x => LengthField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun getExtents self =
      let
        val inkRect
         & logicalRect
         & () =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> PangoRectangleRecord.FFI.withNewPtr
             &&&> PangoRectangleRecord.FFI.withNewPtr
             ---> PangoRectangleRecord.FFI.fromPtr true
                   && PangoRectangleRecord.FFI.fromPtr true
                   && I
          )
            getExtents_
            (
              self
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun getPixelExtents self =
      let
        val inkRect
         & logicalRect
         & () =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> PangoRectangleRecord.FFI.withNewPtr
             &&&> PangoRectangleRecord.FFI.withNewPtr
             ---> PangoRectangleRecord.FFI.fromPtr true
                   && PangoRectangleRecord.FFI.fromPtr true
                   && I
          )
            getPixelExtents_
            (
              self
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun getXRanges self (startIndex, endIndex) =
      let
        val ranges
         & nRanges
         & () =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GIntCArrayN.FFI.withRefOptPtr 0
             &&&> GInt.FFI.withRefVal
             ---> GIntCArrayN.FFI.fromPtr ~1
                   && GInt.FFI.fromVal
                   && I
          )
            getXRanges_
            (
              self
               & startIndex
               & endIndex
               & NONE
               & GInt.null
            )
      in
        ranges (LargeInt.toInt nRanges)
      end
    fun indexToX self (index, trailing) =
      let
        val xPos & () =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GBool.FFI.withVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal && I
          )
            indexToX_
            (
              self
               & index
               & trailing
               & GInt.null
            )
      in
        xPos
      end
    fun xToIndex self xPos =
      let
        val index
         & trailing
         & retVal =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && GBool.FFI.fromVal
          )
            xToIndex_
            (
              self
               & xPos
               & GInt.null
               & GInt.null
            )
      in
        if retVal then SOME (index, trailing) else NONE
      end
  end
