structure PangoAttribute :>
  PANGO_ATTRIBUTE
    where type t = PangoAttributeRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val equal_ = call (getSymbol "pango_attribute_equal") (PangoAttributeRecord.PolyML.cPtr &&> PangoAttributeRecord.PolyML.cPtr --> GBool.PolyML.cVal)
      val startIndex'Offset_ = call (getSymbol "giraffe_pango_attribute_start_index_offset") (cVoid --> GSize.PolyML.cVal)
      val endIndex'Offset_ = call (getSymbol "giraffe_pango_attribute_end_index_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoAttributeRecord.t
    structure StartIndexField =
      Field(
        structure Container = PangoAttributeRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) startIndex'Offset_
      )
    structure EndIndexField =
      Field(
        structure Container = PangoAttributeRecord
        structure FieldType = ValueFieldType(GUInt)
        val offset = (I ---> GSize.FFI.fromVal) endIndex'Offset_
      )
    val startIndex =
      {
        get = fn x => StartIndexField.get x,
        set = fn x => StartIndexField.set x
      }
    val endIndex =
      {
        get = fn x => EndIndexField.get x,
        set = fn x => EndIndexField.set x
      }
    fun equal self attr2 = (PangoAttributeRecord.FFI.withPtr false &&&> PangoAttributeRecord.FFI.withPtr false ---> GBool.FFI.fromVal) equal_ (self & attr2)
  end
