structure PangoColor :>
  PANGO_COLOR
    where type t = PangoColorRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "pango_color_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val copy_ = call (getSymbol "pango_color_copy") (PangoColorRecord.PolyML.cPtr --> PangoColorRecord.PolyML.cOptPtr)
      val parse_ = call (getSymbol "pango_color_parse") (PangoColorRecord.PolyML.cPtr &&> Utf8.PolyML.cInPtr --> GBool.PolyML.cVal)
      val toString_ = call (getSymbol "pango_color_to_string") (PangoColorRecord.PolyML.cPtr --> Utf8.PolyML.cOutPtr)
      val red'Offset_ = call (getSymbol "giraffe_pango_color_red_offset") (cVoid --> GSize.PolyML.cVal)
      val green'Offset_ = call (getSymbol "giraffe_pango_color_green_offset") (cVoid --> GSize.PolyML.cVal)
      val blue'Offset_ = call (getSymbol "giraffe_pango_color_blue_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoColorRecord.t
    structure RedField =
      Field(
        structure Container = PangoColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) red'Offset_
      )
    structure GreenField =
      Field(
        structure Container = PangoColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) green'Offset_
      )
    structure BlueField =
      Field(
        structure Container = PangoColorRecord
        structure FieldType = ValueFieldType(GUInt16)
        val offset = (I ---> GSize.FFI.fromVal) blue'Offset_
      )
    val red =
      {
        get = fn x => RedField.get x,
        set = fn x => RedField.set x
      }
    val green =
      {
        get = fn x => GreenField.get x,
        set = fn x => GreenField.set x
      }
    val blue =
      {
        get = fn x => BlueField.get x,
        set = fn x => BlueField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun copy self = (PangoColorRecord.FFI.withPtr false ---> PangoColorRecord.FFI.fromOptPtr true) copy_ self
    fun parse self spec = (PangoColorRecord.FFI.withPtr false &&&> Utf8.FFI.withPtr 0 ---> GBool.FFI.fromVal) parse_ (self & spec)
    fun toString self = (PangoColorRecord.FFI.withPtr false ---> Utf8.FFI.fromPtr ~1) toString_ self
  end
