structure PangoGlyphGeometry :>
  PANGO_GLYPH_GEOMETRY
    where type t = PangoGlyphGeometryRecord.t
    where type glyph_unit_t = PangoGlyphUnit.t =
  struct
    local
      open PolyMLFFI
    in
      val width'Offset_ = call (getSymbol "giraffe_pango_glyph_geometry_width_offset") (cVoid --> GSize.PolyML.cVal)
      val xOffset'Offset_ = call (getSymbol "giraffe_pango_glyph_geometry_x_offset_offset") (cVoid --> GSize.PolyML.cVal)
      val yOffset'Offset_ = call (getSymbol "giraffe_pango_glyph_geometry_y_offset_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoGlyphGeometryRecord.t
    type glyph_unit_t = PangoGlyphUnit.t
    structure WidthField =
      Field(
        structure Container = PangoGlyphGeometryRecord
        structure FieldType = ValueFieldType(PangoGlyphUnit)
        val offset = (I ---> GSize.FFI.fromVal) width'Offset_
      )
    structure XOffsetField =
      Field(
        structure Container = PangoGlyphGeometryRecord
        structure FieldType = ValueFieldType(PangoGlyphUnit)
        val offset = (I ---> GSize.FFI.fromVal) xOffset'Offset_
      )
    structure YOffsetField =
      Field(
        structure Container = PangoGlyphGeometryRecord
        structure FieldType = ValueFieldType(PangoGlyphUnit)
        val offset = (I ---> GSize.FFI.fromVal) yOffset'Offset_
      )
    val width =
      {
        get = fn x => WidthField.get x,
        set = fn x => WidthField.set x
      }
    val xOffset =
      {
        get = fn x => XOffsetField.get x,
        set = fn x => XOffsetField.set x
      }
    val yOffset =
      {
        get = fn x => YOffsetField.get x,
        set = fn x => YOffsetField.set x
      }
    fun new
      {
        width,
        xOffset,
        yOffset
      } =
      let
        fun init_ p =
          (
            WidthField.C.set width p;
            XOffsetField.C.set xOffset p;
            YOffsetField.C.set yOffset p;
            ()
          )
        val retVal & () = (PangoGlyphGeometryRecord.FFI.withNewPtr ---> PangoGlyphGeometryRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
  end
