structure PangoGlyphItem :>
  PANGO_GLYPH_ITEM
    where type t = PangoGlyphItemRecord.t
    where type item_t = PangoItemRecord.t
    where type glyph_string_t = PangoGlyphStringRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "pango_glyph_item_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val copy_ = call (getSymbol "pango_glyph_item_copy") (PangoGlyphItemRecord.PolyML.cPtr --> PangoGlyphItemRecord.PolyML.cOptPtr)
      val split_ =
        call (getSymbol "pango_glyph_item_split")
          (
            PangoGlyphItemRecord.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             &&> GInt.PolyML.cVal
             --> PangoGlyphItemRecord.PolyML.cPtr
          )
      val item'Offset_ = call (getSymbol "giraffe_pango_glyph_item_item_offset") (cVoid --> GSize.PolyML.cVal)
      val glyphs'Offset_ = call (getSymbol "giraffe_pango_glyph_item_glyphs_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoGlyphItemRecord.t
    type item_t = PangoItemRecord.t
    type glyph_string_t = PangoGlyphStringRecord.t
    structure ItemField =
      Field(
        structure Container = PangoGlyphItemRecord
        structure FieldType = OptPointerFieldType(PangoItemRecord)
        val offset = (I ---> GSize.FFI.fromVal) item'Offset_
      )
    structure GlyphsField =
      Field(
        structure Container = PangoGlyphItemRecord
        structure FieldType = OptPointerFieldType(PangoGlyphStringRecord)
        val offset = (I ---> GSize.FFI.fromVal) glyphs'Offset_
      )
    val item =
      {
        get = fn x => ItemField.get x,
        set = fn x => ItemField.set x
      }
    val glyphs =
      {
        get = fn x => GlyphsField.get x,
        set = fn x => GlyphsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun copy self = (PangoGlyphItemRecord.FFI.withPtr false ---> PangoGlyphItemRecord.FFI.fromOptPtr true) copy_ self
    fun split self (text, splitIndex) =
      (
        PangoGlyphItemRecord.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         &&&> GInt.FFI.withVal
         ---> PangoGlyphItemRecord.FFI.fromPtr true
      )
        split_
        (
          self
           & text
           & splitIndex
        )
  end
