structure PangoGlyphItemIter :>
  PANGO_GLYPH_ITEM_ITER
    where type t = PangoGlyphItemIterRecord.t
    where type glyph_item_t = PangoGlyphItemRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "pango_glyph_item_iter_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val copy_ = call (getSymbol "pango_glyph_item_iter_copy") (PangoGlyphItemIterRecord.PolyML.cPtr --> PangoGlyphItemIterRecord.PolyML.cOptPtr)
      val initEnd_ =
        call (getSymbol "pango_glyph_item_iter_init_end")
          (
            PangoGlyphItemIterRecord.PolyML.cPtr
             &&> PangoGlyphItemRecord.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             --> GBool.PolyML.cVal
          )
      val initStart_ =
        call (getSymbol "pango_glyph_item_iter_init_start")
          (
            PangoGlyphItemIterRecord.PolyML.cPtr
             &&> PangoGlyphItemRecord.PolyML.cPtr
             &&> Utf8.PolyML.cInPtr
             --> GBool.PolyML.cVal
          )
      val nextCluster_ = call (getSymbol "pango_glyph_item_iter_next_cluster") (PangoGlyphItemIterRecord.PolyML.cPtr --> GBool.PolyML.cVal)
      val prevCluster_ = call (getSymbol "pango_glyph_item_iter_prev_cluster") (PangoGlyphItemIterRecord.PolyML.cPtr --> GBool.PolyML.cVal)
      val glyphItem'Offset_ = call (getSymbol "giraffe_pango_glyph_item_iter_glyph_item_offset") (cVoid --> GSize.PolyML.cVal)
      val text'Offset_ = call (getSymbol "giraffe_pango_glyph_item_iter_text_offset") (cVoid --> GSize.PolyML.cVal)
      val startGlyph'Offset_ = call (getSymbol "giraffe_pango_glyph_item_iter_start_glyph_offset") (cVoid --> GSize.PolyML.cVal)
      val startIndex'Offset_ = call (getSymbol "giraffe_pango_glyph_item_iter_start_index_offset") (cVoid --> GSize.PolyML.cVal)
      val startChar'Offset_ = call (getSymbol "giraffe_pango_glyph_item_iter_start_char_offset") (cVoid --> GSize.PolyML.cVal)
      val endGlyph'Offset_ = call (getSymbol "giraffe_pango_glyph_item_iter_end_glyph_offset") (cVoid --> GSize.PolyML.cVal)
      val endIndex'Offset_ = call (getSymbol "giraffe_pango_glyph_item_iter_end_index_offset") (cVoid --> GSize.PolyML.cVal)
      val endChar'Offset_ = call (getSymbol "giraffe_pango_glyph_item_iter_end_char_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoGlyphItemIterRecord.t
    type glyph_item_t = PangoGlyphItemRecord.t
    structure GlyphItemField =
      Field(
        structure Container = PangoGlyphItemIterRecord
        structure FieldType = OptPointerFieldType(PangoGlyphItemRecord)
        val offset = (I ---> GSize.FFI.fromVal) glyphItem'Offset_
      )
    structure TextField =
      Field(
        structure Container = PangoGlyphItemIterRecord
        structure FieldType = OptPointerFieldType(Utf8)
        val offset = (I ---> GSize.FFI.fromVal) text'Offset_
      )
    structure StartGlyphField =
      Field(
        structure Container = PangoGlyphItemIterRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) startGlyph'Offset_
      )
    structure StartIndexField =
      Field(
        structure Container = PangoGlyphItemIterRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) startIndex'Offset_
      )
    structure StartCharField =
      Field(
        structure Container = PangoGlyphItemIterRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) startChar'Offset_
      )
    structure EndGlyphField =
      Field(
        structure Container = PangoGlyphItemIterRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) endGlyph'Offset_
      )
    structure EndIndexField =
      Field(
        structure Container = PangoGlyphItemIterRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) endIndex'Offset_
      )
    structure EndCharField =
      Field(
        structure Container = PangoGlyphItemIterRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) endChar'Offset_
      )
    val glyphItem =
      {
        get = fn x => GlyphItemField.get x,
        set = fn x => GlyphItemField.set x
      }
    val text =
      {
        get = fn x => TextField.get x,
        set = fn x => TextField.set x
      }
    val startGlyph =
      {
        get = fn x => StartGlyphField.get x,
        set = fn x => StartGlyphField.set x
      }
    val startIndex =
      {
        get = fn x => StartIndexField.get x,
        set = fn x => StartIndexField.set x
      }
    val startChar =
      {
        get = fn x => StartCharField.get x,
        set = fn x => StartCharField.set x
      }
    val endGlyph =
      {
        get = fn x => EndGlyphField.get x,
        set = fn x => EndGlyphField.set x
      }
    val endIndex =
      {
        get = fn x => EndIndexField.get x,
        set = fn x => EndIndexField.set x
      }
    val endChar =
      {
        get = fn x => EndCharField.get x,
        set = fn x => EndCharField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun copy self = (PangoGlyphItemIterRecord.FFI.withPtr false ---> PangoGlyphItemIterRecord.FFI.fromOptPtr true) copy_ self
    fun initEnd self (glyphItem, text) =
      (
        PangoGlyphItemIterRecord.FFI.withPtr false
         &&&> PangoGlyphItemRecord.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         ---> GBool.FFI.fromVal
      )
        initEnd_
        (
          self
           & glyphItem
           & text
        )
    fun initStart self (glyphItem, text) =
      (
        PangoGlyphItemIterRecord.FFI.withPtr false
         &&&> PangoGlyphItemRecord.FFI.withPtr false
         &&&> Utf8.FFI.withPtr 0
         ---> GBool.FFI.fromVal
      )
        initStart_
        (
          self
           & glyphItem
           & text
        )
    fun nextCluster self = (PangoGlyphItemIterRecord.FFI.withPtr false ---> GBool.FFI.fromVal) nextCluster_ self
    fun prevCluster self = (PangoGlyphItemIterRecord.FFI.withPtr false ---> GBool.FFI.fromVal) prevCluster_ self
  end
