structure PangoGlyphString :>
  PANGO_GLYPH_STRING
    where type t = PangoGlyphStringRecord.t
    where type glyph_info_record_c_array_n_t = PangoGlyphInfoRecordCArrayN.t
    where type rectangle_t = PangoRectangleRecord.t
    where type 'a font_class = 'a PangoFontClass.class =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "pango_glyph_string_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val new_ = call (getSymbol "pango_glyph_string_new") (cVoid --> PangoGlyphStringRecord.PolyML.cPtr)
      val copy_ = call (getSymbol "pango_glyph_string_copy") (PangoGlyphStringRecord.PolyML.cPtr --> PangoGlyphStringRecord.PolyML.cOptPtr)
      val extents_ =
        call (getSymbol "pango_glyph_string_extents")
          (
            PangoGlyphStringRecord.PolyML.cPtr
             &&> PangoFontClass.PolyML.cPtr
             &&> PangoRectangleRecord.PolyML.cPtr
             &&> PangoRectangleRecord.PolyML.cPtr
             --> cVoid
          )
      val extentsRange_ =
        call (getSymbol "pango_glyph_string_extents_range")
          (
            PangoGlyphStringRecord.PolyML.cPtr
             &&> GInt.PolyML.cVal
             &&> GInt.PolyML.cVal
             &&> PangoFontClass.PolyML.cPtr
             &&> PangoRectangleRecord.PolyML.cPtr
             &&> PangoRectangleRecord.PolyML.cPtr
             --> cVoid
          )
      val getWidth_ = call (getSymbol "pango_glyph_string_get_width") (PangoGlyphStringRecord.PolyML.cPtr --> GInt.PolyML.cVal)
      val setSize_ = call (getSymbol "pango_glyph_string_set_size") (PangoGlyphStringRecord.PolyML.cPtr &&> GInt.PolyML.cVal --> cVoid)
      val numGlyphs'Offset_ = call (getSymbol "giraffe_pango_glyph_string_num_glyphs_offset") (cVoid --> GSize.PolyML.cVal)
      val glyphs'Offset_ = call (getSymbol "giraffe_pango_glyph_string_glyphs_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoGlyphStringRecord.t
    type glyph_info_record_c_array_n_t = PangoGlyphInfoRecordCArrayN.t
    type rectangle_t = PangoRectangleRecord.t
    type 'a font_class = 'a PangoFontClass.class
    structure NumGlyphsField =
      Field(
        structure Container = PangoGlyphStringRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) numGlyphs'Offset_
      )
    structure GlyphsField =
      FieldN(
        structure Container = PangoGlyphStringRecord
        structure FieldType = PointerNFieldType(PangoGlyphInfoRecordCArrayN)
        val offset = (I ---> GSize.FFI.fromVal) glyphs'Offset_
        structure NField = NumGlyphsField
        val toInt = LargeInt.toInt
        val fromInt = LargeInt.fromInt
      )
    val numGlyphs =
      {
        get = fn x => NumGlyphsField.get x,
        set = fn x => NumGlyphsField.set x
      }
    val glyphs =
      {
        get = fn x => GlyphsField.get x,
        set = fn x => GlyphsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new () = (I ---> PangoGlyphStringRecord.FFI.fromPtr true) new_ ()
    fun copy self = (PangoGlyphStringRecord.FFI.withPtr false ---> PangoGlyphStringRecord.FFI.fromOptPtr true) copy_ self
    fun extents self font =
      let
        val inkRect
         & logicalRect
         & () =
          (
            PangoGlyphStringRecord.FFI.withPtr false
             &&&> PangoFontClass.FFI.withPtr false
             &&&> PangoRectangleRecord.FFI.withNewPtr
             &&&> PangoRectangleRecord.FFI.withNewPtr
             ---> PangoRectangleRecord.FFI.fromPtr true
                   && PangoRectangleRecord.FFI.fromPtr true
                   && I
          )
            extents_
            (
              self
               & font
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun extentsRange
      self
      (
        start,
        end',
        font
      ) =
      let
        val inkRect
         & logicalRect
         & () =
          (
            PangoGlyphStringRecord.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> PangoFontClass.FFI.withPtr false
             &&&> PangoRectangleRecord.FFI.withNewPtr
             &&&> PangoRectangleRecord.FFI.withNewPtr
             ---> PangoRectangleRecord.FFI.fromPtr true
                   && PangoRectangleRecord.FFI.fromPtr true
                   && I
          )
            extentsRange_
            (
              self
               & start
               & end'
               & font
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun getWidth self = (PangoGlyphStringRecord.FFI.withPtr false ---> GInt.FFI.fromVal) getWidth_ self
    fun setSize self newLen = (PangoGlyphStringRecord.FFI.withPtr false &&&> GInt.FFI.withVal ---> I) setSize_ (self & newLen)
  end
