structure PangoItem :>
  PANGO_ITEM
    where type t = PangoItemRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "pango_item_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val new_ = call (getSymbol "pango_item_new") (cVoid --> PangoItemRecord.PolyML.cPtr)
      val copy_ = call (getSymbol "pango_item_copy") (PangoItemRecord.PolyML.cPtr --> PangoItemRecord.PolyML.cOptPtr)
      val split_ =
        call (getSymbol "pango_item_split")
          (
            PangoItemRecord.PolyML.cPtr
             &&> GInt.PolyML.cVal
             &&> GInt.PolyML.cVal
             --> PangoItemRecord.PolyML.cPtr
          )
      val offset'Offset_ = call (getSymbol "giraffe_pango_item_offset_offset") (cVoid --> GSize.PolyML.cVal)
      val length'Offset_ = call (getSymbol "giraffe_pango_item_length_offset") (cVoid --> GSize.PolyML.cVal)
      val numChars'Offset_ = call (getSymbol "giraffe_pango_item_num_chars_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoItemRecord.t
    structure OffsetField =
      Field(
        structure Container = PangoItemRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) offset'Offset_
      )
    structure LengthField =
      Field(
        structure Container = PangoItemRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) length'Offset_
      )
    structure NumCharsField =
      Field(
        structure Container = PangoItemRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) numChars'Offset_
      )
    val offset =
      {
        get = fn x => OffsetField.get x,
        set = fn x => OffsetField.set x
      }
    val length =
      {
        get = fn x => LengthField.get x,
        set = fn x => LengthField.set x
      }
    val numChars =
      {
        get = fn x => NumCharsField.get x,
        set = fn x => NumCharsField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun new () = (I ---> PangoItemRecord.FFI.fromPtr true) new_ ()
    fun copy self = (PangoItemRecord.FFI.withPtr false ---> PangoItemRecord.FFI.fromOptPtr true) copy_ self
    fun split self (splitIndex, splitOffset) =
      (
        PangoItemRecord.FFI.withPtr false
         &&&> GInt.FFI.withVal
         &&&> GInt.FFI.withVal
         ---> PangoItemRecord.FFI.fromPtr true
      )
        split_
        (
          self
           & splitIndex
           & splitOffset
        )
  end
