structure PangoLayoutLine :>
  PANGO_LAYOUT_LINE
    where type t = PangoLayoutLineRecord.t
    where type 'a layout_class = 'a PangoLayoutClass.class
    where type rectangle_t = PangoRectangleRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "pango_layout_line_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val getExtents_ =
        call (getSymbol "pango_layout_line_get_extents")
          (
            PangoLayoutLineRecord.PolyML.cPtr
             &&> PangoRectangleRecord.PolyML.cPtr
             &&> PangoRectangleRecord.PolyML.cPtr
             --> cVoid
          )
      val getPixelExtents_ =
        call (getSymbol "pango_layout_line_get_pixel_extents")
          (
            PangoLayoutLineRecord.PolyML.cPtr
             &&> PangoRectangleRecord.PolyML.cPtr
             &&> PangoRectangleRecord.PolyML.cPtr
             --> cVoid
          )
      val getXRanges_ =
        call (getSymbol "pango_layout_line_get_x_ranges")
          (
            PangoLayoutLineRecord.PolyML.cPtr
             &&> GInt.PolyML.cVal
             &&> GInt.PolyML.cVal
             &&> GIntCArrayN.PolyML.cOutRef
             &&> GInt.PolyML.cRef
             --> cVoid
          )
      val indexToX_ =
        call (getSymbol "pango_layout_line_index_to_x")
          (
            PangoLayoutLineRecord.PolyML.cPtr
             &&> GInt.PolyML.cVal
             &&> GBool.PolyML.cVal
             &&> GInt.PolyML.cRef
             --> cVoid
          )
      val xToIndex_ =
        call (getSymbol "pango_layout_line_x_to_index")
          (
            PangoLayoutLineRecord.PolyML.cPtr
             &&> GInt.PolyML.cVal
             &&> GInt.PolyML.cRef
             &&> GInt.PolyML.cRef
             --> GBool.PolyML.cVal
          )
      val layout'Offset_ = call (getSymbol "giraffe_pango_layout_line_layout_offset") (cVoid --> GSize.PolyML.cVal)
      val startIndex'Offset_ = call (getSymbol "giraffe_pango_layout_line_start_index_offset") (cVoid --> GSize.PolyML.cVal)
      val length'Offset_ = call (getSymbol "giraffe_pango_layout_line_length_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoLayoutLineRecord.t
    type 'a layout_class = 'a PangoLayoutClass.class
    type rectangle_t = PangoRectangleRecord.t
    structure LayoutField =
      Field(
        structure Container = PangoLayoutLineRecord
        structure FieldType = OptPointerFieldType(PangoLayoutClass)
        val offset = (I ---> GSize.FFI.fromVal) layout'Offset_
      )
    structure StartIndexField =
      Field(
        structure Container = PangoLayoutLineRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) startIndex'Offset_
      )
    structure LengthField =
      Field(
        structure Container = PangoLayoutLineRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) length'Offset_
      )
    val layout =
      {
        get = fn x => LayoutField.get x,
        set = fn x => LayoutField.set (Option.map PangoLayoutClass.toBase x)
      }
    val startIndex =
      {
        get = fn x => StartIndexField.get x,
        set = fn x => StartIndexField.set x
      }
    val length =
      {
        get = fn x => LengthField.get x,
        set = fn x => LengthField.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun getExtents self =
      let
        val inkRect
         & logicalRect
         & () =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> PangoRectangleRecord.FFI.withNewPtr
             &&&> PangoRectangleRecord.FFI.withNewPtr
             ---> PangoRectangleRecord.FFI.fromPtr true
                   && PangoRectangleRecord.FFI.fromPtr true
                   && I
          )
            getExtents_
            (
              self
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun getPixelExtents self =
      let
        val inkRect
         & logicalRect
         & () =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> PangoRectangleRecord.FFI.withNewPtr
             &&&> PangoRectangleRecord.FFI.withNewPtr
             ---> PangoRectangleRecord.FFI.fromPtr true
                   && PangoRectangleRecord.FFI.fromPtr true
                   && I
          )
            getPixelExtents_
            (
              self
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun getXRanges self (startIndex, endIndex) =
      let
        val ranges
         & nRanges
         & () =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withVal
             &&&> GIntCArrayN.FFI.withRefOptPtr 0
             &&&> GInt.FFI.withRefVal
             ---> GIntCArrayN.FFI.fromPtr ~1
                   && GInt.FFI.fromVal
                   && I
          )
            getXRanges_
            (
              self
               & startIndex
               & endIndex
               & NONE
               & GInt.null
            )
      in
        ranges (LargeInt.toInt nRanges)
      end
    fun indexToX self (index, trailing) =
      let
        val xPos & () =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GBool.FFI.withVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal && I
          )
            indexToX_
            (
              self
               & index
               & trailing
               & GInt.null
            )
      in
        xPos
      end
    fun xToIndex self xPos =
      let
        val index
         & trailing
         & retVal =
          (
            PangoLayoutLineRecord.FFI.withPtr false
             &&&> GInt.FFI.withVal
             &&&> GInt.FFI.withRefVal
             &&&> GInt.FFI.withRefVal
             ---> GInt.FFI.fromVal
                   && GInt.FFI.fromVal
                   && GBool.FFI.fromVal
          )
            xToIndex_
            (
              self
               & xPos
               & GInt.null
               & GInt.null
            )
      in
        if retVal then SOME (index, trailing) else NONE
      end
  end
