structure PangoMatrix :>
  PANGO_MATRIX
    where type t = PangoMatrixRecord.t
    where type rectangle_t = PangoRectangleRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (getSymbol "pango_matrix_get_type") (cVoid --> GObjectType.PolyML.cVal)
      val concat_ = call (getSymbol "pango_matrix_concat") (PangoMatrixRecord.PolyML.cPtr &&> PangoMatrixRecord.PolyML.cPtr --> cVoid)
      val copy_ = call (getSymbol "pango_matrix_copy") (PangoMatrixRecord.PolyML.cPtr --> PangoMatrixRecord.PolyML.cOptPtr)
      val getFontScaleFactor_ = call (getSymbol "pango_matrix_get_font_scale_factor") (PangoMatrixRecord.PolyML.cPtr --> GDouble.PolyML.cVal)
      val getFontScaleFactors_ =
        call (getSymbol "pango_matrix_get_font_scale_factors")
          (
            PangoMatrixRecord.PolyML.cPtr
             &&> GDouble.PolyML.cRef
             &&> GDouble.PolyML.cRef
             --> cVoid
          )
      val rotate_ = call (getSymbol "pango_matrix_rotate") (PangoMatrixRecord.PolyML.cPtr &&> GDouble.PolyML.cVal --> cVoid)
      val scale_ =
        call (getSymbol "pango_matrix_scale")
          (
            PangoMatrixRecord.PolyML.cPtr
             &&> GDouble.PolyML.cVal
             &&> GDouble.PolyML.cVal
             --> cVoid
          )
      val transformDistance_ =
        call (getSymbol "pango_matrix_transform_distance")
          (
            PangoMatrixRecord.PolyML.cPtr
             &&> GDouble.PolyML.cRef
             &&> GDouble.PolyML.cRef
             --> cVoid
          )
      val transformPixelRectangle_ = call (getSymbol "pango_matrix_transform_pixel_rectangle") (PangoMatrixRecord.PolyML.cPtr &&> PangoRectangleRecord.PolyML.cPtr --> cVoid)
      val transformPoint_ =
        call (getSymbol "pango_matrix_transform_point")
          (
            PangoMatrixRecord.PolyML.cPtr
             &&> GDouble.PolyML.cRef
             &&> GDouble.PolyML.cRef
             --> cVoid
          )
      val transformRectangle_ = call (getSymbol "pango_matrix_transform_rectangle") (PangoMatrixRecord.PolyML.cPtr &&> PangoRectangleRecord.PolyML.cPtr --> cVoid)
      val translate_ =
        call (getSymbol "pango_matrix_translate")
          (
            PangoMatrixRecord.PolyML.cPtr
             &&> GDouble.PolyML.cVal
             &&> GDouble.PolyML.cVal
             --> cVoid
          )
      val xx'Offset_ = call (getSymbol "giraffe_pango_matrix_xx_offset") (cVoid --> GSize.PolyML.cVal)
      val xy'Offset_ = call (getSymbol "giraffe_pango_matrix_xy_offset") (cVoid --> GSize.PolyML.cVal)
      val yx'Offset_ = call (getSymbol "giraffe_pango_matrix_yx_offset") (cVoid --> GSize.PolyML.cVal)
      val yy'Offset_ = call (getSymbol "giraffe_pango_matrix_yy_offset") (cVoid --> GSize.PolyML.cVal)
      val x0'Offset_ = call (getSymbol "giraffe_pango_matrix_x0_offset") (cVoid --> GSize.PolyML.cVal)
      val y0'Offset_ = call (getSymbol "giraffe_pango_matrix_y0_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoMatrixRecord.t
    type rectangle_t = PangoRectangleRecord.t
    structure XxField =
      Field(
        structure Container = PangoMatrixRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) xx'Offset_
      )
    structure XyField =
      Field(
        structure Container = PangoMatrixRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) xy'Offset_
      )
    structure YxField =
      Field(
        structure Container = PangoMatrixRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) yx'Offset_
      )
    structure YyField =
      Field(
        structure Container = PangoMatrixRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) yy'Offset_
      )
    structure X0Field =
      Field(
        structure Container = PangoMatrixRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) x0'Offset_
      )
    structure Y0Field =
      Field(
        structure Container = PangoMatrixRecord
        structure FieldType = ValueFieldType(GDouble)
        val offset = (I ---> GSize.FFI.fromVal) y0'Offset_
      )
    val xx =
      {
        get = fn x => XxField.get x,
        set = fn x => XxField.set x
      }
    val xy =
      {
        get = fn x => XyField.get x,
        set = fn x => XyField.set x
      }
    val yx =
      {
        get = fn x => YxField.get x,
        set = fn x => YxField.set x
      }
    val yy =
      {
        get = fn x => YyField.get x,
        set = fn x => YyField.set x
      }
    val x0 =
      {
        get = fn x => X0Field.get x,
        set = fn x => X0Field.set x
      }
    val y0 =
      {
        get = fn x => Y0Field.get x,
        set = fn x => Y0Field.set x
      }
    val getType = (I ---> GObjectType.FFI.fromVal) getType_
    fun concat self newMatrix = (PangoMatrixRecord.FFI.withPtr false &&&> PangoMatrixRecord.FFI.withPtr false ---> I) concat_ (self & newMatrix)
    fun copy self = (PangoMatrixRecord.FFI.withPtr false ---> PangoMatrixRecord.FFI.fromOptPtr true) copy_ self
    fun getFontScaleFactor self = (PangoMatrixRecord.FFI.withPtr false ---> GDouble.FFI.fromVal) getFontScaleFactor_ self
    fun getFontScaleFactors self =
      let
        val xscale
         & yscale
         & () =
          (
            PangoMatrixRecord.FFI.withPtr false
             &&&> GDouble.FFI.withRefVal
             &&&> GDouble.FFI.withRefVal
             ---> GDouble.FFI.fromVal
                   && GDouble.FFI.fromVal
                   && I
          )
            getFontScaleFactors_
            (
              self
               & GDouble.null
               & GDouble.null
            )
      in
        (xscale, yscale)
      end
    fun rotate self degrees = (PangoMatrixRecord.FFI.withPtr false &&&> GDouble.FFI.withVal ---> I) rotate_ (self & degrees)
    fun scale self (scaleX, scaleY) =
      (
        PangoMatrixRecord.FFI.withPtr false
         &&&> GDouble.FFI.withVal
         &&&> GDouble.FFI.withVal
         ---> I
      )
        scale_
        (
          self
           & scaleX
           & scaleY
        )
    fun transformDistance self (dx, dy) =
      let
        val dx
         & dy
         & () =
          (
            PangoMatrixRecord.FFI.withPtr false
             &&&> GDouble.FFI.withRefVal
             &&&> GDouble.FFI.withRefVal
             ---> GDouble.FFI.fromVal
                   && GDouble.FFI.fromVal
                   && I
          )
            transformDistance_
            (
              self
               & dx
               & dy
            )
      in
        (dx, dy)
      end
    fun transformPixelRectangle self rect =
      let
        val rect & () = (PangoMatrixRecord.FFI.withPtr false &&&> PangoRectangleRecord.FFI.withDupPtr true ---> PangoRectangleRecord.FFI.fromPtr true && I) transformPixelRectangle_ (self & rect)
      in
        rect
      end
    fun transformPoint self (x, y) =
      let
        val x
         & y
         & () =
          (
            PangoMatrixRecord.FFI.withPtr false
             &&&> GDouble.FFI.withRefVal
             &&&> GDouble.FFI.withRefVal
             ---> GDouble.FFI.fromVal
                   && GDouble.FFI.fromVal
                   && I
          )
            transformPoint_
            (
              self
               & x
               & y
            )
      in
        (x, y)
      end
    fun transformRectangle self rect =
      let
        val rect & () = (PangoMatrixRecord.FFI.withPtr false &&&> PangoRectangleRecord.FFI.withDupPtr true ---> PangoRectangleRecord.FFI.fromPtr true && I) transformRectangle_ (self & rect)
      in
        rect
      end
    fun translate self (tx, ty) =
      (
        PangoMatrixRecord.FFI.withPtr false
         &&&> GDouble.FFI.withVal
         &&&> GDouble.FFI.withVal
         ---> I
      )
        translate_
        (
          self
           & tx
           & ty
        )
  end
