structure PangoRectangle :>
  PANGO_RECTANGLE
    where type t = PangoRectangleRecord.t =
  struct
    local
      open PolyMLFFI
    in
      val x'Offset_ = call (getSymbol "giraffe_pango_rectangle_x_offset") (cVoid --> GSize.PolyML.cVal)
      val y'Offset_ = call (getSymbol "giraffe_pango_rectangle_y_offset") (cVoid --> GSize.PolyML.cVal)
      val width'Offset_ = call (getSymbol "giraffe_pango_rectangle_width_offset") (cVoid --> GSize.PolyML.cVal)
      val height'Offset_ = call (getSymbol "giraffe_pango_rectangle_height_offset") (cVoid --> GSize.PolyML.cVal)
    end
    type t = PangoRectangleRecord.t
    structure XField =
      Field(
        structure Container = PangoRectangleRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) x'Offset_
      )
    structure YField =
      Field(
        structure Container = PangoRectangleRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) y'Offset_
      )
    structure WidthField =
      Field(
        structure Container = PangoRectangleRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) width'Offset_
      )
    structure HeightField =
      Field(
        structure Container = PangoRectangleRecord
        structure FieldType = ValueFieldType(GInt)
        val offset = (I ---> GSize.FFI.fromVal) height'Offset_
      )
    val x =
      {
        get = fn x => XField.get x,
        set = fn x => XField.set x
      }
    val y =
      {
        get = fn x => YField.get x,
        set = fn x => YField.set x
      }
    val width =
      {
        get = fn x => WidthField.get x,
        set = fn x => WidthField.set x
      }
    val height =
      {
        get = fn x => HeightField.get x,
        set = fn x => HeightField.set x
      }
    fun new
      {
        x,
        y,
        width,
        height
      } =
      let
        fun init_ p =
          (
            XField.C.set x p;
            YField.C.set y p;
            WidthField.C.set width p;
            HeightField.C.set height p;
            ()
          )
        val retVal & () = (PangoRectangleRecord.FFI.withNewPtr ---> PangoRectangleRecord.FFI.fromPtr true && I) init_ ()
      in
        retVal
      end
  end
